SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Requests'!
SystemOrganization addCategory: #'SqueakSVN-Requests-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestBase'!
SystemOrganization addCategory: #'SqueakSVN-TestBase-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestCategory'!
SystemOrganization addCategory: #'SqueakSVN-OBSystemBrowser'!
SystemOrganization addCategory: #'SqueakSVN-UITests'!
SystemOrganization addCategory: #'SqueakSVN-Tools'!
SystemOrganization addCategory: #'SqueakSVN-Tools-Nodes'!
SystemOrganization addCategory: #'SqueakSVN-Commands'!
SystemOrganization addCategory: #'SqueakSVN-Commands-Test'!
SystemOrganization addCategory: #'SqueakSVN-Environment'!
SystemOrganization addCategory: #'SqueakSVN-Environment-Test'!

OBCmdMultiView subclass: #OBSVNCmdMultiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNCmdMultiView methodsFor: 'execution' stamp: 'cop 4/7/2008 16:09'!
execute
	|viewType labels |
	labels := #(Source Bytecode Decompile PrettyPrint).
	(target isKindOf: OBMethodNode) ifTrue:
		[labels := labels, #(#Blame).].
	viewType := OBChoiceRequest labels: labels.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 4/7/2008 17:36'!
setBlameArrayInDefinitionPanelForBlame: anArray

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBSVNBlameDefinition new setBlameArray: anArray;
							 yourself)]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 4/7/2008 18:44'!
toggleBlame
	| method aSVNMethod |
	method := target theClass lookupSelector: target selector.
	method ifNil: [^ nil ].
	SVNProject allInstances isEmpty ifTrue: [^nil].
	aSVNMethod := (SVNProject allInstances last allVersionedMethods like: (SVNMethod forExistingMethod: method)).
	aSVNMethod ifNil: [^nil].
	self setBlameArrayInDefinitionPanelForBlame: (SVNBlameStyler createArrayFromBlameLines: aSVNMethod blame).! !

Morph subclass: #SVNObservingMorph
	instanceVariableNames: 'process ppro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNObservingMorph methodsFor: 'menus' stamp: 'rkrk 3/16/2008 06:57'!
changeColor

	| mgr ratio |
	mgr := SVNTestDirectoryManager getInstance.
	(mgr basicTestDirectories size = 0 or: [mgr svnAwareTestDirectories size = 0])
		ifTrue: [^ Color blue].
	ratio := mgr numberOfCleanBasicTestDirectories < mgr numberOfCleanSvnAwareTestDirectories
		ifTrue: [mgr numberOfCleanBasicTestDirectories / mgr basicTestDirectories size]
		ifFalse: [mgr numberOfCleanSvnAwareTestDirectories / mgr svnAwareTestDirectories size].
	self color: (Color r: 1 - ratio g: ratio b: 0).! !

!SVNObservingMorph methodsFor: 'as yet unclassified' stamp: 'rkrk 3/16/2008 03:47'!
correctPosition

	self position: self world position x @ (self world height - self height).! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:01'!
handlesMouseDown: evt

	^ true! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:02'!
mouseDown: evt

	SVNTestDirectoryManager reCreate! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rt 3/20/2008 16:07'!
start

	process := [
		[self
			correctPosition;
			changeColor.
		(Delay forSeconds: 5) wait] repeat
	] forkAt: Processor userBackgroundPriority.! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rkrk 3/16/2008 04:03'!
stop

	process terminate.! !

OBReadOnlyDefinition subclass: #OBSVNBlameDefinition
	instanceVariableNames: 'blame blameArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 3/6/2008 13:28'!
blame
	^blame! !

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:24'!
blameArray
	^blameArray! !

!OBSVNBlameDefinition methodsFor: 'initialize-release' stamp: 'cop 3/6/2008 12:58'!
initialize
	super initialize.
	blame := false.! !

!OBSVNBlameDefinition methodsFor: 'callbacks' stamp: 'cop 4/3/2008 13:23'!
setBlameArray: anArray
	blameArray := anArray.
	blame := true.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:24'!
belongsToCurrentSvnProject

	^ false! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
commentsOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 11:54'!
currentSvnProject

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment currentProject.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:22'!
hasSvnElementOfKind: aClass

	^ self svnElement notNil and: [self svnElement isKindOf: aClass]! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:53'!
metaclassesOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 03:58'!
svnElement

	^ nil! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 03:42'!
svnEnvironment

	"Ugly solution. Somehow nodes have to know their svnEnvironment.
	In the momenr there is a filter added to all OBMetaNodes which are build in
	a OBSVNSystemBrowser."
	| environmentFilter |
	environmentFilter := self metaNode filters
		detect: [:ea | ea isKindOf: SVNOBEnvironmentFilter]
		ifNone: [^ nil].
	^ environmentFilter svnEnvironment.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
usedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:58'!
svnFilters

	^ filters! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:54'!
svnWithAllChildrenDo: aBlock

	"Copied from OBRefactory"
	self svnWithAllChildrenDo: aBlock seen: IdentitySet new! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:56'!
svnWithAllChildrenDo: aBlock seen: aSet

	"Copied from OBRefactory"
	(aSet includes: self) ifTrue: [ ^ self ].
	aSet add: self.
	aBlock value: self.
	self edges do: [ :each | each metaNode svnWithAllChildrenDo: aBlock seen: aSet ]! !

!String methodsFor: '*SqueakSVN' stamp: 'rkrk 3/26/2008 15:48'!
forSvnPrimitive

	^ {(self , (Character value: 0) asString) convertToSystemString} asOrderedCollection.! !

!String methodsFor: '*SqueakSVN' stamp: 'rt 4/25/2008 15:11'!
forSvnPrimitiveAsString

	^ self forSvnPrimitive first! !

!String methodsFor: '*SqueakSVN' stamp: 'test 3/26/2008 00:07'!
pathForSvn

	| modifiedPath returnPath |
	self flag: #TODO.
	modifiedPath := self collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^ (returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

OBMetagraphBuilder subclass: #OBSVNMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:21'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBSVNStatusIconClassFilter new! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 4/12/2008 22:01'!
populateMetaclassNode

     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBSVNStatusIconClassFilter new.! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:19'!
populateMethodNode

	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:; "What's that? 'Needed??"
		addFilter: OBSVNStatusIconMethodFilter new! !

!Class methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 05:38'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnClassFor: self) notNil! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 17:21'!
panelArea: aDefinitionPanel with: aBlock 
	| morph definitionMorph textMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	definitionMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;	
		minWidth: 300;	
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     

	textMorph := aDefinitionPanel createContentMorph.		
     aDefinitionPanel setContentMorph: textMorph.		
	definitionMorph addMorphBack: textMorph.	
	morph addMorphBack: definitionMorph.
			
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
     ^definitionMorph! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'rkrk 4/7/2008 22:33'!
svnPane: aColumn with: aBlock 
	| pane divider |
	pane := OBPane new.
	pane
		model: aColumn;
		height: Preferences standardCodeFont height * 3.2;
		vResizing: #rigid;
		hResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self listMorphForColumn: aColumn).
	"current ifNotNil: [current pushPane: pane]."
"	self halt."
	current ifNotNil: 
		[current addMorphBack: pane.
			self current: pane do: aBlock.
			divider := (BorderedSubpaneDividerMorph horizontal)
				color: aColumn browser defaultBackgroundColor duller;
				styleWith: OBMorphBuilder new.
			current addMorphBack: divider].
	^ pane! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: 'sut hasTouchedFileSystem hasModifiedSVNDummy directoryManager slash svnRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestCase subclass: #SVNAuthenticationRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNAuthenticationRequestTest methodsFor: 'running' stamp: 'rt 4/24/2008 12:16'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.

	"remember the auth values ?"
	
	"set username and password to test values"
	(SVNAuthenticationRequest onUsername: 'AuthTestUser' andPassword: 'AuthTestKey') execute.! !

!SVNAuthenticationRequestTest methodsFor: 'running' stamp: 'rt 4/21/2008 18:52'!
tearDown

	"try to reset"
	(SVNAuthenticationRequest onUsername: 'DEFAULTUSER' andPassword: 'PASSWORD') execute.
	

	super tearDown! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rt 4/24/2008 12:10'!
testSetUsersValuesInNewInstance

	| name key |
	name := 'Name'.
	key := 'Key'.
	
	sut := SVNAuthenticationRequest onUsername: name andPassword: key.
	self assert: sut username = name.
	self assert: sut password = key.! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rt 4/24/2008 12:09'!
testSetUsersValuesInOldInstance

	| name key |
	sut := SVNAuthenticationRequest onUsername: 'Name' andPassword: 'Key'.
	
	name := 'NewName'.
	key := 'NewKey'.
	
	sut onUsername: name andPassword: key.
	self assert: sut username = name.
	self assert: sut password = key.! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rt 4/24/2008 12:18'!
testUseUsersInput

	| project log |
	sut := 'UseUsersInputTestUser'.
	(SVNAuthenticationRequest onUsername: sut andPassword: 'UseUsersInputTestKey') execute.
	
	project := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	log := ( (SVNCommitLogsRequest target: project projectDirectory basePath)
		execute;
		commitLogs ) last.
	self assert: log author = sut! !

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClassTest subclass: #PoolDictionariesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
nameOfPoolDictionary
	^ 'TestStoringAndRestoringOfPoolDictionariesClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:17'!
nameOfTestClass
	^ 'PoolDictionariesTestClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
setUp
	
	super setUp.
	
	self willTouchFileSystem.
	self willNeedRepositoryAndWorkingCopy.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	Smalltalk at: (self nameOfPoolDictionary asSymbol) put: (Dictionary new).
	
	Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: self nameOfPoolDictionary
		category: self class category asString.! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/17/2008 15:12'!
tearDown

	super tearDown.
	
	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 00:56'!
testStoringAndRestoringOfPoolDictionaries

	| svnProject |
	svnProject := SVNProject checkoutProject: 'TestPro' fromURL: self repositoryURLPath inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	svnProject addClass: (Smalltalk classNamed: self nameOfTestClass).
	svnProject commit.

	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	self deny: (Smalltalk classNamed: self nameOfTestClass) notNil.
	
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	
	"restore"
	OSProcess waitForCommand: 'svn revert -R ', svnProject directory path.
	svnProject restoreAndLoad.
	
	"check"
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) notNil.
	self assert: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	self assert: (Smalltalk at: self nameOfTestClass asSymbol) poolDictionaryNames = (OrderedCollection with: self nameOfPoolDictionary asSymbol).! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rkrk 4/1/2008 18:14'!
assertDirectoryEntriesEstablishedIn: svnClass

	| rootDir |
	self flag: #TODO. "Mapping details"
	rootDir := svnClass directory.
	rootDir theName = svnClass theName.
	
	self assert: (rootDir directoryExists: 'class').
	self assert: (rootDir directoryExists: 'instance').
	"class details"
	self assert: (rootDir fileExists: 'category').
	self assert: (rootDir fileExists: 'classInstanceVariables').
	self assert: (rootDir fileExists: 'classVariables').
	self assert: (rootDir fileExists: 'comment').
	self assert: (rootDir fileExists: 'instanceVariables').
	self assert: (rootDir fileExists: 'poolDictionaries').
	self assert: (rootDir fileExists: 'superclass').! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rt 3/10/2008 13:18'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	| instanceMethodSelectors expectedMethodSelectors classMethodSelectors expectedclassMethodSelectors |
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.
	self flag: #TODO.
	"Implementation details about the file mapping
	are spread here"
	instanceMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass not])
				collect: [:each | each theName].
	expectedMethodSelectors := aClass methodDict
				collect: [:each | each selector asString].
	self assert: instanceMethodSelectors asSet = expectedMethodSelectors asSet.
	classMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass])
				collect: [:each | each theName].
	expectedclassMethodSelectors := aClass class methodDict
				collect: [:each | each selector asString].
	self assert: classMethodSelectors asSet = expectedclassMethodSelectors asSet! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 00:35'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	self assert: (Smalltalk hasClassNamed: aString) not.
	svnClass
		theName: aString asString;
		superclassName: 'Object';
		instanceVariables: #('a');
		classVariables: #('A');
		classInstanceVariables: #('b');
		poolDictionaries: #();
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'helper' stamp: 'mu 4/23/2008 14:10'!
methodSelector
	^ #m2! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:48'!
testAddMethod

	"Setup"
	| className svnMethod1 svnMethod2 |
	sut := SVNClass new.
	className := 'PleaseDoNotExist'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	sut establishSvnFilesAndDirectories.
	svnMethod1 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className;
		establishSvnFilesAndDirectories;
		yourself.
	svnMethod2 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className , ' class';
		establishSvnFilesAndDirectories;
		yourself.
	"Execution"
	sut
		addMethod: svnMethod1;
		addMethod: svnMethod2.
	"Assertion"
	self assert: (sut versionedMethods includes: svnMethod1).
	self assert: (sut versionedMethods includes: svnMethod2).
	self assert: ('*' , className , '*' match: svnMethod1 file basePath).
	self assert: ('*instance*' match: svnMethod1 file basePath).
	self assert: ('*class*' match: svnMethod2 file basePath).! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:52'!
testAllClassMethodsExists
	"Setup"
	| expectedFileNames directoryOfMethods actualFileNames |
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := sut directory getSubDirectoryNamed: self classClass.
	"Assertion"
	expectedFileNames := (self svnDummy class methodDict collect: 
				[ :each | each selector asString ]) asSet.
	actualFileNames := directoryOfMethods files collect: 
				[ :each | each theName ].
	self assert: expectedFileNames asSet = actualFileNames asSet! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:46'!
testAllInstanceMethodsExists
	"Setup"
	| expectedFileNames directoryOfMethods actualFileNames |
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := sut directory getSubDirectoryNamed: self classInstance.
	"Assertion"
	self assert: directoryOfMethods notNil.
	expectedFileNames := (self svnDummy methodDict collect: 
				[ :each | each selector asString ]) asSet.
	actualFileNames := directoryOfMethods files collect: 
				[ :each | each theName ].
	self assert: expectedFileNames = actualFileNames asSet! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:44'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	"Execution"
	sut := self createDummyClassForTests.
	"Assertion"
	self
		assertSVNClass: sut
		hasStateFromSystemClass: self svnDummy.
	self assertDirectoryEntriesEstablishedIn: sut
		! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:59'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| classFilesCreator |
	"Setup"
	classFilesCreator := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: classFilesCreator directory.
	"Execution"
	classFilesCreator store.
	sut := SVNClass restoreFrom: classFilesCreator directory.
	"Assertion"
	self
		assertSVNClass: sut
		hasStateFromSystemClass: self svnDummy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'test 4/23/2008 14:42'!
testDeleteClass

	| svnClass class |
	"Setup"
	class := Object
				subclass: #OnlyForThisTest
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
	svnClass := SVNClass forExistingClass: class.
	"Execution"
	class removeFromSystem.
	"Assertion"
	self assert: (svnClass theClass isNil).
	! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:14'!
testEqual

	| sut1 sut2 |
	"Setup"
	sut1 := self createDummyClassForTests.
	sut2 := self createDummyClassForTests.
	"Assertion"
	self assert: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:13'!
testGetSVNMethodsFromClass

	| expectedInstanceMethods expectedClassMethods |
	"Setup"
	sut := self createDummyClassForTests.
	"Expected"
	expectedInstanceMethods := self svnDummy methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	expectedClassMethods := self svnDummy class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	"Assertion"
	self assert: sut versionedMethods = (expectedInstanceMethods union: expectedClassMethods) asSet.! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:57'!
testLoadClass
	
	| className |
	"Setup"
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	"Execution"
	[sut load.
	"Assertion"
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [Smalltalk
				at: className asSymbol
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:54'!
testLoadExistingClassAndRestoreDeletedMethod
	
	| methodSelector |
	"Setup"
	methodSelector := #m2.
	sut := SVNClass forExistingClass: self svnDummy.
	self svnDummy removeSelector: methodSelector.
	"Execution"
	sut load.
	"Assertion"
	self assert: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:21'!
testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod
	"Setup"
	| class |
	self flag: #TODO.	"why ? a class with unversioned methods should not lose all methods."
	self willModifySVNDummy.
	class := self svnDummy.
	"Execution"
	sut := SVNClass forExistingClass: class.
	self assert: (class selectors includes: self methodSelector).
	sut removeSVNMethod: 
		(SVNMethod forExistingMethod: class >> self methodSelector).
	sut load.
	"Assertion"
	self deny: (class selectors includes: self methodSelector).
	self restoreSVNDummy! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/26/2008 16:40'!
testModifyInstanceVariables

	| svnClass |
	self
		willModifySVNDummy;
		willNeedRegistry.
	self svnEnvironment addSvnProject: self createSvnProjectWithSvnDummy.
	self svnDummy addInstVarName: 'newVar'.
	svnClass := self svnEnvironment findSvnClassFor: self svnDummy.
	self assert: svnClass notNil.
	self assert: (svnClass instanceVariables includes: 'newVar').! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:08'!
testNotEqual

	| sut1 sut2 |
	"Setup"
	sut1 := SVNClass forExistingClass: self svnDummy.
	sut2 := SVNClass forExistingClass: self class.
	"Assertion"
	self deny: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:52'!
testRemovIngAMethodAlsoRemovesFiles

	| svnMethod |
	"(self selector: #testRemovIngAMethodAlsoRemovesFiles) run"
	"Setup"
	sut := self createDummyClassForTests .
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = self methodSelector asString]
		ifNone: [self assert: false].
	"Execution"
	sut removeSVNMethod: svnMethod.
	"Assertion"
	self deny: (sut versionedMethods includes: svnMethod).
	self flag: #TODO. "Get rid of instance/class ... use accessors or such"
	self assert: ((sut directory getSubDirectoryNamed: 'instance') files
		noneSatisfy: [:ea | ea theName = self methodSelector asString]).! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:07'!
testRemoveClassFromVersioningControl

	| svnProject svnClass |
	"Setup"
	self flag: #TODO.
	self willTouchFileSystem.
	svnProject := SVNProject named: 'TestPro'.
	svnProject directory: (self defaultSVNDirectory createSubDirectoryNamed: svnProject theName).
	svnClass := SVNClass forExistingClass: self svnDummy.
	svnProject addSVNClass: svnClass.
	"Execution"
	svnProject removeClass: self svnDummy.
	"Assertion"
	self deny: (svnProject versionedClasses includes: svnClass).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:45'!
testRemoveMethod

	| svnMethod |
	"Setup"
	sut := self createDummyClassForTests .
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = self methodSelector asString]
		ifNone: [self assert: false].
	"Execution"
	sut removeSVNMethod: svnMethod.
	"Assertion"
	self deny: (sut versionedMethods includes: svnMethod).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:02'!
testRestoreRemovesNoLongerExistingMethods

	| methodSelector sizeOfVersionedMethods svnDir |
	"(self selector: #testRestoreRemovesNoLongerExistingMethods) run"
	"Setup"
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"prepare"
	"self halt."
	sut := self createDummyClassForTests.
	sut store.
	methodSelector := #m2.
	sizeOfVersionedMethods := sut versionedMethods size.
	svnDir := self defaultSVNDirectory.
	svnDir addSubdirectory: sut directory.
	svnDir store.
	(FileDirectory on: (sut directory getSubDirectoryNamed: 'instance') path)
		deleteFileNamed: methodSelector.
	"exercise"
	sut restoreAndLoad.
	self assert: sut versionedMethods size = (sizeOfVersionedMethods - 1).
	self deny: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:02'!
testSetWithSVNClassesAreEqual

	"(self selector: #testSetWithSVNClassesAreEqual) run"
	| set1 set2 anotherOne |
	sut := SVNClass forExistingClass: self svnDummy.
	anotherOne := (SVNClass forExistingClass: self svnDummy).
	self assert: sut = anotherOne.
	set1 := Set with: sut.
	set2 := Set with: anotherOne.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:00'!
testStatus

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy class';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #added.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForClassMethods

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy class';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusClassMethods = #modified.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForComment

	| svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	sut comment: 'Something'.
	sut 	store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusComment = #modified.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForInstanceMethods

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusInstanceMethods = #modified.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:47'!
testWriteCommentFile

	| createdFile |
	"Setup"
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	createdFile := sut directory getFileNamed: sut nameForCommentFile.
	"Assertion"
	self assert: (sut directory fileExists: sut nameForCommentFile).
	self assert: self svnDummy comment = createdFile content.! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: 'fileToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/13/2008 22:07'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:01'!
tearDown
	super tearDown.
	"self halt."! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 13:57'!
testCleanupDirectory

	| workingDir |
	workingDir := FileDirectory on: self workingCopyPath , self slash , '.svn'.
	(workingDir fileNamed: 'lock') close.
	self assert: (workingDir fileExists: 'lock').
	
	sut svnCleanupDirectory: self workingCopyPath.
	
	self deny: (workingDir fileExists: 'lock').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 4/27/2008 07:08'!
testCountOfCommitLogs

	| path file |
	path := self workingCopyPath.
	self assert: 1 = (sut svnGetCountOfCommitLogsFrom: path).
	
	file := path, self slash, 'fileToAdd'.
	self createFile: file.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	self assert: 2 = (sut svnGetCountOfCommitLogsFrom: path).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 4/3/2008 16:01'!
testCountOfCommitLogsIfTargetIsUnversioned

	| file |
	file := self workingCopyPath , self slash , 'aFile'.
	self createFile: file.
	self assert: 0 = (sut svnGetCountOfCommitLogsFrom: file).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: self workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:18'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 02:08'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents |
	path := self workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: self workingCopyPath , self slash ,'.svn', self slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:41'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: {workingCopyPath , self slash , fileToAdd}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnCheckoutRevisionByNumber

	"create new revisions"
	| firstFileName pathToFirstFile secondFileName pathToSecondFile workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	firstFileName := 'fileForFirstRevision'.
	pathToFirstFile := workingCopyPath , self slash , firstFileName.
	self createFile: pathToFirstFile.
	self assertThatFiles: {firstFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToFirstFile.
	sut svnCommit: {pathToFirstFile}.
	
	secondFileName := 'fileForSecondRevision'.
	pathToSecondFile := workingCopyPath , self slash , secondFileName.
	self createFile: pathToSecondFile.
	self assertThatFiles: {secondFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.
	
	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	self assert: (workingcopyDirectory fileExists: firstFileName).
	self deny: (workingcopyDirectory fileExists: secondFileName).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: {path , self slash , fileToAdd}.

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 4/17/2008 20:05'!
testSvnCommitWithMessageAndRevsionNumber
	| path commitLog message message1 stream |
	message := 'this is a log message'.
	message1 := 'this is another logMessage'.

	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	
	"Commit the file, than change its contents and commit it a second time"
	sut svnCommit: {  (path , self slash , fileToAdd)}
		withMessage: message.
	stream := FileStream fileNamed: path , self slash , fileToAdd.
	stream
		nextPutAll: '123';
		close.
	sut svnCommit: {  (path , self slash , fileToAdd)}
		withMessage: message1.
	
	"self halt."
	 
	"read the CommitLogs from the repository and assert them"
	commitLog := ((sut svnGetCommitLogsFrom: path , self slash , fileToAdd) at:1) comment.
	self assert: ((sut svnGetCommitLogsFrom: path , self slash , fileToAdd) at:1) revision = 1.
	self assert: commitLog = message.
	commitLog := ((sut svnGetCommitLogsFrom: path , self slash , fileToAdd) at:2) comment.
	self assert: ((sut svnGetCommitLogsFrom: path , self slash , fileToAdd) at:2) revision = 2.
	self assert: commitLog = message1.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:34'!
testSvnDeleteFromWorkingCopyWithCommittedItems

	| file dir |
	file := self workingCopyPath , self slash , 'file'.
	dir := self workingCopyPath , self slash , 'dir'.
	
	self createFile: file.
	(FileDirectory on: dir) assureExistence.
	
	sut svnAdd: file.
	sut svnAdd: dir.
	sut svnCommit: {file. dir}.
	
	sut svnDeleteTargetsFromWorkingCopy: {file. dir}.
	
	self assert: (FileDirectory new directoryExists: dir).
	self deny: (FileDirectory new fileExists: file).
	
	sut svnCommit: {dir. file}.
	
	self deny:
			((FileDirectory new fileExists: file) or:
			[(FileDirectory new directoryExists: dir)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnDeleteFromWorkingCopyWithUncommittedItems

	| file1 file2 dir1 dir2 workingCopyPathTemplate |
	workingCopyPathTemplate := self workingCopyPath , self slash.
	file1 := workingCopyPathTemplate , 'file1'.
	file2 := workingCopyPathTemplate , 'file2'.
	dir1 := workingCopyPathTemplate , 'dir1'.
	dir2 := workingCopyPathTemplate , 'dir2'.
	
	self createFile: file1.
	self createFile: file2.
	(FileDirectory on: dir1) assureExistence.
	(FileDirectory on: dir2) assureExistence.
	
	sut svnAdd: file2.
	sut svnAdd: dir2.
	
	sut svnDeleteTargetsFromWorkingCopy: {file1. file2. dir1. dir2}.
	
	self deny:
			((FileDirectory new fileExists: file1) or:
			[(FileDirectory new fileExists: file2)] or:
			[(FileDirectory new directoryExists: dir1)] or:
			[(FileDirectory new directoryExists: dir2)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 4/25/2008 11:03'!
testSvnGetBlameLinesFor
	
	| pathToFile firstLine secondLine blameLines |	
	self flag: #TODO. "the SVNBlameLinesRequest does the work"
	"Prepare the authentication baton"
	(SVNAuthenticationRequest onUsername: 'DEFAULTUSER' andPassword: '') execute.
	
	"Prepare the lines"
	firstLine := 'A line'.
	secondLine := 'Another line'.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: self workingCopyPath.
	
	"Write something into the testFile"
	self inFile: pathToFile write: firstLine, String cr.
	
	"Add it and commit it"
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"Commit next line"
	self inFile: pathToFile write: firstLine, String cr, secondLine.
	sut svnCommit: {pathToFile}.
	
	"Get blame lines"
	blameLines := sut svnGetBlameLinesFrom: pathToFile.

	"check if succeeded"
	self assert: (blameLines isEmpty not ).
	self assert: ((blameLines at: 1) = '1' ).
	self assert: ((blameLines at: 2) = 'DEFAULTUSER' ).
	self assert: ((blameLines at: 4) = '0' ).
	self assert: ((blameLines at: 5) = firstLine ).
	self assert: ((blameLines at: 6) = '2' ).
	self assert: ((blameLines at: 7) = 'DEFAULTUSER' ).
	self assert: ((blameLines at: 9) = '1' ).
	self assert: ((blameLines at: 10) = secondLine ).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 4/17/2008 20:08'!
testSvnGetPropertyFrom

	| path property properties |
	self flag: #TODO. "SVNPropertiesRequest does the work"
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.

	properties := (SVNPropertiesRequest target: path) execute; properties.
	property := properties
		at: 'propertyName'
		ifAbsent: [self assert: false].
	
	self assert: (property = 'value').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'cop 4/28/2008 15:44'!
testSvnResolvedTarget

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	fileInFirstWC resolved.
	self assert: fileInFirstWC status isConflicted not.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 11:17'!
testSvnRevert

	| file text |
	file := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	FileStream 
		forceNewFileNamed: file
		do: [:stream | stream nextPutAll: 'content'].
	
	sut svnRevertTargets: {file}.
	
	FileStream 
		readOnlyFileNamed: file
		do: [:stream | text := stream contents.].
	
	self deny: text size ~= 0.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory pathToFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: {workingCopyPath}.
	
	"check if succeeded"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile pathToFile pathToSecondFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create new revisions"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	secondFile := 'fileForSecondRevision'.
	pathToSecondFile := self pathTo: secondFile inDir: workingCopyPath.
	self createFile: pathToSecondFile.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.

	"recover the first revision"
	sut 
		svnUpdateTargets: {workingCopyPath}
		toRevisionByNumber: 1.

	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile)! !

SVNCApiClientTest subclass: #SVNShutDownErrorSearchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:06'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.
	
	fileToAdd := 'testFile'.
	self createFile: self workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 13:25'!
testCommandForAddProperty


	| key value path result expected |
	sut := SVNCommandLineClient new.
	key := 'irgendEinKey'.
	value := 'irgendEinValue'.
	path := SmalltalkImage current imagePath.
	result := sut buildCmdPropset: key value: value for: path.
	expected := 'svn propset ' , key , ' ' , value , ' ' , path.
	self assert: result = expected.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:19'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:49'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 4/11/2008 13:10'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: self workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 23:55'!
setUp

	super setUp.
	sut := SVNClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:04'!
testBackslashToSlash

	| validPath |
	validPath := 'C:\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := 'C:\\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveLastSlash

	| path |
	path := 'C:\test\test\' pathForSvn.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNCommandTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

SVNCommandTestCase subclass: #SVNAddToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

SVNAddToCurrentProjectCommandTest subclass: #SVNAddClassToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 13:28'!
testAddTarget

	"Class is not versioned return nil"
	| node environment svnProject svnClass |
	"prepare"
	environment := self createEnvironmentWithEmptyProject.
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: environment.
	sut := SVNAddClassToCurrentProjectCommand on: node	for: self.
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedClasses size = 1.
	svnClass := svnProject versionedClasses anyOne.
	self assert: svnClass theClass = self svnDummy.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:52'!
testIsActiveForClassNodeWhenTargetIsNotVersioned

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment:  self createEnvironmentWithEmptyProject.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:30'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEmptyEnvironment.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createEmptyEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:43'!
testIsNotActiveIfTargetIsInCurrentProject

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment:  self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.! !

SVNAddToCurrentProjectCommandTest subclass: #SVNAddMethodToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'helper' stamp: 'rkrk 4/23/2008 14:01'!
inSvnDummyCompileNewMethodNamed: methodSelector

	self deny: (self svnDummy includesSelector: methodSelector).
	self svnDummy compile: methodSelector asString , ' 1 + 2 + 3'.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'helper' stamp: 'rkrk 4/23/2008 13:56'!
selectorForNewSvnDummyMethod

	^ #methodForAddmethodCommandTest! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 14:01'!
tearDown

	super tearDown.
	(self svnDummy includesSelector: self selectorForNewSvnDummyMethod)
		ifFalse: [^ self].
	self svnDummy removeSelectorSilently: self selectorForNewSvnDummyMethod.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 13:41'!
testAddTargetWhenClassIsNotVersioned

	"Class is not versioned return nil"
	| node environment svnProject svnMethod |
	"prepare"
	environment := self createEnvironmentWithEmptyProject.
	node := self 
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> #m2) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedClasses size = 0.
	self assert: svnProject versionedMethods size = 1.
	svnMethod := svnProject versionedMethods anyOne.
	self assert: svnMethod methodSelector = #m2.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:25'!
testAddTargetWhenClassIsVersioned

	"Class is not versioned return nil"
	| node environment svnProject svnClass methodSel |
	self willModifySVNDummy.
	"prepare. There must be a node with an unversioned method"
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	svnClass := environment svnProjects anyOne versionedClasses anyOne. "There is only one"
	methodSel := self selectorForNewSvnDummyMethod.
	self inSvnDummyCompileNewMethodNamed: methodSel.
	node := self 
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> methodSel) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"method should not be versioned yet"
	self deny: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedMethods isEmpty.
	self assert: (svnProject versionedClasses includes: svnClass).
	self assert: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:55'!
testIsActiveForMethodNodeWhenTargetisNotVersioned01

	"prepare"
	| node |
	node := self
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithEmptyProject.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 22:15'!
testIsActiveForMethodNodeWhenTargetisNotVersioned02

	"prepare"
	| node environment |
	self willModifySVNDummy.
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self inSvnDummyCompileNewMethodNamed: self selectorForNewSvnDummyMethod.
	node := self
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> self selectorForNewSvnDummyMethod) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:37'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: self createEmptyEnvironment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createEmptyEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:55'!
testIsNotActiveIfTargetIsInCurrentProject

	"prepare"
	| node |
	node := self
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.! !

!SVNAddToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 23:27'!
testFindSvnProjectOfTarget01
	"Class is not versioned return nil"
	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self class
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.	"any class which is not in the environment will do"
	sut := SVNAddClassToCurrentProjectCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut findSvnProjectOfSVNElementOfTarget isNil! !

!SVNAddToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 23:27'!
testFindSvnProjectOfTarget02
	"Class is not versioned return nil"
	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddClassToCurrentProjectCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut findSvnProjectOfSVNElementOfTarget notNil! !

!SVNCommandTestCase methodsFor: 'helper' stamp: 'cop 4/23/2008 13:45'!
createNodeOfClass: aNodeClass on: target withEnvironment: svnEnv
	
	"Create a OBNode. Due to the way we access SVNEnvironments (via a filter),
	we also need a metaNode. Pretty ugly instantiation..."
	| metaNode filter node |
	metaNode := OBMetaNode new.
	filter := SVNOBEnvironmentFilter with: svnEnv.
	metaNode addFilter: filter.
	node := aNodeClass on: target.
	node metaNode: metaNode.
	^ node.! !

!SVNCommandTestCase methodsFor: 'helper' stamp: 'rkrk 4/23/2008 17:16'!
mockNodeOfKind: aClass withEnvironment: svnEnv svnElement: svnElement

	^ self createNodeOfClass: aClass on: svnElement withEnvironment: svnEnv! !

SVNCommandTestCase subclass: #SVNDeleteClassCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:18'!
testIsActiveForNodes

	| node |
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self assert: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:34'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEmptyEnvironment.
	sut := SVNDeleteClassCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createEmptyEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 22:32'!
testIsNotActiveWhenTargetIsNoSvnProject

	| node |
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: self createEmptyEnvironment
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self deny: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 22:35'!
testIsNotActiveWhenTargetIsNotInCurrentSvnProject

	| node environment anotherSvnProject |
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	anotherSvnProject := SVNProject named: 'NothingInMe'.
	environment
		addSvnProject: anotherSvnProject;
		currentProject: anotherSvnProject.
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: environment
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self deny: sut isActive.! !

SVNCommandTestCase subclass: #SVNDeleteMethodCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteMethodCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:33'!
testIsActiveForNodes

	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNDeleteMethodCommand on: node for: self.
	self assert: sut isActive.! !

!SVNDeleteMethodCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:31'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEmptyEnvironment.
	sut := SVNDeleteMethodCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createEmptyEnvironment.
	sut target: node.
	self deny: sut isActive.! !

SVNCommandTestCase subclass: #SVNDeleteProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteProjectCommandTest methodsFor: 'tests' stamp: 'cop 4/24/2008 15:28'!
testDeleteProject
	"prepare"
	| node |
	svnEnvironment := self createEnvironmentWithEmptyProject.
	node := SVNProjectNode element: svnEnvironment svnProjects anyOne svnEnvironment: svnEnvironment.
	sut := SVNDeleteProjectCommand on: node for: self.
	
	"exercise and assert"
	self assert: sut isActive.
	self assert: svnEnvironment svnProjects isEmpty not.
	
	sut deleteProjectIn: svnEnvironment.
	self assert: svnEnvironment svnProjects isEmpty.
	! !

SVNTestCase subclass: #SVNCommitLogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNCommitLogTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 16:18'!
testRevisionAuthorDateString
	
	| commitLogString aCommitLog |
	aCommitLog := SVNCommitLog
		createCommitLogWithRevision: 1 
		author: 'Michi' 
		date: (DateAndTime year: 2008 month: 01 day: 01 hour: 01 minute: 00) 
		comment: 'aComment'.
	
	commitLogString := aCommitLog revisionAuthorDateString.
	
	self assert: '1 - Michi 1 January 2008 1:00 am' = commitLogString! !

SVNTestCase subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:08'!
createClassNamed: nameOfClass

	^ Object
		subclass: nameOfClass asSymbol
		instanceVariableNames: 'i1'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM1For: class

	class compile: 'm1' , String cr , '^ ''Heeeee Yaaaahhhhhhh'''.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM2For: class

	class compile: 'm2: argument' , String cr , '^ argument asString'.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/4/2008 02:18'!
nameOfAClass
	^ 'ClassCreatedInSVNAccepatanceTests'! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'running' stamp: 'rkrk 3/4/2008 05:40'!
tearDown

	super tearDown.
	Smalltalk
		at: self nameOfAClass asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].
	self flag: #TODO.
	self restoreSVNDummy.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:28'!
test01

	| svnProject class workingCopyDir readSVNProject projectName readDirectory |
	self flag: #TODO. "Merge with test02"
	self willNeedRepositoryAndWorkingCopy.
	"Create new project. Create new class. Add it to the project and commit."
	projectName := 'NewProject'.
	svnProject := SVNProject named: projectName.
	class := self createClassNamed: self nameOfAClass.
	self createMethodM1For: class.
	self createMethodM2For: class.
	"self halt."
	workingCopyDir := SVNDirectory on: self workingCopyPath.
	svnProject
		directory: (workingCopyDir createSubDirectoryNamed: projectName);
		addClass: class;
		commit.
	"Read the project"
	readDirectory := SVNDirectory named: projectName basePath: self workingCopyPath.
	readDirectory read.
	readSVNProject := SVNProject restoreFrom: readDirectory.
	
	self assert: readSVNProject = svnProject.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'cop 4/14/2008 11:51'!
test02

	| svnProject newSVNProject svnClass newWorkingCopyDirectory newWorkingCopyPath |
	self willNeedRepositoryAndWorkingCopy.
	"create and modify a SVNProject"
	svnClass := SVNClass
		name: self nameOfAClass
		superclassName: 'Object'
		instanceVariables: {}
		classVariables: Set new
		classInstanceVariables: {}
		poolDictionaries: OrderedCollection new
		comment: ''
		category: 'neu'.
	"define a working copy directory"
	svnProject := SVNProject checkoutProject: 'TestProject' fromURL: self repositoryURLPath inWorkingCopy:  (SVNDirectory on: self workingCopyPath).
	svnProject addSVNClass: svnClass.
	"commit the changes"
	svnProject commit.
	"self halt."
	"delete project and working copy"
	svnProject unload.
	self deny: (Smalltalk hasClassNamed: self nameOfAClass).
	"checkout the project in a new working copy"
	newWorkingCopyPath := self pathForTests , self slash , 'newWorkingCopy'.
	newWorkingCopyDirectory := SVNDirectory on: newWorkingCopyPath.
	newSVNProject := SVNProject
		checkoutProject: 'TestProject' 
		fromURL: self repositoryURLPath
		inWorkingCopy: newWorkingCopyDirectory.
	"load it into the system"
	newSVNProject load.
	"check if the old state is restored"
	self assert: (Smalltalk hasClassNamed: self nameOfAClass).
	self flag: #TODO. "Check if methods are there"! !

SVNTestCase subclass: #SVNCreateProjectDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UITests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 3/4/2008 02:10'!
fullPath

	^ FileDirectory fullPathForURI: ''! !

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 4/7/2008 13:12'!
setUp

	super setUp.
	sut := SVNCreateProjectDialog new
		svnProject: (SVNProject named: '');
		yourself.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:10'!
testWorkingCopyPath

	| path |
	path := self fullPath , 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (path = sut projectWorkingCopyPath).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:12'!
testWorkingCopyPathRelative

	| path |
	path := 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (sut projectWorkingCopyPath = (self fullPath , path)).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 16:01'!
testWorkingCopyPathWithBackSlash

	| fullpath path |
	path := 'workingCopy' , self slash , 'subdir'.
	
	sut setProjectWorkingCopyPath: path.
	fullpath := self fullPath , path.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:13'!
testWorkingCopyPathWithSlash

	| path fullpath |
	path := './workingCopy/subdir'.
	
	self assert: (sut setProjectWorkingCopyPath: path).
	fullpath := self fullPath , 'workingCopy' , self slash , 'subdir'.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

SVNTestCase subclass: #SVNDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 3/13/2008 14:31'!
testAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 3/5/2008 01:33'!
testAddFilesWithPropertiesWhichAreInTheEndEqual

	| filename assoc |
	sut := SVNDirectory
		named: 'svnDir'
		basePath: self pathForTests.
	filename := 'fileName'.
	assoc := 'key' -> 'value'.
	(sut createFileNamed: filename) properties add: assoc.
	(sut createFileNamed: filename) properties add: assoc.

	self assert: sut files size = 1.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:09'!
testAddSubdirectories

	| dir1 dir2 |
	"setup"
	sut := SVNDirectory
		named: 'rootDir'
		basePath: self pathForTests.
	dir1 := SVNDirectory named: 'depth1'.
	dir2 := SVNDirectory named: 'depth2'.
	dir1 addSubdirectory: dir2.
	"exercise"
	sut addSubdirectory: dir1.
	"assert"
	self assert: sut path = dir1 basePath.
	self assert: dir1 path = dir2 basePath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:04'!
testAddTwoTimesTheSameFile

	| file |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	file := SVNFile named: 'test'.
	sut
		addFile: file;
		addFile: file.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'test 4/2/2008 16:53'!
testAlreadyExistingFileIsReplacedWhenAdded

	"And the state of the existing file is considered"
	| resultFile fileName file1 file2 |
	fileName := 'TheFile'.
	file1 := SVNFile named: fileName.
	file1
		content: 'abc_xyz';
		properties: (Dictionary with: 'a' -> 'b').
	sut addFile: file1.
	file2 := SVNFile named: fileName.
	file2
		content: 'Howdey Hoooo!!';
		properties: (Dictionary with: '123' -> '456').
	sut addFile: file2.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: resultFile = file2.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:49'!
testCommitARemovedDirectory

	| fileName |
	"create"

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
				named: 'TestDir'
				basePath: self workingCopyPath.
	fileName := 'iAmAFile'.
	sut
		createFileNamed: fileName;
		store;
		commit.
	
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self
		assertThatFiles: {fileName}
		existsIn: (self workingCopyPath , '2', self slash, sut theName).
	
	"remove"
	sut
		remove;
		commit.
	
	"check"
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self deny: (FileDirectory on: self workingCopyPath , '2', self slash, sut theName) exists.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateFile

	| fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories anyOne.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:13'!
testCreateTwoTimesTheSameFile

	| fileName |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	sut
		createFileNamed: fileName;
		createFileNamed: fileName.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:10'!
testCreateTwoTimesTheSameFileWithContent

	| fileName content |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	content := 'abc'.
	sut
		createFileNamed: fileName
		withContent: content.
	sut
		createFileNamed: fileName
		withContent: content.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 00:19'!
testCreateWithOn

	sut := SVNDirectory on: self pathForTests.
	FileDirectory
		splitName: self pathForTests
		to: [:dirPath :localName |
			self assert: sut basePath = dirPath.
			self assert: sut theName = localName].
	! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 05:30'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	sut recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete].
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 17:08'!
testDontStoreSubdirectoriesMultipleSubdirectoriesWithTheSameName

	| newSubdir1 newSubdir2 subdirFromSut key value |
	newSubdir1 := SVNDirectory named: 'subdir' basePath: sut path.
	sut addSubdirectory: newSubdir1.
	newSubdir2 := SVNDirectory named: 'subdir' basePath: sut path.
	key := 'key'.
	value := 'value'.
	newSubdir2 properties at: key put: value.
	sut addSubdirectory: newSubdir2.
	self assert: sut subdirectories size = 1.
	subdirFromSut := sut subdirectories anyOne.
	self assert: (subdirFromSut properties at: key) = value.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:58'!
testFilesMustHaveTheCorrectBasePath01

	| newFile |
	newFile := SVNFile
		named: 'new'
		basePath: 'Not/existing'.
	sut addFile: newFile.
	self assert: newFile basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:01'!
testGatherPathsOfAllElements

	| dirName fileName expected1 expected2 result |
	dirName := 'dir1'.
	fileName := 'file1'.
	sut
		createSubDirectoryNamed: dirName;
		createFileNamed: fileName.
	expected1 := sut path , self slash , dirName.
	expected2 := sut path , self slash , fileName.
	result := sut recursivelyGatherPathsOfAllElements.
	self assert: result size = 2.
	self assert: (result includes: expected1).
	self assert: (result includes: expected2).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'per 4/21/2008 11:08'!
testReadNonExistingDirectory

	sut := SVNDirectory
		named: 'blablabla'
		basePath: 'auf\dem\Mond'.
	"self shouldnt: [sut read] raise: Error."
	self assert: sut subdirectories isEmpty.
	self assert: sut files isEmpty.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:24'!
testReadWhenFileAndSubdirectoriesAreDeleted

	| fileName subDirName |
	self willTouchFileSystem.
	"Create a SVNDirectory and add a file and a subdirectory to it. Store. Delete the file and subdirectory
	and let the sut do a read. The file and subdirectory should be removed."
	"(self selector: #testReadWhenFileAndSubdirectoriesAreDeleted) run"
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'file'. subDirName := 'subdir'.
	sut
		createFileNamed: fileName;
		createSubDirectoryNamed: subDirName;
		store.
	self assert: sut files size = 1.
	self assert: sut subdirectories size = 1.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	(FileDirectory on: sut path) deleteFileNamed: fileName.
	(FileDirectory on: sut path) deleteDirectory: subDirName.
	self denyThatFiles: {fileName. subDirName} existsIn: sut path.
	sut read.
	self assert: sut files size = 0.
	self assert: sut subdirectories size = 0.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	self willTouchFileSystem.
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self
		createDirNamed: sut theName
		in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self pathTo: fileName inDir: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile 
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile)! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:46'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut remove.
	
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:04'!
testSetWithDirsAreEqual01

	"(self selector: #testSetWithDirsAreEqual01) run"
	| set1 set2 |
	sut := SVNDirectory named: 'svnDirectory' basePath: self pathForTests.
	sut
		createFileNamed: 'blabla';
		createSubDirectoryNamed: 'ugauga'.
	set1 := Set with: sut.
	set2 := Set with: sut.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:06'!
testSetWithDirsAreEqual02

	"(self selector: #testSetWithDirsAreEqual02) run"
	| set1 set2 anotherOne |
	sut := (SVNClass forExistingClass: self svnDummy) directory.
	anotherOne := (SVNClass forExistingClass: self svnDummy) directory.
	sut = anotherOne.
	set1 := Set with: sut.
	set2 := Set with: anotherOne.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:22'!
testSetWithDirsAreEqual03

	"(self selector: #testSetWithDirsAreEqual03) run"
	| set1 set2 subDir svnFile |
	sut := SVNDirectory named: 'svnDirectory' basePath: self pathForTests.
	subDir := SVNDirectory named: 'subDir'.
	(subDir createFileNamed: 'uga') properties at: 'aaa' put: 'bbbb'.
	svnFile := SVNFile named: 'file' basePath: '/asfsd/sadfdsaf/sdfds'.
	svnFile properties at: 'aaa' put: 'bbbb'.
	sut addSubdirectory: subDir.
	subDir addFile: svnFile.
	set1 := Set with: sut.
	set2 := Set with: sut copy.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreDirectoryWithFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreLotsOfDirectoriesAndFiles

	| fileName subDirName subDirFileName subSubDirName subSubDirFileName subDir subSubDir |
	self willTouchFileSystem.
	fileName := 'file'.
	subDirName := 'subDir'.
	subDirFileName := 'subDirFileName'.
	subSubDirName := 'subsubDir'.
	subSubDirFileName := 'subSubDirFileName'.

	sut createFileNamed: fileName.
	subDir := sut createSubDirectoryNamed: subDirName.
	subDir createFileNamed: subDirFileName.
	subSubDir := subDir createSubDirectoryNamed: subSubDirName.
	subSubDir createFileNamed: subSubDirFileName.
	
	sut store.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	self assertThatFiles: {subDirFileName. subSubDirName} existsIn: subDir path.
	self assertThatFiles: {subSubDirFileName} existsIn: subSubDir path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 4/17/2008 20:05'!
testStoreProperties

	| propertyDict result |
	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
		named: 'bla2'
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	result := (SVNPropertiesRequest target: sut path) execute; properties.
	self debugExpected: propertyDict result: result.
	self assert: propertyDict = result.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:59'!
testSubdirectoriesMustHaveTheCorrectBasePath01

	| newDir |
	newDir := SVNDirectory
		named: 'blupf'
		basePath: 'not/existing/path'.
	sut addSubdirectory: newDir.
	self assert: newDir basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectoryWithSubdirectoriesAndFiles

	| directoryName subDirectoryName fileName subDir |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	subDirectoryName := 'SubDirectory'.
	fileName := 'file'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	subDir := sut createSubDirectoryNamed: subDirectoryName.
	subDir createFileNamed: fileName.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.
	self
		assertFile: subDirectoryName
		wasSVNAddedIn: sut path.
	self
		assertFile: fileName
		wasSVNAddedIn: sut path.! !

SVNTestCase subclass: #SVNEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:52'!
testClassIsIncludedInEvironment

	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self assert: (sut includes: self svnDummy).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testCompiledMethodIsIncludedInEvironment

	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self assert: (sut includes: self svnDummy >> #m2).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:51'!
testFindSvnMethodForCompiledMethod01

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	"excercise"
	method := self svnDummy >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self deny: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testFindSvnMethodForCompiledMethod02

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	"excercise"
	method := self svnDummy class >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self assert: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:50'!
testFindSvnMethodForCompiledMethod03

	| method |
	"prepare"
	sut := self createEnvironmentWithEmptyProject.
	"excercise"
	method := self svnDummy class >> #onInstanceAndClassSide. 
	self assert: (sut findSvnMethodForMethod: method) isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:52'!
testFindSvnMethodInSvnClassWithinEnvironment

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	method := SVNMethod forExistingMethod: self svnDummy >> #m1.
	result := sut findSvnProjectOrSvnClassForSvnMethod: method.
	self assert: result notNil.
	self assert: (result isKindOf: SVNClass).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testMethodRefIsIncludedInEvironment

	| methodRef |
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	methodRef := MethodReference class: self svnDummy selector: #m2.
	self assert: (sut includes: methodRef ).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:51'!
testNoSvnClassForClassNotInProject

	| result |
	sut := self createEnvironmentWithEmptyProject.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:48'!
testRetrieveSvnClassFromSystemClass

	| result |
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result = (SVNClass forExistingClass: self svnDummy)! !

SVNTestCase subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'assertion' stamp: 'test 4/17/2008 20:13'!
assertThatProperties: propertyDict areAddedTo: svnDirectoryEntry

	| result |
	result := (SVNPropertiesRequest target: svnDirectoryEntry path) execute ; properties.
	
	self debugExpected: propertyDict result: result.
	self assert: propertyDict = result.! !

!SVNFileTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNFile
		named: 'SVNFileCreatedDuringTests'
		basePath: self pathForTests.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:50'!
testCommitARemovedFile
	| client fileName |
	"create"
	client := SVNCApiClient new.
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile named: fileName basePath: self workingCopyPath.
	sut store.
	client svnAdd: sut path.
	client svnCommit: {  (sut path)}.
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self assert: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName).
	
	"remove"
	sut remove.
	client svnCommit: {sut path}.
	
	"check"
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self deny: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:50'!
testConvertIllegalFileName01

	| expected separator |
	sut theName: 'selectorwithcolon:'.
	separator := sut class asciiValueSeparator asString.
	expected := 'selectorwithcolon' , separator , $: asciiValue asString , separator.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:54'!
testConvertIllegalFileName02

	| expected firstPart separator |
	sut theName: '//'.
	separator := sut class asciiValueSeparator asString.
	firstPart := separator , $/ asciiValue asString , separator.
	expected := firstPart , firstPart.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:51'!
testCreateMethodWithAsciiInName

	| separator |
	separator := sut class asciiValueSeparator asString.
	sut := SVNFile
		named: 'm1' , separator , '58' , separator
		basePath: self pathForTests.
	self assert: sut theName = 'm1:'.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:12'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	sut delete.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:14'!
testDeletenonExistingFile

	| fileName |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut delete] raise: Error.
! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/5/2008 20:22'!
testEqualFilesStoredInSet

	| fileName content file1 file2 assoc set dir |
	self willTouchFileSystem.
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 store.
	dir := self defaultSVNDirectory.
	dir read.
	dir commit.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	set := Set with: file1 with: file2.
	self assert: set size = 1.
	self assert: file1 = file2.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:34'!
testEquals

	| fileName content file1 file2 assoc |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	self assert: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:52'!
testEquals02

	| file1 file2 set |
	file1 := SVNFile readFrom:  '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	file2 := SVNFile readFrom: '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	set := Set with: file1 with: file2.
	self assert: set size = 1.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 4/21/2008 13:06'!
testFilenamesWithUmlauts

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'mp'
		basePath: self pathForTests.
	self assert: svnFile filename = 'm%246%p'.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/4/2008 01:11'!
testReadFileContents

	| fileName content fullPath |
	self willTouchFileSystem.
	fileName := 'someSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self pathTo: fileName inDir: self pathForTests.
	self 
		inFile: fullPath
		write: content.
	sut read.
	self assert: sut content = content! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/20/2008 03:45'!
testReadFileProperties

	| fileName helper expected propertyKey propertyValue result |
	self willNeedRepositoryAndWorkingCopy.
	"create some file and add manually properties to it"
	fileName := 'someSVNFile'.
	helper := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	helper store.	
	propertyKey := 'schluessel'.
	propertyValue := 'wert'.
	self svnClientDo: [:svnClient |
		svnClient svnAddProperty: propertyKey WithValue: propertyValue To: helper path].
	
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut read.
	expected := Dictionary with: propertyKey -> propertyValue.
	result := sut properties.
	self debugExpected: expected result: result.
	self assert: result = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 4/21/2008 13:15'!
testReadFileWithUmlauts

	| filename expected svnDir |
	self willTouchFileSystem.
	filename := 'm%246%pp'.
	expected := 'mpp'.
	self
		inFile: (self pathTo: filename inDir: self pathForTests)
		write: String new.
	svnDir := self defaultSVNDirectory.
	svnDir read.
	self assert: svnDir files size = 1.
	sut := svnDir files anyOne.
	self assert: sut filename = filename.
	self assert: sut theName = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/5/2008 18:52'!
testReadMethodWithIllegalFileName01

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'm1:'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNFile
		named: svnFile theName
		basePath: svnFile basePath.
	sut read.
	self assert: sut = svnFile.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 4/21/2008 01:20'!
testReadNonExistingFile

	| fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut read] raise: Error.
	self assert: sut content isEmpty.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:51'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'aLittleSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut remove.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:20'!
testStoreAndAddFile

	| fileName |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'testSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut store.
	self 
		assertFile: fileName
		wasSVNAddedIn: self workingCopyPath! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:57'!
testStoreAsFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreContent

	| fileName content |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreProperties

	| fileName propertyDict |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self
		assertThatProperties: propertyDict
		areAddedTo: sut.! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/13/2008 15:26'!
testSvnAdd

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNFile
		named: 'FileName'
		basePath: self workingCopyPath.
	sut
		store;
		svnAdd.
	self
		assertFile: sut theName
		wasSVNAddedIn: sut basePath.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:30'!
testUnequal01

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content , ' Blupf'.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:31'!
testUnequal02

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName , ' abc'
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:33'!
testUnequal03

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 properties add: 'key' -> 'value'.
	file2 properties add: 'otherKey' -> 'value'.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/14/2008 04:19'!
testUpdateWithNoLocalChanges

	| contentForRev1 |
	self willNeedRepositoryAndWorkingCopy.
	contentForRev1 := 'abc'.
	sut content: contentForRev1.
	sut
		store;
		commit.
	"self assert: false."! !

SVNTestCase subclass: #SVNInfoRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNInfoRequestTest methodsFor: 'helper' stamp: 'mu 4/2/2008 11:34'!
getScheduleForFile: aFile

	^ (SVNInfoRequest target: aFile) execute schedule.! !

!SVNInfoRequestTest methodsFor: 'running' stamp: 'rkrk 3/23/2008 03:24'!
setupAddedFile

	^ (self defaultSVNDirectory createFileNamed: 'fileForSvnInfo')
		store;
		yourself.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 03:33'!
testConvertToDateFromCTimeString

	! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:58'!
testDefaultArrayForPrimitive

	| conditions |
	sut := SVNInfoRequest new.
	self flag: #TODO.
	conditions := {
		[:elem | elem isString and: [elem size > 200]].	"repository root url"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #unspecified)]. "current revision kind" 
		[:elem | elem isNil].							"current revision number"
		[:elem | elem isString and: [elem size = (36 + 1)]].	"repository uuid"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #unspecified)]."last changed  revision kind"
		[:elem | elem isNil].							"last changed revision number"
		[:elem | elem isString and: [elem size = (25 + 1)]].	"date"
		[:elem | elem isString and: [elem size > 100]].	"author"
		[:elem | elem isString and: [elem size = (8 + 1)]].	"schedule"
	}.
	sut arrayForPrimitive with: conditions do: [:each :condition |
		self assert: (condition value: each)].! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'test 4/2/2008 10:43'!
testExecuteInfoForAddedFile

	| addedFile expectedRevision expectedLastChangedRevision |
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	sut := SVNInfoRequest target: addedFile.
	sut execute.
	self flag: #TODO. "Make author changable"
	self assert: sut author = ''.
	expectedRevision := SVNRevision unspecified.
	expectedRevision number: 0.
	self assert: sut revision = expectedRevision.
	expectedLastChangedRevision := SVNRevision unspecified.
	expectedLastChangedRevision number: -1.
	self assert: sut lastChangedRevision = expectedLastChangedRevision.
	self assert: sut date = DateAndTime current.
	self assert: sut repositoryRootUrl , '/' = self repositoryURLPath.
	self flag: #TODO. "Manage RepositoryUUID"
	self assert: sut repositoryUUID isString.
	self assert: sut schedule = 'add'.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 4/26/2008 02:45'!
testGetHeadRevision

	| file request |
	self willNeedRepositoryAndWorkingCopy.
	
	file := self defaultSVNDirectory createFileNamed: 'fileInSvnInfoRequestTest'.
	file
		store;
		commit.
	request := (SVNInfoRequest target: file forRevision: (SVNRevision head)).
	request execute.
	self assert: request revision number = 1.
	file
		content: 'xyz';
		store;
		commit.
	request execute.
	self assert: request revision number = 2.
	self svnClientDo: [:client | client
		svnUpdateTargets: {file path}
		toRevisionByNumber: 1].
	request execute.
	self assert: request revision number = 2.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 4/26/2008 02:47'!
testGetWorkingRevision

	| file request |
	self willNeedRepositoryAndWorkingCopy.
	
	file := self defaultSVNDirectory createFileNamed: 'fileInSvnInfoRequestTest'.
	file
		store;
		commit;
		content: 'xyz';
		store;
		commit.
	self svnClientDo: [:client | client
		svnUpdateTargets: {file path}
		toRevisionByNumber: 1].
	request := (SVNInfoRequest target: file forRevision: (SVNRevision working)).
	request execute.
	self assert: request revision number = 1.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'mu 4/2/2008 11:57'!
testInfoScheduleForFile

	| addedFile firstSchedule secondSchedule stream thirdSechedule |
	"setup"
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	
	"execute"
	firstSchedule := self getScheduleForFile: addedFile.
	"self halt."
	addedFile commitWithMessage: 'not relevant'.
	secondSchedule := self getScheduleForFile: addedFile.
	self flag: #TODO. "if a element is modified - return the status modified/replace"
"	stream := FileStream fileNamed: addedFile path.
	stream
		nextPutAll: '123';
		close.
	thirdSechedule := self getScheduleForFile: addedFile."
	
	"assert"
	self assert: firstSchedule = 'add'.
	self assert: secondSchedule = 'normal'.
	"self assert: thirdSechedule = 'replace'"! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 02:28'!
testStringForSvnPrimitive

	| string result stringForPrimitive |
	string := 'blabla'.
	result := string forSvnPrimitive. "Be a collection with one String"
	self assert: result size = 1.
	stringForPrimitive := result first.	
	self assert: stringForPrimitive last = (Character value: 0).! !

SVNTestCase subclass: #SVNLoaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNLoaderTest commentStamp: '<historical>' prior: 0!
A SVNLoaderTest is xxxxxxxxx.

Instance Variables
!

!SVNLoaderTest methodsFor: 'assertions' stamp: 'rt 3/7/2008 22:07'!
classesRecoveredCorrect: aSet

	| element setUnderTest |
	self assert: aSet size = 1.
	element := aSet someElement.
	self assert: element superclassName = 'Object'.
	self assert: element theName = 'TestClass4'.
	
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass3'. 'TestClass5'} asSet.
	self assert: (setUnderTest detect: [:each | each theName = 'TestClass5']) subclasses isEmpty.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass3'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 1.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass2'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass1'. 'TestClass6'} asSet.
	
	setUnderTest do: [:each | self assert: each subclasses isEmpty].
	^true! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 10:52'!
getSVNTestClassFromClass: aClass

	^SVNClass forExistingClass: aClass! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:45'!
getTestClass

	| class |
	class :=(Smalltalk classNamed: self nameOfTestClass asSymbol) ifNil: [Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: '' 
		classVariableNames:''
		poolDictionaries: ''
		category: self class category asString].
	
	class
		compile: 'm1: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm2: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm3: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	^class! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 23:21'!
nameOfTestClass

	^'ClassOfSVNLoaderTest'! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 11:21'!
removeTestClass: name

	| class |
	(class := Smalltalk classNamed: name) ifNotNil: [class removeFromSystem].! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:29'!
setOfDependentClasses
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'SVNMethod')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'SVNClass')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'DoesNotExistingClass').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 15:58'!
setOfDependentClassesWithCycles
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass1').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 21:08'!
setOfDependentClassesWithOutCycles

	^Set with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'TestClass2').! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/8/2008 02:43'!
setUp
	super setUp.
	sut := SVNLoader new! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/7/2008 11:16'!
tearDown

	self removeTestClass: self nameOfTestClass.
	
	super tearDown! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 22:29'!
testClassSorting

	| aSVNClassSet sortedSVNClasses |
	aSVNClassSet := self setOfDependentClassesWithOutCycles.
	sut addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	
	sortedSVNClasses := sut sortSVNClasses: aSVNClassSet consider: (sut requiredClasses intersection: sut classesToLoad).
	
	self assert: (self classesRecoveredCorrect: sortedSVNClasses)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 12:53'!
testDetectDependenciesInSVNClasses

	| resultSet |
	resultSet := sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses..
	self assert: resultSet = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:39'!
testDetectDependenciesInSVNMethods

	| svnClass resultSet |
	svnClass := self getSVNTestClassFromClass: self getTestClass.
	resultSet := sut 
				addToRequiredClassesAllDependenciesInSVNMethods: (svnClass versionedMethods).
	self assert: resultSet = (Set with: self nameOfTestClass)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 16:08'!
testForCycles

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithCycles.
	self assert: (sut hasCycle: self setOfDependentClassesWithCycles).
	
	sut initialize.
	
	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithOutCycles.
	self deny: (sut hasCycle: self setOfDependentClassesWithOutCycles).! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 15:56'!
testRequirements

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses.
	
	self assert: sut classesToLoad = {'TestClass1'. 'TestClass2'. 'TestClass3'. 'TestClass4'. 'TestClass5'. 'TestClass6'} asSet.
	
	self assert: sut requiredClasses = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet.
	
	self assert: sut unknownRequiredClasses = {'DoesNotExistingClass'} asSet! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 01:58'!
svnFileForMethodReference: methodRef

	| svnFile |
	svnFile := SVNFile 
		named: methodRef methodSymbol asString
		basePath: ''
		content: methodRef source.
	svnFile properties 
		at: 'class' put: methodRef actualClass name asString;
		at: 'category' put: methodRef category;
		at: 'timestamp' put: methodRef timeStamp.
	^ svnFile.! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:25'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod forExistingMethod: self svnDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 12:44'!
testExtractMetaClass

	| method result svnFile className |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	svnFile := SVNFile
		named: 'm99'
		basePath: '/'.
	className := 'SVNDummy class'.
	svnFile properties
		at: 'class'
		put: className.
	result := method extractClassFrom: svnFile.
	self assert: result = className.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 3/4/2008 03:25'!
testLoadMethodIntoSystem

	| class methodSelector  |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	class removeSelector: methodSelector.
	self deny: (class methodDict includesKey: methodSelector).
	sut load.
	self assert: (class methodDict includesKey: methodSelector).! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 4/21/2008 00:46'!
testRestoreAndLoad

	
	| newSourceCode result |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"prepare"
	sut := SVNMethod forExistingMethod: self svnDummy >> #m2.
	"For setting the correct path"
	self defaultSVNDirectory addFile: sut file.
	sut store.
	sut file store.
	
	newSourceCode := 'm2 ^ 1 + 2 + 3 + 4 + 5'.
	sut source: newSourceCode.
	sut store.
	sut file store.
	"exercise"
	sut restoreAndLoad.
	result := (self svnDummy >> #m2) getSource.
	self assert: result = newSourceCode.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 4/1/2008 04:33'!
testRestoreFromSVNFile

	
	| methodSelector class methodReference svnFile expectedSVNMethod |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	methodReference := (class >> methodSelector) methodReference.
	svnFile := self svnFileForMethodReference: methodReference.
	"exercise"
	sut := SVNMethod restoreFrom: svnFile.
	"expected"
	expectedSVNMethod := SVNMethod forExistingMethod: class >> methodSelector.
	"assertion"
	self assert: sut = expectedSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/1/2008 02:04'!
testSVNMethodComesWithCorrectlyInitializedSVNFile

	| methodSelector class methodRef expectedFile resultFile |
	"setup"
	class := self svnDummy. methodSelector := #m1.
	methodRef := (class >> methodSelector) methodReference.
	"exercise"
	sut := SVNMethod forExistingMethod: methodRef compiledMethod.
	"assert"
	expectedFile := self svnFileForMethodReference: methodRef.
	resultFile := sut file.
	self assert: expectedFile = resultFile.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 17:41'!
testStoreInSVNDirectory
	
	| methodSelector class methodReference expectedSVNFile |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	methodReference := (class >> methodSelector) methodReference.
	expectedSVNFile := self svnFileForMethodReference: methodReference.
	"assertion"
	expectedSVNFile basePath: sut file basePath.
	self assert: sut file notNil.
	self assert: sut file = expectedSVNFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 18:09'!
testStoreThenRestore

	| methodSelector writtenSVNMethod methodFile readSVNMethod |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #m1.
	writtenSVNMethod := SVNMethod forExistingMethod: self svnDummy >> methodSelector.
	self defaultSVNDirectory addFile: writtenSVNMethod file.
	"exercise"
	writtenSVNMethod store.
	"assertion"
	methodFile := writtenSVNMethod file.
	self assert: methodFile notNil.
	readSVNMethod := SVNMethod restoreFrom: methodFile.
	self assert: writtenSVNMethod = readSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 17:44'!
testStoreWithSpecialCharInSVNDirectory

	| methodSelector class expectedFileName separator |
	"prepare"
	methodSelector := #<.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	separator := SVNDirectoryEntry asciiValueSeparator asString.
	expectedFileName := separator , '60' , separator.
	"assertion"
	self assert: sut file notNil.
	self assert: sut file filename = expectedFileName! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/28/2008 00:28'!
testUpdateToPreviousRevision

	| source1 source2 |
	"Create a SVNMethod of SVNDummy>>m2. Commit rev1 of the svnMethod. Change
	svnMethod (and the svnDummy) and commit again. Update to rev1."
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"objects needed"
	sut := SVNMethod forExistingMethod: self svnDummy >> #m2.
	self defaultSVNDirectory addFile: sut file.
	source1 := sut source.
	"prepare"
	sut store.
	sut file store.
	sut	commit.
	source2 := 'm2 "another source of m2"'.
	self svnDummy compile: source2.
	sut source: source2. "no registry here. Manually assign new source"
	sut store.
	sut file store.
	sut commit.
	self
		assertThatFile: sut theName
		inPath: self pathForTests
		hasContent: source2.
	self assert: (self svnDummy >> #m2) getSource = source2.
	"exercise"
	sut updateToRevision: (SVNRevision number: 1).
	self assert: sut source = source1.
	self assert: (self svnDummy >> #m2) getSource = source1.! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: 'needsTestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest subclass: #SVNProjectExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectExternalTest methodsFor: 'assertions' stamp: 'rkrk 3/6/2008 14:41'!
assertNoSVNFileWithIllegalCharacterIn: aSVNDirectory

	aSVNDirectory files do: [:each |
		self assert: (each filename includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not.].
	aSVNDirectory subdirectories do: [:each | self assertNoSVNFileWithIllegalCharacterIn: each].! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/19/2008 11:15'!
createSimpleDummyClassForSVNProjectTest

	| class |
	class := Object
				subclass: self nameOfClassForTests asSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
	
	class compile: 'm1: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm2: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm3: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm4: obj' classified: 'neu' withStamp: nil notifying: nil.
	^class! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/13/2008 16:32'!
nameOfClassForTests

	^ 'SimpleDummyClassForSVNProjectTest'! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 04:24'!
removeSimpleDummyClassForSVNProjectTest

	Transcript
		show: 'will remove SimpleDummyClassForSVNProjectTest in test:' , testSelector;
		cr;
		show: 'class is there:' , (Smalltalk hasClassNamed: self nameOfClassForTests) asString;
		cr.
	"testSelector = #testCheckoutProperties ifTrue: [self halt]."
	(Smalltalk hasClassNamed: self nameOfClassForTests) ifFalse: [^self].
	Transcript
		show: 'Removing...';
		cr.
	(Smalltalk classNamed: self nameOfClassForTests) removeFromSystemUnlogged.
	Transcript
		show: 'Class successfully removed';
		cr.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:34'!
setUp

	super setUp.
	
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	self createSimpleDummyClassForSVNProjectTest.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:35'!
tearDown

	self removeSimpleDummyClassForSVNProjectTest.
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	
	super tearDown.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/20/2008 04:58'!
testCheckoutProperties

	| svnPro destination client |
	self willNeedRepositoryAndWorkingCopy.

	svnPro := SVNProject
 		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
     
	svnPro addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro store.

	destination := self workingCopyPath, self slash, svnPro theName,
				self slash, self nameOfClassForTests.
	client := SVNCommandLineClient new.
	client
		svnAddProperty: 'instanceVariables'
		WithValue: 'instVar1'
		To: destination.

	svnPro projectDirectory read.
	self assert: (svnPro projectDirectory subdirectories size = 1).! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:40'!
testCheckoutSVNDirectories

	| svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 commit.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 checkout.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:40'!
testCountOfCommitedElements

	| svnPro1 svnPro2 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	
	svnPro2 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	
	svnPro1 commit.
	svnPro1 commit.
	self assert: svnPro1 = svnPro2.

	self assert: svnPro1 projectDirectory subdirectories size = 1.
	self assert: svnPro1 projectDirectory subdirectories size = svnPro2 projectDirectory subdirectories size.
	self assert: svnPro1 projectDirectory subdirectories anyOne files size = svnPro2 projectDirectory subdirectories anyOne files size.
	self assert: svnPro1 projectDirectory subdirectories anyOne subdirectories size = svnPro2 projectDirectory subdirectories anyOne subdirectories size.
	self assert: ((svnPro1
					projectDirectory subdirectories anyOne subdirectories
						detect: [:each | each theName = 'instance']) files size
							= (svnPro2 projectDirectory subdirectories anyOne subdirectories
								detect: [:each | each theName = 'instance']) files size)! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:42'!
testCountOfCommitedElements02

	| svnPro1 svnPro2 projectName |
	self willTouchFileSystem. self flag: #TODO. "No need to write to disk..."
	projectName := 'TestPro'.
	
	svnPro1 := SVNProject named: projectName.
	svnPro1 directory: (SVNDirectory on: self pathForTests , projectName).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 store.
	
	svnPro2 := SVNProject named: projectName.
	svnPro2 directory: (SVNDirectory on: self pathForTests , projectName).
	svnPro2 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro2 store.
	
	svnPro1 store.
	svnPro1 store.
	"self assert: svnPro1 = svnPro2."
	self assert: svnPro1 directory = svnPro2 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:48'!
testDeleteAClass

	| projectName svnProject svnClass secondWorkingCopyPath sameProject |
	"Was this test not a bit too complicated?"
	self willNeedRepositoryAndWorkingCopy.
	self flag: #TODO.
	projectName := 'TestPro'.
	svnProject := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath "There was repositoryPath...?"
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	svnClass := SVNClass forExistingClass: self createSimpleDummyClassForSVNProjectTest.
	svnProject
		addSVNClass: svnClass;
		commit;
		removeSVNClass: svnClass;	"exercise"
		commit.
	
	"Is the class really deleted?"
	secondWorkingCopyPath := self workingCopyPath, '2'.

	sameProject := SVNProject
		checkoutProject: projectName
		fromURL: self repositoryURLPath
		inWorkingCopy:  (SVNDirectory on: secondWorkingCopyPath).
	self assert: sameProject versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'test 4/1/2008 13:41'!
testStoringOfInstanceVariables

	| class svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	svnPro1 checkout.
	svnPro1 load.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i1 i2'.
	svnPro1 commit.
	class := nil.
	"self halt."
	svnPro1 checkout.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i3'.
	svnPro1 commit.
	svnPro1 checkout.! !

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 02:08'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject theName).! !

!SVNProjectTest methodsFor: 'running' stamp: 'rt 3/17/2008 12:43'!
setUp

	super setUp.
	
	self willNeedSimpleTestClass: false! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:07'!
simpleTestClass

	self willNeedSimpleTestClass ifFalse: [
		self deny: (Smalltalk hasClassNamed: self simpleTestClassName).
		needsTestClass := true.
		Object
			subclass: self simpleTestClassName asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self class category asString].
	^ (Smalltalk classNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:02'!
simpleTestClassName

	^'SimpleTestClass'! !

!SVNProjectTest methodsFor: 'running' stamp: 'rkrk 4/15/2008 02:41'!
tearDown

	super tearDown.
	
	(Smalltalk hasClassNamed: self simpleTestClassName)
		ifTrue:[(Smalltalk classNamed: self simpleTestClassName) removeFromSystemUnlogged]! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:47'!
testAddCategory

	| classesOfCategory result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	sut addCategory: 'SqueakSVN-TestCategory'.
	classesOfCategory := {
		SVNClass forExistingClass: Class1.
		SVNClass forExistingClass: Class2.
		SVNClass forExistingClass: Class3.} asSet.
	result := sut versionedClasses.
	self assert: result = classesOfCategory asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:48'!
testAddClass

	| aClass methodsOfClass result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := (aClass methodDict collect: [:ea | SVNMethod forExistingMethod: ea ])
						union: (aClass class methodDict collect: [:ea | SVNMethod forExistingMethod: ea ]).
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:49'!
testAddClassWhenClassAlreadyExist

	| aClass svnClass svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	svnClass := SVNClass forExistingClass: aClass.
	svnMethod := svnClass versionedMethods detect: [:ea | (ea theName = 'm2') and: [ea nameOfClass asSymbol = svnClass theName]].
	svnClass removeSVNMethod: svnMethod.
	sut addSVNClass: svnClass.
	self assert: sut versionedClasses size = 1.
	self assert: (sut versionedClasses someElement versionedMethods noneSatisfy: [:ea | ea theName = 'm2']).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'cop 4/24/2008 15:06'!
testAddClassWhenMethodAllreadyAdded

	| aClass aMethod|
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	sut addClass: aClass.
	self assert: sut versionedMethods size = 0.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:50'!
testAddMethod

	| aMethod svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod nameOfClass = aMethod methodReference actualClass name.
	self assert: svnMethod methodSelector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/27/2008 05:16'!
testAllVersionedMethodsShouldNotModifyVersionedMethods

	| numberOfClassMethods |
	sut := SVNProject named: 'TestPro'.
	sut
		addSvnMethod: SVNMethod new;
		addClass: self svnDummy.
	numberOfClassMethods := self svnDummy selectors size + self svnDummy class selectors size.
	self assert: sut versionedMethods size = 1.
	self assert: sut versionedClasses anyOne versionedMethods size = numberOfClassMethods.
	"exercise and assert"
	self assert: sut allVersionedMethods size = (numberOfClassMethods + 1).
	self assert: sut versionedClasses anyOne versionedMethods size = numberOfClassMethods.
	self assert: sut versionedMethods size = 1.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/25/2008 14:37'!
testClassDeleted

	self
		willNeedSimpleTestClass: true;
		willNeedRegistry.
	sut := SVNProject named: 'test'.
	self svnRegistry addSvnProject: sut.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	
	self simpleTestClass removeFromSystem.

	self assert: (sut versionedClasses size = 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:44'!
testClassLoading

	| file |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
		
	sut := SVNProject
		checkoutProject: 'MyPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: self defaultSVNDirectory.
	
	sut
		addClass: self svnDummy;
		commit;
		checkout;
		load.
	
	self deny: self svnDummy isNil.
	self deny: self svnDummy class isObsolete.
	self deny: sut versionedClasses size = 0.
	self deny: sut versionedClasses someElement directory isNil.
	file := sut versionedClasses someElement versionedMethods someElement file.
	self assert: ((FileDirectory on: file basePath) fileExists: file filename).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:11'!
testDeleteClass

	self willNeedSimpleTestClass: true.
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	sut deleteClass: self simpleTestClass.
	self deny: (sut versionedClasses size ~= 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'pe 4/17/2008 15:35'!
testDeleteMethod

	self willNeedSimpleTestClass: true.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	sut deleteMethod: (self simpleTestClass compiledMethodAt: #m1).
	self deny: (sut versionedMethods size ~= 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 18:01'!
testDirectoryEntryWasCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:10'!
testMappingToFileSystem01

	self willTouchFileSystem.
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	sut store.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/25/2008 14:37'!
testMethodDeleted

	self
		willNeedSimpleTestClass: true;
		willNeedRegistry.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	self svnRegistry addSvnProject: sut.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	
	self simpleTestClass removeSelector: #m1.
	
	self assert: (sut versionedMethods size = 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 16:50'!
testProjectDirectoryShouldBeCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:03'!
testRemoveClass

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addClass: self svnDummy.
	self assert: (sut versionedClasses size = 1).
	sut removeClass: self svnDummy.
	self deny: (sut versionedClasses size ~= 0).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveMethod

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods size = 1).
	sut removeMethod: (self svnDummy compiledMethodAt: #m2).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveSVNClass

	| svnClass |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnClass := SVNClass forExistingClass: self svnDummy.
	sut addSVNClass: svnClass.
	self assert: (sut versionedClasses includes: svnClass).
	sut removeSVNClass: svnClass.
	self deny: (sut versionedClasses includes: svnClass).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 03:25'!
testRemoveSVNClassAlsoRemovesClassDirectoryWhenVersioned

	| svnClass |
	"(self selector: #testRemoveSVNClassAlsoRemovesClassDirectoryWhenVersioned) run"
	self willNeedRepositoryAndWorkingCopy.
	sut := self createSvnProjectWithSvnDummy.
	svnClass := sut versionedClasses anyOne. "There is only one"
	self defaultSVNDirectory addSubdirectory: sut directory.
	sut store.
	sut removeSVNClass: svnClass.
	self denyThatFiles: {svnClass theName} existsIn: sut directory path.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:53'!
testRemoveSVNMethod

	| svnMethod |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnMethod := SVNMethod forExistingMethod: (self svnDummy compiledMethodAt: #m2).

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods includes: svnMethod).
	sut removeSVNMethod: svnMethod.
	self deny: (sut versionedMethods includes: svnMethod).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:02'!
testRestore

	| projectName class sut2 |
	self willNeedRepositoryAndWorkingCopy.
	class := self svnDummy.
	projectName := 'SomeSVNProject'.
	sut2 := SVNProject named: projectName.
	sut2 directory: (self defaultSVNDirectory createSubDirectoryNamed: projectName).
	sut2 addClass: class.
	sut2 store.
	
	sut := SVNProject restoreFrom: (sut2 directory).
	self assert: sut theName = projectName.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: class)).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:04'!
testRestoreOfNoLongerExistingClassesWillDeleteThem

	"(self selector: #testRestoreOfNoLongerExistingClassesWillDeleteThem) run"
	self
		willModifySVNDummy;
		willNeedRepositoryAndWorkingCopy.
	sut := self createSvnProjectWithSvnDummy.
	self assert: sut versionedClasses size = 1.
	sut store.
	"Delete the directory of SVNDummy"
	(FileDirectory on: sut versionedClasses anyOne directory path) deleteRecursivelyPlatformIndependent.
	sut restore.
	self assert: sut versionedClasses size = 0.
	sut store.
	self denyThatFiles: {self svnDummy name} existsIn: sut directory path.
	"sut load.
	self assert: self svnDummy isNil."! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 01:40'!
testShouldGetProjectDirectoryfromWorkingcopyDirectory

	| projectName expectedProjectDir workingCopyDir |
	projectName := 'SVNProject123'.
	workingCopyDir := self defaultSVNDirectory.
	sut := SVNProject named: projectName.
	sut directory: (workingCopyDir createSubDirectoryNamed: projectName).
	
	"workingCopyDir read."
	expectedProjectDir := (workingCopyDir getSubDirectoryNamed: projectName).
	self assert: sut directory = expectedProjectDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:09'!
testStatusProjectMethods

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNProject named: 'TestPro'.
	sut directory: self defaultSVNDirectory.
	sut store.
	sut directory store.
	sut commit.
	sut addMethod: self svnDummy >> #m1.
	sut store.
	sut directory store.
	self assert: sut statusProjectMethods = #modified.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 00:49'!
testUpdateProjectToPreviousRevision

	self willNeedRepositoryAndWorkingCopy.
	sut := self createEmptySvnProject.
	sut store; commit.
	sut addClass: self svnDummy.
	sut store; commit.
	self assertThatFiles: {self svnDummy name asString} existsIn: sut directory path.
	self assert: sut versionedClasses size = 1.
	sut updateToRevision: (SVNRevision number: 1).
	self denyThatFiles: {self svnDummy name asString} existsIn: sut directory path.
	self assert: sut versionedClasses size = 0.! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 12:50'!
willNeedSimpleTestClass
	
	^ needsTestClass! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:03'!
willNeedSimpleTestClass: bool

	needsTestClass := false.
	bool ifTrue:	[self simpleTestClass].! !

SVNTestCase subclass: #SVNPropertiesRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNPropertiesRequestTest methodsFor: 'running' stamp: 'rt 4/17/2008 18:51'!
setUp

	super setUp.
	
	sut := SVNPropertiesRequest new.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:03'!
testConverting

	| collection dict |
	collection := (sut forPrimitiveGetArrayOfSize: 2) asOrderedCollection.
	collection at: 1 put: ( ('key' , collection first) copyFrom: 1 to: 1024 ).
	collection at: 2 put: ( ('value' , collection second) copyFrom: 1 to: 1024 ).
	
	self deny: collection first = 'key'.
	self deny: collection second = 'value'.
	
	dict := sut dictionaryFromArray: collection asArray.
	self assert: dict keys size = 1.
	self assert: (dict at: 'key') = 'value'.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/23/2008 19:18'!
testCountOfPropertiesOfNonVersionedTarget

	| arrayForCount |
	self willTouchFileSystem.
	arrayForCount := {nil}.
	sut
		basicSvnGetCountOfPropertiesOf: self pathForTests pathForSvn
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/23/2008 19:19'!
testCountOfPropertiesOfNotExistingTarget

	| arrayForCount |
	arrayForCount := {nil}.
	sut
		basicSvnGetCountOfPropertiesOf: 'neverExistingPath'
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/23/2008 19:20'!
testCountOfPropertiesOfTargetWithProperties

	| path client arrayForCount |
	self willNeedRepositoryAndWorkingCopy.
	path := self workingCopyPath.
	client := SVNCApiClient new.
	arrayForCount := {nil}.
	
	client svnAddProperty: 'key' WithValue: 'value' To: path.
	client svnAddProperty: 'key2' WithValue: '' To: path.
	
	sut
		basicSvnGetCountOfPropertiesOf: path pathForSvn
		storeCountIn: arrayForCount.
	self assert: 2 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/23/2008 19:20'!
testCountOfPropertiesOfTargetWithoutProperties

	| arrayForCount |
	arrayForCount := {nil}.
	self willNeedRepositoryAndWorkingCopy.
	
	sut
		basicSvnGetCountOfPropertiesOf: self workingCopyPath pathForSvn
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:27'!
testPropertiesOfNonVersionedTarget

	self willTouchFileSystem.
	sut
		target: self pathForTests;
		execute.
	self assert: sut properties isEmpty! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:25'!
testPropertiesOfNotExistingTarget

	sut
		target: 'neverExistingPath';
		execute.
	self assert: sut properties isEmpty! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:31'!
testPropertiesOfTargetWithProperties

	| path client |
	self willNeedRepositoryAndWorkingCopy.
	path := self workingCopyPath.
	client := SVNCApiClient new.
	
	client svnAddProperty: 'key' WithValue: 'value' To: path.
	client svnAddProperty: 'key2' WithValue: '' To: path.
	
	sut
		target: path;
		execute.

	self assert: sut properties keys size = 2.
	self assert: (sut properties at: 'key') = 'value'.
	self assert: (sut properties at: 'key2') = ''.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:28'!
testPropertiesOfTargetWithoutProperties

	self willNeedRepositoryAndWorkingCopy.
	sut
		target: self workingCopyPath;
		execute.
	self assert: sut properties isEmpty! !

SVNTestCase subclass: #SVNRegistryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
compileMethodNamed: methodSelector	inCategory: aString andClass: aClass
	
	aClass
		compile: methodSelector asString
		classified: aString.! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/25/2008 09:24'!
createRegistryWithProjectAndSvnDummy
	
	| svnProject |
	svnProject := self createEmptySvnProject .
	svnProject addClass: self svnDummy.
	^ SVNRegistry new
		addSvnProject: svnProject;
		yourself.! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
defaultMethodSelector

	^ #methodForNotifyTest! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
newSourceForSVNDummyM2

	^ 'm2
	^ 1984 sqrt'! !

!SVNRegistryTest methodsFor: 'running' stamp: 'rkrk 4/24/2008 11:58'!
tearDown

	super tearDown.
	sut ifNotNil: [sut notifyAboutSystemChanges: false].
	(self svnDummy methodDict anySatisfy: [:ea | ea selector = self defaultMethodSelector])
		ifTrue: [self svnDummy removeSelector: self defaultMethodSelector].! !

!SVNRegistryTest methodsFor: 'tests' stamp: 'rkrk 4/24/2008 13:07'!
testEnvironmentCreation

	| svnProject1 svnProject2 environment |
	sut := SVNRegistry new.
	svnProject1 := SVNProject named: 'pro1'.
	svnProject2 := SVNProject named: 'pro2'.
	sut
		addSvnProject: svnProject1;
		addSvnProject: svnProject2.
	
	environment := sut createSvnEnvironment.
	self assert: environment svnProjects size = 2.
	self assert: (environment svnProjects includes: svnProject1).
	self assert: (environment svnProjects includes: svnProject2).! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:27'!
testNotifyMethodModification

	"prepare"
	| svnClass svnMethod numberOfMethodsInClass numberOfMethodsInClassInSvnClass svnProject |
	self
		willModifySVNDummy;
		willNeedRegistry.

	svnProject := SVNProject named: 'ProjForRegistryTest'.
	svnProject addClass: self svnDummy.
	sut := self svnRegistry.
	sut addSvnProject: svnProject.
	
	"exercise"
	self svnDummy compile: self newSourceForSVNDummyM2.

	"assertion"	
	svnMethod := sut findSvnMethodNamed: #m2.
	self assert: svnMethod source = self newSourceForSVNDummyM2.
	
	"Are all methods of the class verioned?"
	svnClass := sut findSvnProjectOrSvnClassForSvnMethod: svnMethod.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:33'!
testNotifyMethodProtocolModification

	"prepare"
	| svnMethod numberOfMethodsInClass svnClass numberOfMethodsInClassInSvnClass |
	self
		willModifySVNDummy;
		willNeedRegistry.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self  svnRegistry.
	sut addSvnProject: self createSvnProjectWithSvnDummy.
	
	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'changedMethodCategory'
		andClass: self svnDummy.
		
	"exercise"
	svnMethod := sut findSvnMethodForMethod: (self svnDummy >> self defaultMethodSelector).
	self assert: svnMethod category = 'changedMethodCategory'.
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:34'!
testNotifyMethodRemoving

	| method svnClass numberOfMethodsInClass numberOfMethodsInClassInSvnClass |
	self
		willNeedRegistry;
		willModifySVNDummy.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self svnRegistry.
	sut addSvnProject: self createSvnProjectWithSvnDummy.
	
	method := self svnDummy >> self defaultMethodSelector.
	self assert: (sut includes: method).
	self svnDummy removeSelector: self defaultMethodSelector.
	self deny: (sut includes: method).
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:02'!
testRegistryCreatesEnvironmentWithItsProjects

	self willNeedRegistry.
	
	self assert: self svnRegistry svnProjects isEmpty.
	self svnEnvironment addSvnProject: (SVNProject named: 'ABC').
	self assert: self svnRegistry svnProjects size = 1.! !

SVNTestCase subclass: #SVNRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNRepositoryTest subclass: #SVNRepositoryExternalTest
	instanceVariableNames: 'username password url pathOfWorkingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRepositoryExternalTest methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 02:49'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopyWithRestrictedAccess! !

!SVNRepositoryExternalTest methodsFor: 'running' stamp: 'rt 4/24/2008 17:29'!
tearDown

	(SVNAuthenticationRequest onUsername: '' andPassword: '') execute.
	^ super tearDown! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 02:50'!
testTryToAccessProtectedRepositoryWithUnValidKey

	self setUsername: 'validUser'.
	self setPassword: 'validKey'.
	
	(SVNAuthenticationRequest onUsername: 'invaildUser' andPassword: 'invalidKey') execute.
	
	self deny: (SVNRepository new
		primitiveProject: 'aName'
		onRepository: self repositoryURLPath
		exists: {nil}) = 0.! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 03:45'!
testTryToAccessProtectedRepositoryWithValidKey

	(SVNAuthenticationRequest
		onUsername: self getUsername
		andPassword: self getPassword) execute.
	
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 02:52'!
testWillNeedsAPassword

	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut requiresAuthentication.! !

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 4/21/2008 19:33'!
createTestProjectNamed: aString in: anURL

	(SVNRepository on: anURL) createProject: aString! !

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 3/30/2008 19:43'!
nameOfTestProject
	^'TestProject'! !

!SVNRepositoryTest methodsFor: 'running' stamp: 'rt 4/9/2008 00:54'!
tearDown

	(self directoryManager currentDirectory notNil and:
		[self directoryManager currentDirectory isSvnAware])
			ifTrue: [(SVNCApiClient new) svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath)].
	
	^ super tearDown! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/24/2008 13:07'!
testAccessingUnprotectedRepository

	self willNeedRepositoryAndWorkingCopy.
	
	(SVNAuthenticationRequest onUsername: '' andPassword: '') execute.
	
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 3/30/2008 19:41'!
testCheckForExistingProject

	self willNeedRepositoryAndWorkingCopy.
	self createTestProjectNamed: self nameOfTestProject in: self repositoryURLPath.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:55'!
testCheckForNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self deny: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:57'!
testCreateExistingProject

	self willNeedRepositoryAndWorkingCopy.

	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:21'!
testCreateNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/24/2008 15:52'!
testCreateValidRepository

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut notNil.! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:19'!
testDoNotCreateUnvalidRepository

	sut := SVNRepository on: 'noValidUrl'.
	self assert: sut isNil.! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/8/2008 13:14'!
testNoPasswordRequired

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut requiresAuthentication not.! !

SVNTestCase subclass: #SVNRevisionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:36'!
testBase

	sut := SVNRevision base.
	self assert: sut kindSymbol = #base.
	self assert: sut kind = 5.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:52'!
testForSvnPrimitive01

	| expected result |
	sut := SVNRevision head.
	expected := {sut kind. nil} asOrderedCollection.
	result := sut forSvnPrimitive.
	self assert: expected = result.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:52'!
testForSvnPrimitive02

	| expected |
	sut := SVNRevision number: 30.
	expected := {sut kind. 30} asOrderedCollection.
	self assert: expected = sut forSvnPrimitive.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testHead

	sut := SVNRevision head.
	self assert: sut kindSymbol = #head.
	self assert: sut kind = 7.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:01'!
testNoNew

	self should: [SVNRevision new] raise: Error.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:09'!
testNumber

	sut := SVNRevision number: 10.
	self shouldnt: [sut number] raise: AssertionFailure.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 02:55'!
testNumberOnlyWhenCorrectlyInitialized

	sut := SVNRevision unspecified.
	self assert: sut number = nil.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:27'!
testSetsShouldBeEqual

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self assert: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual01

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 20. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual02

	| set1 set2 |
	set1 := {SVNRevision working. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:18'!
testShouldBeEqualIfNumberIsEqual

	| sut1 sut2 |
	sut1 := SVNRevision number: 10.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self assert: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:24'!
testShouldBeEqualIfSameKind

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut2 := SVNRevision head.
	self assert: sut1 = sut2..
	
	sut1 := SVNRevision base.
	sut2 := SVNRevision base.
	self assert: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfKindIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision working.
	sut2 := SVNRevision head.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfNumberIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut1 number: 8.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testUnspecified

	sut := SVNRevision unspecified.
	self assert: sut kindSymbol = #unspecified.
	self assert: sut kind = 0.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:38'!
testWorking

	sut := SVNRevision working.
	self assert: sut kindSymbol = #working.
	self assert: sut kind = 6.! !

SVNTestCase subclass: #SVNStatusRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNStatusRequestTest methodsFor: 'helper' stamp: 'mu 4/21/2008 14:21'!
addTestFile: aFile to: aDirectory
	| file |
	file := self svnDirectoryForWorkingCopy
		createFileNamed: aFile.
	aDirectory addFile: file.
	! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:41'!
testHighestStatusOfItems

	| svnFile svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'testFile2'.
	svnDir addFile: svnFile.
	svnDir
		store;
		commit.
	svnFile
		content: 'abc';
		store.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfAddedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #added.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 14:25'!
testStatusOfAddedItemRecursive

	| svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	self addTestFile: 'testFile2' to: svnDir.
	svnDir
		store.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #added.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfCommitedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #normal.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 14:26'!
testStatusOfCommitedItemRecursive

	| svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #normal.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfItemNotInWorkingcopy

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named: 'fileName123456789'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'test 4/21/2008 13:07'!
testStatusOfItemNotInWorkingcopyRecursive

	| svnFile svnDir path|
	self willTouchFileSystem.
	path := self
		createDirNamed: 'testDir'
		in: self pathForTests.
	svnDir := SVNDirectory on: path.
	
	svnFile := SVNFile
		named: 'fileName123456789'
		basePath: self pathForTests.
	svnDir addFile: svnFile.
	svnDir store.
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfModifiedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit;
		content: 'abc';
		store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 12:59'!
testStatusOfModifiedItemRecursive

	| svnFile svnDir path|
	self willNeedRepositoryAndWorkingCopy.
	path := self
		createDirNamed: 'testDir'
		in: self workingCopyPath.
	svnDir := SVNDirectory on: path.
	
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnDir addFile: svnFile.
	svnDir
		store;
		commit.
	svnFile
		content: 'abc';
		store.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfUnversionedItem

	| path svnDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory entry. Cannot use store here
	because store automatically adds the entry to thw WC."
	path := self
		createDirNamed: 'shouldNotBeAdded'
		in: self workingCopyPath.
	svnDir := SVNDirectory on: path.
	sut := SVNStatusRequest target: svnDir isRecursive: false.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 3/15/2008 05:30'!
assertFile: fileName wasSVNAddedIn: path 

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: path , self slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName)! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 23:48'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent 

	| fullPath actualContent |
	fullPath := self pathTo: fileName inDir: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:45'!
assertThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames allSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'helper' stamp: 'mu 4/23/2008 13:53'!
classClass
	^ 'class'! !

!SVNTestCase methodsFor: 'helper' stamp: 'mu 4/23/2008 13:53'!
classInstance
	^ 'instance'! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/26/2008 16:44'!
cleanupSVNDummy

	self hasModifiedSVNDummy ifFalse: [^ self].
	self flag: #TODO. "Full restore?"
	self svnDummy ifNotNil: [self svnDummy removeFromSystemUnlogged].
	self restoreSVNDummy.
	"((self svnDummy methodDict includesKey: #m2)
		and: [(self svnDummy >> #m2) getSource asString = self sourceCodeForSVNDummyM2])
			ifFalse: [self svnDummy compile: self sourceCodeForSVNDummyM2]."! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 01:54'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'running' stamp: 'mu 4/23/2008 13:31'!
createDummyClassForTests
	^ SVNClass forExistingClass: self svnDummy! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 4/23/2008 09:35'!
createEmptyEnvironment

	^ SVNEnvironment forSvnProjects: Set new.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 4/25/2008 14:31'!
createEmptySvnProject

	| proj |
	proj := SVNProject named: 'ProjectForSVNTest'.
	self defaultSVNDirectory addSubdirectory: proj directory.
	^ proj! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 4/25/2008 14:42'!
createEnvironmentWithCurrentProjectAndSvnDummy

	| env |
	env := self createEnvironmentWithEmptyProject.
	env svnProjects anyOne addClass: self svnDummy.
	^ env! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 4/25/2008 14:43'!
createEnvironmentWithEmptyProject
	
	| svnProject |
	svnProject := self createEmptySvnProject.
	^ self createEmptyEnvironment
		addSvnProject: svnProject;
		currentProject: svnProject;
		yourself.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 4/25/2008 14:31'!
createSvnProjectWithSvnDummy

	^ self createEmptySvnProject
		addClass: self svnDummy;
		yourself.! !

!SVNTestCase methodsFor: 'debugging' stamp: 'rkrk 3/20/2008 03:42'!
debugExpected: expected result: result

	expected = result ifTrue: [^ self].
	Transcript
		show: 'expected: ';
		show: expected asString;
		cr;
		show: 'result';
		show: result asString;
		cr.
	self halt.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 02:30'!
defaultSVNDirectory
	
	^ SVNDirectory on: self pathForTests! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:46'!
denyThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames noneSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager
	^ directoryManager! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager: anObject
	directoryManager := anObject! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 03:27'!
getPassword

	^ self directoryManager getPassword! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 03:27'!
getUsername

	^ self directoryManager getUsername! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy
	^ hasModifiedSVNDummy! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy: anObject
	hasModifiedSVNDummy := anObject! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 02:53'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.! !

!SVNTestCase methodsFor: 'initialization' stamp: 'rkrk 3/15/2008 04:21'!
initialize

	super initialize.
	self slash: FileDirectory slash.! !

!SVNTestCase methodsFor: 'logging' stamp: 'rt 4/15/2008 19:46'!
logCurrentTest

	SqueakSVNPluginCaller primWriteOutText: '### ' , testSelector asString , ' ###'.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 4/23/2008 17:14'!
methodRefOfSvnDummyM2

	^ (self svnDummy >> #m2) methodReference.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:53'!
pathForTests

	^ self directoryManager pathForTests.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/24/2008 23:45'!
pathTo: filename inDir: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:54'!
repositoryURLPath

	^ self directoryManager repositoryURLPath! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 4/26/2008 16:46'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout. You can use
	e.g. printIt: [FileStream readOnlyFileNamed: 'SVNDummy.st' do: [:stream | stream contents]]
	after doing a fileout"
	"do it: [self new restoreSVNDummy]."
	| stream |
	stream :=  ReadWriteStream with:  '''From Squeak3.9.1 of 2 March 2008 [latest update: #7075] on 14 April 2008 at 10:36:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!


!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 3/14/2008 02:25''!!
< other

	^ super < other!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:22''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	self flag: #TODO.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:40'!
setPassword: aString

	self directoryManager setPassword: aString! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 03:59'!
setUp

	"[SVNTestDirectoryManager instance: nil]"
	super setUp.
	self hasModifiedSVNDummy: false.
	self directoryManager: SVNTestDirectoryManager getInstance.
	self directoryManager testDirectories ifEmpty: [
		self directoryManager
			basePath: (FileDirectory default directoryNamed: 'svnTests') pathName;
			createBasicTestDirs: 200 svnAwareTestDirs: 50].
	SqueakSVNPluginCaller primWriteOutText: self selector asString.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:40'!
setUsername: aString

	self directoryManager setUsername: aString! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 04:22'!
slash

	^ slash! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:23'!
slash: string

	slash := string! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:01'!
sourceCodeForSVNDummyM2

	^ 'm2
	^ 2'! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:35'!
stopAccessToRepository

	(self directoryManager currentDirectory isKindOf: SVNRestrictedTestDirectory)
		ifTrue: [self directoryManager stopAccessToRepository]! !

!SVNTestCase methodsFor: 'svn helper' stamp: 'rkrk 3/4/2008 00:58'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy2
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath2.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:07'!
svnDummy

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy'.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'mu 3/4/2008 11:20'!
svnDummy99

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy99'.! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 4/25/2008 13:58'!
svnEnvironment

	^ self svnRegistry createSvnEnvironment.! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 13:58'!
svnRegistry
	^ svnRegistry! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 13:58'!
svnRegistry: anObject
	svnRegistry := anObject! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:35'!
tearDown

	super tearDown.
	self
		"cleanupFileSystem;"
		cleanupSVNDummy;
		"stop external process"
		stopAccessToRepository.
	self directoryManager unregister.
	
	"Quick fix until old system notfication mechanism is fully abandoned"
	self svnRegistry ifNotNil: [
		SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self svnRegistry.
		self svnRegistry: nil].
	
	SVNRegistry allInstances do: [:ea | ea notifyAboutSystemChanges: false].! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/4/2008 02:29'!
willModifySVNDummy

	self hasModifiedSVNDummy: true.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/25/2008 13:08'!
willNeedRegistry

	self svnRegistry: (SVNRegistry forSvnProjects: Set new).! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/3/2008 01:51'!
willNeedRepositoryAndTwoWorkingCopies

	self directoryManager registerForSvnAwareTestDirectoryWithTwoWorkingCopies.! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:45'!
willNeedRepositoryAndTwoWorkingCopiesWithRestrictedAccess

	self directoryManager registerForSvnRestrictedTestDirectoryWithTwoWorkingCopies.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/15/2008 01:56'!
willNeedRepositoryAndWorkingCopy

	self directoryManager registerForSvnAwareTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:44'!
willNeedRepositoryAndWorkingCopyWithRestrictedAccess

	self directoryManager registerForSvnRestrictedTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'test 3/16/2008 03:02'!
willTouchFileSystem
	
	self flag: #TODO.
	self directoryManager registerForTestDirectory.
	"do nothing? directoryManager already has a new
	current directory because of #unregister"
	"self directoryManager registerForTestDirectory."! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'test 3/15/2008 04:34'!
workingCopyPath

	^ self directoryManager workingCopyPath! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 03:13'!
workingCopyPath2

	^ self directoryManager workingCopyPath2! !

SVNTestCase subclass: #SVNUpdateRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

SVNUpdateRequestTest subclass: #SVNConflictUpdateRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:35'!
testDoSimpleUpdate

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		update;
		read.
	self assert: file content = content.
	! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 00:47'!
testDoSimpleUpdateOfDeletedFile

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		delete.
	self
		denyThatFiles: {file path}
		existsIn: file basePath.
	self defaultSVNDirectory update.
	self
		assertThatFiles: {file path}
		existsIn: file basePath.
	file read.
	self assert: file content = content.
	! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'cop 4/28/2008 13:00'!
testDoUpdateWithTwoWCsAndLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	"self assert: fileInFirstWC content = changedContent2."! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'cop 4/28/2008 13:03'!
testDoUpdateWithTwoWCsAndWithoutLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"check if anything is fine"
	fileInFirstWC
		update;
		read.
	self assert: fileInFirstWC content = changedContent.
	self assert: fileInFirstWC status isNormal.! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:33'!
testLocalChangesShouldStayAfterUpdate

	| file originalContent newContent |
	self willNeedRepositoryAndWorkingCopy.
	originalContent := 'ABCabcXYZxyz'.
	newContent := 'Changed content'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self workingCopyPath.
	file
		content: originalContent;
		store;
		commit;
		content: newContent;
		store;
		update;
		read.
	self assert: file content = newContent.! !

!SVNUpdateRequestTest methodsFor: 'assertion' stamp: 'rkrk 4/27/2008 16:26'!
assertSvnDirEntry: svnDirectoryEntry hasRevision: aNumber

	| svnInfo |
	svnInfo := (SVNInfoRequest
		target: svnDirectoryEntry
		forRevision: SVNRevision working).
	svnInfo execute.
	self assert: svnInfo revision number = aNumber.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/27/2008 16:25'!
testUpdateBeNotRecursive

	| svnDirectory svnSubDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory and a subDirectory. Commit so that both have revision 2.
	Update the directory to revision 1. The subdirectory should still have revision 2"
	svnDirectory := self defaultSVNDirectory createSubDirectoryNamed: 'dirCreatedInUpdateRequestTest'.
	svnSubDir := svnDirectory createSubDirectoryNamed: 'subDirCreatedInUpdateRequestTest'.
	svnDirectory
		store;
		commit.
	"Change things so that commit works"
	svnDirectory properties at: 'bla' put: 'blupf'.
	svnSubDir properties at: 'bla2' put: 'blupf2'.
	svnDirectory
		store;
		commit;
		read.
	self assertSvnDirEntry: svnDirectory hasRevision: 2.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.
	sut := SVNUpdateRequest
		target: svnDirectory
		updateToRevision: (SVNRevision number: 1)
		beRecursive: false.
	sut execute.
	self assertSvnDirEntry: svnDirectory hasRevision: 1.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/27/2008 16:28'!
testUpdateBeRecursive

	| svnDirectory svnSubDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory and a subDirectory. Commit so that both have revision 2.
	Update the directory to revision 1. The subdirectory should now also have revision 1"
	svnDirectory := self defaultSVNDirectory createSubDirectoryNamed: 'dirCreatedInUpdateRequestTest'.
	svnSubDir := svnDirectory createSubDirectoryNamed: 'subDirCreatedInUpdateRequestTest'.
	svnDirectory
		store;
		commit.
	"Change things so that commit works"
	svnDirectory properties at: 'bla' put: 'blupf'.
	svnSubDir properties at: 'bla2' put: 'blupf2'.
	svnDirectory
		store;
		commit;
		read.
	self assertSvnDirEntry: svnDirectory hasRevision: 2.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.
	sut := SVNUpdateRequest
		target: svnDirectory
		updateToRevision: (SVNRevision number: 1)
		beRecursive: true.
	sut execute.
	self assertSvnDirEntry: svnDirectory hasRevision: 1.
	self assertSvnDirEntry: svnSubDir hasRevision: 1.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/27/2008 16:27'!
testUpdateFileOfRevision2ToRevision1

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory
		createFileNamed: 'fileCreatedInUpdateRequestTest'
		withContent: 'rev1'.
	svnFile
		store;
		commit;
		content: 'rev2';
		store;
		commit;
		read.
	self assert: svnFile content = 'rev2'.
	sut := SVNUpdateRequest
		target: svnFile
		updateToRevision: (SVNRevision number: 1)
		beRecursive: false.
	sut execute.
	svnFile read.
	self assertSvnDirEntry: svnFile hasRevision: 1.
	self assert: svnFile content = 'rev1'.! !

TestCase subclass: #SVNTestDirectoryManagerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNTestDirectoryManagerTest methodsFor: 'default' stamp: 'rkrk 3/15/2008 00:27'!
pathForManager

	^ (FileDirectory default directoryNamed: 'TestManagerTestDir') pathName! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:33'!
setUp
	super setUp.
	"SVNTestDirectoryManager is a singleton. For tests get own copy"
	sut := SVNTestDirectoryManager basicNew initialize.
	sut basePath: self pathForManager.! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:34'!
tearDown
	
	super tearDown.
	sut clear.
	(FileDirectory on: self pathForManager) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:42'!
testAccessingWorkingCopy2WithoutRegisteringShouldFail

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectory.
	self should: [sut workingCopyPath2] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:58'!
testAfterRegisterAnswerSameDirectory

	| directory |
	sut
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	sut registerForTestDirectory.
	directory := sut currentDirectory.
	self assert: directory notNil.
	self assert: sut pathForTests = directory pathForTests.
	self assert: sut currentDirectory == directory.
	sut unregister.
	self deny: sut currentDirectory == directory.
	"self should: [sut pathForTests] raise: AssertionFailure"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:59'!
testCallingSvnAwareMethods

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 3.
	sut registerForSvnAwareTestDirectory.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:43'!
testCallingSvnAwareMethodsWithWorkingCopy2

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectoryWithTwoWorkingCopies.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut workingCopyPath2 = sut currentDirectory workingCopyPath2.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:01'!
testCallingSvnAwareMethodsWithoutProperRegisteringShouldFail

	sut
		createBasicTestDirs: 2
		svnAwareTestDirs: 1.
	sut registerForTestDirectory.
	self should: [sut workingCopyPath] raise: AssertionFailure.
	self should: [sut repositoryURLPath] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 06:28'!
testCreateAgainShouldUseAlreadyExistingDirectories

	| someElement |
	sut 
		createBasicTestDirs: 3
		svnAwareTestDirs: 0.
	someElement := sut testDirectories anyOne.
	sut 
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	self assert: sut basicTestDirectories size = 5.
	self assert: (sut testDirectories includes: someElement).! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/18/2008 23:49'!
testPercent

	self assert: (sut percent: 30 of: 80) = 24.
	self assert: (sut percent: 10 of: 3) = 1. "Be at least one"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:32'!
testRecreate10Percent

	sut 
		createBasicTestDirs: 10
		svnAwareTestDirs: 0.
	5 timesRepeat: [
		sut registerForTestDirectory.
		sut currentDirectory isDirty: true.
		sut unregister].
	sut reCreatePercent: 10.
	self assert: (sut testDirectories count: [:ea | ea isDirty not]) = 6.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:02'!
testRegisteringMoreOftenThanTheDefaultNumberOfPreparedDirectories

	| numberOfTimesToRegister |
	sut createBasicTestDirs: 5 svnAwareTestDirs: 0.
	numberOfTimesToRegister := sut basicTestDirectories size + 3.
	numberOfTimesToRegister timesRepeat: [
		sut registerForTestDirectory.
		self deny: sut currentDirectory isDirty.
		sut currentDirectory isDirty: true.
		sut unregister].! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'test 3/16/2008 06:16'!
testShouldClearOldDirectories

	| sutFileDirectory |
	sut 
		createBasicTestDirs: 20
		svnAwareTestDirs: 0.
	sutFileDirectory := FileDirectory on: sut basePath.
	self assert: sutFileDirectory entries size = 20.
	sut 
		createBasicTestDirs: 12
		svnAwareTestDirs: 0.
	self assert: sutFileDirectory entries size = 12.! !

TestCase subclass: #SVNTestDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

SVNTestDirectoryTest subclass: #SVNAwareTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNAwareTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 20:52'!
setUp
	super setUp.
	sut := SVNAwareTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:24'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:28'!
testCheckConsistency03

	sut 
		create;
		createSecondWorkingCopy.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:11'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:22'!
testCreateDoesNotCreateAutomaticallySecondWorkingCopy

	| directory |
	sut create.
	directory := sut directory.
	self deny: (directory directoryExists: 'workingCopy2').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:48'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:34'!
testCreateWorkingCopy2AndBeDirty

	sut
		create;
		createSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self assert: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:56'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:07'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:55'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

SVNAwareTestDirectoryTest subclass: #SVNRestrictedTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNRestrictedTestDirectoryTest methodsFor: 'running' stamp: 'rt 4/26/2008 21:12'!
setUp
	super setUp.
	sut := SVNRestrictedTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'running' stamp: 'rt 4/26/2008 21:47'!
tearDown

	sut clear.
	super tearDown! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 23:38'!
testChangedUsernameAndPassword

	| directory file newUsername newPassword |
	directory := FileDirectory on: sut repositoryDirectory pathName , FileDirectory slash , 'conf'.
	newUsername := 'usr'.
	newPassword := 'key'.
	
	sut create.
	self deny: sut usernameForRepository = newUsername.
	self deny: sut passwordForRepository = newPassword.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	self deny: (file contents substrings includesAnyOf: {newUsername. newPassword}).
	file close.
	
	sut setUsername: newUsername.	
	sut setPassword: newPassword.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	self assert: (file contents substrings includesAllOf: {newUsername. newPassword}).
	file close.
! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:12'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCheckConsistency03

	sut 
		create;
		createSecondWorkingCopy.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCreateDoesNotCreateAutomaticallySecondWorkingCopy

	| directory |
	sut create.
	directory := sut directory.
	self deny: (directory directoryExists: 'workingCopy2').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/26/2008 21:19'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self deny: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:01'!
testCreateInBasepathAndCheckout

	| directory |
	sut
		create;
		checkoutWorkingCopy.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/26/2008 21:17'!
testCreateWorkingCopy2AndBeDirty

	sut
		create;
		createSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self deny: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:01'!
testCreateWorkingCopy2BeDirtyAndCheckout

	sut
		create;
		createSecondWorkingCopy;
		checkoutSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self assert: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:28'!
testRepositoryConfiguration

	| directory file |
	sut create.
	directory := FileDirectory on: sut repositoryDirectory pathName , FileDirectory slash , 'conf'.
	self assert: directory exists.
	self assert: (directory fileExists: 'svnserve.conf').
	self assert: (directory fileExists: 'passwd').
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'svnserve.conf'.
	self assert: file contents = sut contentOfConfFile.
	file close.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	file close.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/27/2008 06:35'!
testSetRepositoryUrlAndServerRoot

	| repUrl root |
	sut create.
	
	repUrl := 'svn://localhost/forSVNTestDirectoryTest/' , sut directory localName , '/' , sut nameForRepository.
	self assert: repUrl = sut repositoryURLPath.
	
	root := sut directory pathName
		copyFrom: 1
		to: (sut directory pathName size -
			sut directory localName size - 1 -
			'forSVNTestDirectoryTest' size - 1).
	self assert: root = sut serverRoot.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/15/2008 15:57'!
setUp

	super setUp.
	sut := SVNTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNTestDirectoryTest methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:09'!
somePath

	| localName dir |
	localName := 'forSVNTestDirectoryTest'.
	dir := FileDirectory default.
	dir assureExistenceOfPath: localName.
	^ dir pathName , dir slash , localName.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:25'!
tearDown

	super tearDown.
	self flag: #TODO.
	(FileDirectory on: self somePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut directory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testCreateInBasepath

	sut create.
	self deny: sut isDirty.
	self assert: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:05'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:54'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

TestCase subclass: #SVNUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'rt 3/30/2008 21:03'!
testIfEqual

	| sut1 sut2 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User' password: 'password'.
	
	self assert: sut1 = sut2.! !

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'rt 3/30/2008 21:04'!
testIfNotEqual

	| sut1 sut2 sut3 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User2' password: 'password'.
	sut3 := SVNUser user: 'User' password: 'password2'.
	
	self deny: sut1 = sut2.
	self deny: sut1 = sut3.
	self deny: sut2 = sut3.! !

!MethodReference methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self) notNil! !

!CompiledMethod methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self methodReference) notNil! !

Object subclass: #Class1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class1 commentStamp: '<historical>' prior: 0!
A Class1 is xxxxxxxxx.

Instance Variables
!

!Class1 methodsFor: 'as yet unclassified' stamp: 'mu 3/27/2008 18:35'!
nurzumTesten
	^true! !

Object subclass: #Class2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class2 commentStamp: '<historical>' prior: 0!
A Class2 is xxxxxxxxx.

Instance Variables
!

Object subclass: #Class3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class3 commentStamp: '<historical>' prior: 0!
A Class3 is xxxxxxxxx.

Instance Variables
!

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 3/23/2008 01:54'!
forSvnPrimitive

	self error: 'I should not be passed down to a SVN primitive!!'! !

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:13'!
includedInSvnEnvironment: svnEnvironment

	^ false! !

Object subclass: #SVNAuthenticationRequest
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNAuthenticationRequest class methodsFor: 'instance creation' stamp: 'rt 4/21/2008 18:07'!
onUsername: aUsername andPassword: aPassword

	^ self new
		onUsername: aUsername andPassword: aPassword;
		yourself! !

!SVNAuthenticationRequest methodsFor: 'primitive' stamp: 'rt 4/21/2008 18:10'!
basicSetUsernameTo: aUsername andPasswordTo: aPassword

	<primitive: 'authenticateWithNameAndPassword' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNAuthenticationRequest methodsFor: 'execution' stamp: 'rt 4/21/2008 18:14'!
execute

	self basicSetUsernameTo: self username andPasswordTo: self password.! !

!SVNAuthenticationRequest methodsFor: 'initialization' stamp: 'rt 4/21/2008 18:13'!
initialize

	super initialize.
	username := ''.
	password := ''.! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:07'!
onUsername: aUsername andPassword: aPassword

	username := aUsername.
	password := aPassword! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:14'!
password

	^ password! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:14'!
username

	^ username! !

Object subclass: #SVNBlameStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNBlameStyler class methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:44'!
createArrayFromBlameLines: anOrderedCollection
	^self new createArrayFromBlameLines: anOrderedCollection! !

!SVNBlameStyler class methodsFor: 'functionality' stamp: 'cop 3/18/2008 14:04'!
createTextFromBlameLines: anOrderedCollection
	^self new createTextFromBlameLines: anOrderedCollection! !

!SVNBlameStyler methodsFor: 'functionality' stamp: 'cop 4/8/2008 14:12'!
addTo: aTCol from: aSCol startAt: aIndex
	| index |
	index := aIndex.
	[ aTCol add: (aSCol at: index).
	  index := index + 5. ]
		doWhileTrue: [ index <= aSCol size ].! !

!SVNBlameStyler methodsFor: 'functionality' stamp: 'cop 4/10/2008 11:00'!
createArrayFromBlameLines: anOrderedCollection
	| revisionCollection authorCollection lineCollection codeCollection |
	revisionCollection := OrderedCollection new add: 'Revision'; yourself.
	authorCollection := OrderedCollection new add: 'Author'; yourself.
	lineCollection := OrderedCollection new add: 'Line'; yourself.
	codeCollection := OrderedCollection new add: 'Code'; yourself.

	anOrderedCollection isEmpty ifFalse:
		[self addTo: 	revisionCollection from: anOrderedCollection startAt: 1.
		 self addTo: authorCollection from: anOrderedCollection startAt: 2.
		 self addTo: lineCollection from: anOrderedCollection startAt: 4.
		 self addTo: codeCollection from: anOrderedCollection startAt: 5.].
	
	^Array with: revisionCollection asArray with: authorCollection asArray with: lineCollection asArray with: codeCollection asArray.! !

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:43'!
buttonForUnloading

	"self buttonForUnloading"
	(SimpleButtonMorph newWithLabel: 'Unload SqueakSVNPlugin')
		target: self;
		actWhen: #buttonDown;
		actionSelector: #unloadSqueakSVN;
		openInWorld.! !

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:00'!
unloadSqueakSVN

	UIManager default inform: 'Unloading SqueakSVNPlugin'.
	SmalltalkImage current unloadModule: 'SqueakSVNPlugin'.! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 12:56'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/11/2008 12:41'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 15:43'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 13:45'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 12:18'!
basicSvnCleanupDirectory: directoryPath
	<primitive: 'svnCleanupDirectory' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/6/2008 11:04'!
basicSvnCommit: collectionOfPathesToTargets withMessage: aString
 
	<primitive: 'svnCommitWithMessage' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 15:59'!
basicSvnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets

	<primitive: 'svnDeleteTargetsFromWorkingCopy' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 18:53'!
basicSvnGetHeadRevision: pathToTarget storeNumberIn: arrayForNumber

	<primitive: 'svnGetHeadRevisionStoreNumberIn' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 15:18'!
basicSvnResolvedTarget: target
	<primitive: 'svnResolvedTarget' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/19/2008 17:18'!
basicSvnRevertTargets: targets
	<primitive: 'svnRevertTargets' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 4/27/2008 15:57'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionkind: revKind revisionNumber: revisionNumber beRecursive: bool
 
	<primitive: 'svnUpdateTargetsToRevisionKindRevisionNumberBeRecursive' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 4/25/2008 15:50'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | each
			pathForSvn
			forSvnPrimitiveAsString].
	(SVNErrorCatcher on: [self
		basicSvnCommit: commitArray
		withMessage: aString forSvnPrimitiveAsString]) execute! !

!SVNClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:12'!
normalizePath: aString 

	self flag: #TODO. "Find my senders, replace method call an delete me"
	^ aString pathForSvn! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 2/25/2008 11:54'!
svnAdd: aPath 

	^self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/17/2008 19:39'!
svnAddProperty: property WithValue:value To: target

	| propertyToAdd valueToAdd |
	self flag: #TODO. "Make conversion more clear and consider read also"
		"Check for valid key."
	propertyToAdd := property = ''
		ifTrue: ['nil']
		ifFalse: [property].
	valueToAdd := value = ''
		ifTrue: ['']
		ifFalse: [value asString].
	^self
		basicSvnAddProperty: propertyToAdd
		WithValue: valueToAdd
		To: (self normalizePath: target).! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 19:31'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	(SVNErrorCatcher
		on: [self
			basicSvnCheckoutHeadRevisionFrom: (self normalizePath: repositoryURL)
			to: (self normalizePath: workingCopyPath)]) execute! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 19:30'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	(SVNErrorCatcher
		on: [self
			basicSvnCheckoutRevisionByNumber: revisionNumber
			from: repositoryURL
			to: (self normalizePath: workingCopyPath)]) execute! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 12:19'!
svnCleanupDirectory: directoryPath 

	^self basicSvnCleanupDirectory: (self normalizePath: directoryPath)! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 16:13'!
svnCommit: aCollection 

	^self svnCommit: aCollection withMessage: 'empty commit message'.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 16:13'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	^(SVNErrorCatcher on: [self basicSvnCommit: commitArray withMessage: aString]) execute successful! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 16:00'!
svnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets 
	| deleteArray |
	deleteArray := collectionOfPathsToTargets 
				collect: [:each | self normalizePath: each].
	self basicSvnDeleteTargetsFromWorkingCopy: deleteArray! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 18:45'!
svnGetBlameLinesFrom: target

	self deprecated: 'Use the SVNBlameLinesRequest !!'.
	^ (SVNBlameLinesRequest target: target)
		execute;
		blameLines! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 20:29'!
svnGetCommitLogsFrom: target

	self deprecated: 'Use the SVNCommitLogsRequest !!'.
	^ (SVNCommitLogsRequest target: target)
		execute;
		commitLogs! !

!SVNClient methodsFor: 'svn primitives' stamp: 'test 4/27/2008 07:08'!
svnGetCountOfCommitLogsFrom: target

	self deprecated: 'Why you ask for it ? Use the SVNCommitLogsRequest'.
	
	^ ( (SVNCommitLogsRequest target: target)
		execute;
		commitLogs ) size.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 4/26/2008 03:17'!
svnGetHeadRevision: aPath

	"| arrayForNumber errorCatcher |
	arrayForNumber := {nil}.
	self halt.
	errorCatcher := (SVNErrorCatcher on: [self
		basicSvnGetHeadRevision: aPath pathForSvn
		storeNumberIn: arrayForNumber])
			execute;
			yourself.
	errorCatcher successful
		ifTrue: [^ arrayForNumber first]
		ifFalse: [^ 0]"
	| svnDirEntry request |
	FileDirectory "remove this later. Not needed"
		splitName: aPath
		to: [:path :localName |
			svnDirEntry := ((FileDirectory on: path) fileExists: localName)
				ifTrue: [SVNFile on: aPath]
				ifFalse: [SVNDirectory on: aPath]].
	request := (SVNInfoRequest target: svnDirEntry forRevision: (SVNRevision head)).
	request execute.
	^ request revision number
		ifNil: [0]
		ifNotNilDo: [:int | int].! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 15:18'!
svnResolvedTarget: target 
	^ self basicSvnResolvedTarget: target! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 14:17'!
svnRevertTargets: targets

	| arrayOfTargets |
	arrayOfTargets := targets collect: [:each | self normalizePath: each].
	^self basicSvnRevertTargets: arrayOfTargets! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 4/27/2008 15:57'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher on: [self
		basicSvnUpdateTargets: updateArray
		toRevisionkind: (SVNRevision number: revisionNumber) kind
		revisionNumber: revisionNumber
		beRecursive: true]) execute! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 4/27/2008 16:40'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher on: [self
		basicSvnUpdateTargets: updateArray
		toRevisionkind: SVNRevision head kind
		revisionNumber: 0
		beRecursive: true]) execute! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 20:26'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:59'!
basicSvnAdd: aPath 

	OSProcess waitForCommand: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:59'!
basicSvnAddProperty: key WithValue: value To: path

	| command |
	command := self buildCmdPropset: key value: value for: path.
	OSProcess waitForCommand: command! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:58'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	OSProcess waitForCommand: 'svn co ' , repositoryURL , ' ' , workingCopyPath.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:58'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	OSProcess waitForCommand: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:57'!
basicSvnCommit: collectionOfTargets withMessage: aString

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn commit' , targets , ' -m "',aString,'"'.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:57'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn up -r', revisionNumber asString , targets.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:56'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn up' , targets.
	^ 0! !

!SVNCommandLineClient methodsFor: 'build commands' stamp: 'pe 2/26/2008 13:27'!
buildCmdPropset: key value: value for: path 
	
	^ 'svn propset ' , key , ' ' , value , ' ' , path.! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rt 4/27/2008 00:51'!
executeViaOSProcessSynchronously: command

	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	
	self deprecated: 'Use the OSProcess command "waitForCommand"'.
	OSProcess waitForCommand: command! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:13'!
normalizePath: aPath

	^'"' , aPath pathForSvn , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 4/27/2008 16:58'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	"hack so that command line client still works. I think we could retire it soon"
	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher on: [self
		basicSvnUpdateTargets: updateArray
		toRevisionByNumber: revisionNumber]) execute! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 4/27/2008 16:59'!
svnUpdateTargetsToHeadRevision: aCollection 

	"hack so that command line client still works. I think we could retire it soon"
	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher
		on: [self basicSvnUpdateTargetsToHeadRevision: updateArray]) execute! !

Object subclass: #SVNCommand
	instanceVariableNames: 'target requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNCommand subclass: #SVNAddToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddToCurrentProjectCommand commentStamp: 'rkrk 4/23/2008 23:34' prior: 0!
For SVNSystemBrowser!

SVNAddToCurrentProjectCommand subclass: #SVNAddAllClassesInCategoryToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddAllClassesInCategoryToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/24/2008 00:27'!
execute

	"Be careful. This is not tested. Not even tried..."
	| addClassCommands |
	addClassCommands := self target classes collect: [:obClassNode |
		SVNAddClassToCurrentProjectCommand
			on: obClassNode
			for: self theRequestor].
		
	addClassCommands
		select: [:ea | ea isActive]
		thenDo: [:ea | ea execute].! !

!SVNAddAllClassesInCategoryToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/24/2008 00:25'!
isActive

	^ super isActive
		and: [self target isKindOf: OBClassCategoryNode].! !

SVNAddToCurrentProjectCommand subclass: #SVNAddClassToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddClassToCurrentProjectCommand methodsFor: 'executing' stamp: 'cop 4/24/2008 11:10'!
addTargetToCurrentProject

	self target currentSvnProject addClass: self target theClass.! !

!SVNAddClassToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:30'!
isActive

	^ super isActive
		and: [self target isKindOf: OBClassNode].! !

SVNAddToCurrentProjectCommand subclass: #SVNAddMethodToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddMethodToCurrentProjectCommand methodsFor: 'executing' stamp: 'rkrk 4/23/2008 23:44'!
addTargetToCurrentProject

	| methodRef svnClass |
	methodRef := self target reference.
	(self target classBelongsToCurrentSvnProject)
		ifFalse: [self svnEnvironment currentProject addMethod: methodRef compiledMethod]
		ifTrue: [svnClass := self svnEnvironment findSvnClassFor: methodRef actualClass.
			svnClass addCompiledMethod: methodRef compiledMethod].
	! !

!SVNAddMethodToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:31'!
isActive

	^ super isActive
		and: [self target isKindOf: OBMethodNode].! !

!SVNAddToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/23/2008 23:33'!
addTargetToCurrentProject

	self subclassResponsibility.! !

!SVNAddToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/23/2008 23:32'!
execute

	self findSvnProjectOfSVNElementOfTarget ifNotNilDo: [:project |
			self informTargetIsAlreadyVersionedIn: project. ^ self ].
	self addTargetToCurrentProject.

	"Wahhhhhhhhhhhhh!!!!!!!! Refactooooooooooor!!!!!!!!"
	"	| project svnClass |
	self flag: #TODO.
	project := self target svnEnvironment findSvnProjectFor: self target svnElement.
	project = self target currentSvnProject
		ifTrue: [UIManager default inform:
			'SVNElement is already a member of the project ' ,  project theName. ^ self].
	(project isNil and: [self svnElement isNil])
		ifTrue: [
			(self target isKindOf: OBClassCategoryNode)
				ifTrue: [self target classes do: [:ea| self target currentSvnProject addClass: ea theClass]].
			(self target isKindOf: OBClassNode)
				ifTrue: [self target currentSvnProject addClass: self target theClass].
			(self target isKindOf: OBMethodNode)
				ifTrue: [
					svnClass := (self target svnEnvironment findSvnClassFor: self target theNonMetaClass).
					svnClass
						ifNil: [self target currentSvnProject
								addMethod: self target reference compiledMethod]
						ifNotNil: [svnClass addMethod: (SVNMethod forExistingMethod: self target reference compiledMethod)]
					
					].
				self target currentSvnProject store.
				self theRequestor announce: (OBNodeChanged node: self target).
				^ self].
	
	(project isNil and: [self svnElement notNil])
		ifTrue: [
			(self target svnElement isKindOf: SVNMethod)
			ifTrue: [
				svnClass := self target svnEnvironment findSvnClassFor: self target theClass.
				(svnClass notNil and: [self target svnEnvironment includes: svnClass])
					ifTrue: [svnClass addMethod: self target svnElement]
					ifFalse: [self target currentSvnProject addMethod: self target svnElement]]
			ifFalse: [self target currentSvnProject addClass: self target svnElement]]
		ifFalse: [UIManager default confirm:
			'SVNElement is already a member of the project ' ,
				project theName ,
				'. Remove it and add it to the current project ' ,
				self target currentSvnProject theName , '?'].
		self target currentSvnProject store.
		self theRequestor announce: (OBNodeChanged node: self target)."! !

!SVNAddToCurrentProjectCommand methodsFor: 'ui' stamp: 'rkrk 4/23/2008 14:31'!
informTargetIsAlreadyVersionedIn: aSVNProject

	UIManager default inform:
		'You cannot add this element to the SVNProject ' ,
		self target svnEnvironment currentProject theName ,
		' because it is already versioned in the SVNProject ' ,
		aSVNProject theName.! !

!SVNAddToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:30'!
isActive

	^ self target notNil 
		and: [self target currentSvnProject notNil]
		and: [self target belongsToCurrentSvnProject not]! !

!SVNAddToCurrentProjectCommand methodsFor: 'default' stamp: 'rkrk 4/12/2008 22:39'!
label

	^ 'Add to current project'! !

!SVNCommand class methodsFor: 'converting' stamp: 'rkrk 4/12/2008 11:32'!
on: target for: requestor
	
	^ self new
		target: target;
		theRequestor: requestor;
		yourself.! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesNodes

	^ true! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesText

	^ false! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/21/2008 11:24'!
addItemToMenu: aMenu

	self isActive ifFalse: [^ self].
	aMenu
		add: self label
		target: self
		action: #execute.! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
buttonLabel

	^ self label! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:49'!
cluster

	^ #SVN! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 12:35'!
createCluster
	^ OBCommandCluster label: self cluster! !

!SVNCommand methodsFor: 'execution' stamp: 'rkrk 4/6/2008 20:15'!
execute! !

!SVNCommand methodsFor: 'finding' stamp: 'rkrk 4/23/2008 23:27'!
findSvnProjectOfSVNElementOfTarget
	^ self svnEnvironment findSvnProjectFor: self target svnElement! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
group

	^ #SVN! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
isActive

	^ false! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:20'!
isEnabled

	^ true! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 13:28'!
keystroke
	^ nil
! !

!SVNCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 20:15'!
label

	^ 'No label'! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
longDescription

	"Override this and return a string or a text for the fly-by-help (tooltip)"
	^ nil! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/7/2008 01:09'!
perform: aSelector orSendTo: anObject
	"needed by the menu action invocation"
	self perform: aSelector! !

!SVNCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 02:02'!
svnEnvironment

	^ self target svnEnvironment.! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target
	^ target! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target: anObject
	target := anObject! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:28'!
theRequestor
	^ requestor! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:29'!
theRequestor: anObject
	
	requestor := anObject! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ false! !

SVNCommand subclass: #SVNCreateProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCreateProjectCommand commentStamp: 'rkrk 4/23/2008 23:34' prior: 0!
For SVNProjectBrowser!

!SVNCreateProjectCommand methodsFor: 'executing' stamp: 'rkrk 4/21/2008 17:25'!
execute

	self flag: #TODO. "Update only the environment. ProjectNodes can be created from this"
	SVNCreateProjectDialog call ifNotNilDo: [:svnProject |
		svnProject checkout; load.
		"-------------"
		self theRequestor svnEnvironment addSvnProject: svnProject.
		self theRequestor beDependentFromProjects.
		"-------------"
		self theRequestor projectNodes add: (SVNProjectNode
				element: svnProject
				svnEnvironment: self theRequestor svnEnvironment).
		self theRequestor updateTree].! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 22:35'!
isActive

	^ self target isNil! !

!SVNCreateProjectCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:36'!
label

	^ 'Create Project'! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ true! !

SVNCommand subclass: #SVNElementCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNElementCommand subclass: #SVNClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNClassCommand subclass: #SVNBrowseClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNBrowseClassCommand methodsFor: 'as yet unclassified' stamp: 'per 4/23/2008 12:59'!
execute

	| browser |
	browser := OBSVNSystemBrowser onClass: (Smalltalk classNamed: self svnClass theName).
	browser svnEnvironment currentProject: self target parent svnElement.
	browser panels first currentProject: self target parent svnElement.
	browser open.
	
	! !

!SVNBrowseClassCommand methodsFor: 'as yet unclassified' stamp: 'per 4/23/2008 11:19'!
label

	^ 'Browse class'! !

!SVNClassCommand methodsFor: 'testing' stamp: 'cop 4/28/2008 11:02'!
isActive

	^ super isActive
		and: [self target hasSvnElementOfKind: SVNClass]! !

!SVNClassCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:45'!
svnClass

	self assert: (self svnElement isKindOf: SVNClass).
	^ self svnElement! !

SVNClassCommand subclass: #SVNDeleteClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteClassCommand commentStamp: 'rkrk 4/23/2008 23:35' prior: 0!
For
SVNProjectBrowser <-- not implmented yet
and
SVNSystemBrowser!

!SVNDeleteClassCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 12:00'!
deleteClass

	(self target svnEnvironment findSvnProjectFor: self svnClass)
		ifNotNilDo: [:project | project removeSVNClass: self svnClass]! !

!SVNDeleteClassCommand methodsFor: 'execution' stamp: 'cop 4/23/2008 13:50'!
execute

	(UIManager default confirm: 'You realy want to delete this class from this project?')
		ifTrue: [ self deleteClass.]
	! !

!SVNDeleteClassCommand methodsFor: 'default' stamp: 'cop 4/23/2008 10:51'!
label

	^ 'Delete class'! !

SVNElementCommand subclass: #SVNCommitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCommitCommand commentStamp: 'rkrk 4/23/2008 23:35' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:54'!
execute
	
	SVNCommitBrowser openWith: self svnElement.! !

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 4/12/2008 12:07'!
label

	^ 'Commit SVNElement'! !

!SVNElementCommand methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:03'!
isActive

	^ self target notNil and:
		[self target belongsToCurrentSvnProject] and:
		[self target hasSvnElementOfKind: SVNElement]! !

!SVNElementCommand methodsFor: 'accessing' stamp: 'cop 4/14/2008 09:40'!
svnElement

	^ self target svnElement! !

SVNElementCommand subclass: #SVNMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNMethodCommand subclass: #SVNBrowseMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNBrowseMethodCommand methodsFor: 'as yet unclassified' stamp: 'per 4/24/2008 12:17'!
execute

	| browser |
	browser := OBSVNSystemBrowser onClass: (Smalltalk classNamed: target svnElement nameOfClass) selector: target svnElement theName asSymbol.
	browser svnEnvironment currentProject: self target parent parent parent svnElement.
	browser panels first currentProject: self target parent parent parent svnElement.
	browser open.! !

!SVNBrowseMethodCommand methodsFor: 'as yet unclassified' stamp: 'per 4/24/2008 11:12'!
label

	^ 'Browse method'! !

SVNMethodCommand subclass: #SVNDeleteMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteMethodCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser <-- not implmented yet
and
SVNSystemBrowser!

!SVNDeleteMethodCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 11:58'!
deleteMethod

	(self target svnEnvironment findSvnProjectOrSvnClassForSvnMethod: self svnMethod)
		ifNotNilDo: [:projectOrClass | projectOrClass removeSVNMethod: self svnMethod].! !

!SVNDeleteMethodCommand methodsFor: 'execution' stamp: 'cop 4/23/2008 13:50'!
execute

	(UIManager default confirm: 'You realy want to delete this method from this class?')
		ifTrue: [ self deleteMethod.]
	! !

!SVNDeleteMethodCommand methodsFor: 'default' stamp: 'cop 4/23/2008 10:51'!
label

	^ 'Delete method'! !

!SVNMethodCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:49'!
isActive

	^ super isActive
		and: [self target hasSvnElementOfKind: SVNMethod]! !

!SVNMethodCommand methodsFor: 'derived accessing' stamp: 'cop 4/23/2008 10:50'!
svnMethod

	self assert: (self svnElement isKindOf: SVNMethod).
	^ self svnElement! !

SVNElementCommand subclass: #SVNProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNProjectCommand subclass: #SVNCheckoutCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCheckoutCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNCheckoutCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:22'!
execute

	self svnProject checkout! !

!SVNCheckoutCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 01:22'!
label

	^ 'Checkout project'! !

SVNProjectCommand subclass: #SVNChooseAndAddClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNChooseAndAddClassCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNChooseAndAddClassCommand methodsFor: 'default' stamp: 'rkrk 4/21/2008 01:57'!
acceptClassBlock

	| class |
	^ [:text |
		class := (Smalltalk classNamed: text asString).
		class notNil and: [(self svnEnvironment includes: class) not]].! !

!SVNChooseAndAddClassCommand methodsFor: 'execution' stamp: 'cop 4/21/2008 17:18'!
execute

	| text |
	text := SVNRequestDialog
		ask: 'Enter class name'
		template: String new
		canAcceptBlock: self acceptClassBlock.
	text ifNil: [^ self].
	self svnProject addClass: (Smalltalk classNamed: text asString).! !

!SVNChooseAndAddClassCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 04:13'!
label

	^ 'Add class to project'! !

SVNChooseAndAddClassCommand subclass: #SVNChooseAndAddMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNChooseAndAddMethodCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNChooseAndAddMethodCommand methodsFor: 'default' stamp: 'cop 4/21/2008 17:03'!
acceptBlock: aString
	
	| class methodSelector |
	self flag: #TODO "Adding methods of a superclass... be careful!!!!!! And write a test for this!!!!!!
	What about adding the class to which the methods belongs afterwards? ...!!".
	^ [:text |
		class := Smalltalk classNamed: aString.
		methodSelector := text asString asSymbol.
		(class includesSelector: methodSelector) and:
			[(self svnEnvironment includes: class >> methodSelector) not]].! !

!SVNChooseAndAddMethodCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/21/2008 02:33'!
execute

	| className methodName method |
	className := SVNRequestDialog
		ask: 'Enter class name'
		template: String new
		canAcceptBlock: self acceptClassBlock.
	className ifNil: [^ self].
	
	methodName := SVNRequestDialog
		ask: 'Enter method name'
		template: String new
		canAcceptBlock: (self acceptBlock: className asString).
	methodName ifNil: [^ self].
	
	method := (Smalltalk classNamed: className) >> methodName asSymbol.
	self svnProject addMethod: method.! !

!SVNChooseAndAddMethodCommand methodsFor: 'default' stamp: 'cop 4/18/2008 12:05'!
label

	^ 'Add method to project'! !

SVNProjectCommand subclass: #SVNDeleteProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'cop 4/24/2008 15:28'!
deleteProjectIn: aSVNEnv

	aSVNEnv currentProject = self svnProject ifTrue: [aSVNEnv currentProject: nil ].
	aSVNEnv svnProjects remove: self svnProject.
	self svnProject changed.! !

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 12:00'!
execute

	(UIManager default confirm: 'You realy want to delete the ', self svnProject theName, ' project?')
		ifTrue: ["(UIManager default confirm: 'Do you want to remove ', self svnProject theName, ' project from the repository?')
			ifTrue: [self removeProjectFromRepository]".
			self deleteProjectIn: self target svnEnvironment. ]
	! !

!SVNDeleteProjectCommand methodsFor: 'default' stamp: 'cop 4/24/2008 11:31'!
label

	^ 'Delete project'! !

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'cop 4/24/2008 14:21'!
removeProjectFromRepository
	(self svnElement 
		remove
		commitWithMessage: 'Project ', self svnElement theName, ' deleted.')
		svnDirectoryEntry delete.! !

!SVNProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:50'!
isActive

	^ super isActive and: [self target hasSvnElementOfKind: SVNProject]! !

!SVNProjectCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:44'!
svnProject

	self assert: (self svnElement isKindOf: SVNProject).
	^ self svnElement! !

SVNProjectCommand subclass: #SVNSetURLCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetURLCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNSetURLCommand methodsFor: 'executing' stamp: 'pe 4/14/2008 15:17'!
execute

	| newUrl |
	newUrl := SVNRequestDialog
		ask: self label
		template: self svnProject repositoryURL asString
		canAcceptBlock: [:text | text notNil].
	newUrl ifNotNil: [self svnProject repositoryURL: newUrl asString].! !

!SVNSetURLCommand methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:24'!
label

	^ 'Edit SVNProject URL'! !

SVNProjectCommand subclass: #SVNSetWorkingCopyPathCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetWorkingCopyPathCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNSetWorkingCopyPathCommand methodsFor: 'executing' stamp: 'rkrk 4/7/2008 01:00'!
execute

	| newWCPath |
	self flag: #TODO. "SVNProjects will soon have no working copy path any longer.
	They will specify their project directory instead."
	newWCPath := SVNRequestDialog
		ask: self label
		template: self svnProject workingCopyDirectory path
		canAcceptBlock: [:text | text notNil].
	self flag: #TODO. "Setting the workingcopy path is not so easy!!
	All subentries have to be updated!!"
	(UIManager default confirm: 'This operation will not work in an expected way. Continue?')
		ifTrue:[newWCPath ifNotNil: [
				self svnProject workingCopyDirectory: (SVNDirectory on: newWCPath asString)]].! !

!SVNSetWorkingCopyPathCommand methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 00:02'!
label

	^ 'Edit working copy path'! !

SVNElementCommand subclass: #SVNRevertCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNRevertCommand commentStamp: 'rkrk 4/23/2008 23:37' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:55'!
execute
	
	self svnElement revert! !

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Revert'! !

SVNElementCommand subclass: #SVNUpdateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNUpdateCommand commentStamp: 'rkrk 4/23/2008 23:37' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:50'!
execute
	
	self svnElement update! !

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Update'! !

SVNElementCommand subclass: #SVNUpdateToRevisionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNUpdateToRevisionCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/28/2008 04:06'!
execute

	| revisionNumber number |
	revisionNumber := SVNRequestDialog
		ask: 'Please enter the revision number'
		template: ''
		canAcceptBlock: [:text |
			number := text asString asInteger.
			number notNil and: [number positive]].
	self svnElement updateToRevision: (SVNRevision number: revisionNumber asInteger).! !

!SVNUpdateToRevisionCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/28/2008 00:29'!
label

	^ 'update to revision...'! !

Object subclass: #SVNCommitLog
	instanceVariableNames: 'revision author date comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNCommitLog class
	instanceVariableNames: 'revision author date comment'!

SVNCommitLog class
	instanceVariableNames: 'revision author date comment'!

!SVNCommitLog class methodsFor: 'instance creation' stamp: 'rkrk 4/3/2008 15:35'!
createCommitLogWithRevision: aRevision author: anAuthor date: aDate comment: aComment

	^ self new
		revision: aRevision;
		author: anAuthor;
		date: aDate;
		comment: aComment.! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
author
	^ author! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
author: anAuthor
	author := anAuthor! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:15'!
comment
	^ comment! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
comment: aComment
	comment := aComment! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
date
	^ date! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
date: aDate
	date := aDate! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
revision
	^ revision! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
revision: aRevision
	revision := aRevision! !

!SVNCommitLog methodsFor: 'printing' stamp: 'rkrk 4/3/2008 15:36'!
revisionAuthorDateString

	^ self revision asString, ' - ', self author , ' ' , self date asDateAndTime asTimeStamp asString! !

Object subclass: #SVNCurrentProjectChanged
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNCurrentProjectChanged class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/11/2008 19:49'!
forProject: svnProject

	^ self new
		currentProject: svnProject;
		yourself.! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject
	^currentProject! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	^ super = other and:
		[self files = other files] and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 4/2/2008 17:02'!
addFile: svnFile

	"assure that there is no file with the same name"
	"self assert: (self files noneSatisfy: [:file |
		file theName = svnFile theName and: [file ~~ svnFile]])."
	"self files removeAllSuchThat: [:file | file theName = svnFile theName]."
	| alreadyExistingFile |
	svnFile basePath: self path.
	alreadyExistingFile := self files
		detect: [:file | file theName = svnFile theName]
		ifNone: [^ self files add: svnFile].
	^ alreadyExistingFile
		properties: svnFile properties;
		content: svnFile content;
		yourself.! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 4/28/2008 02:14'!
addSubdirectory: svnDirectory

	"assure that there is no file with the same name"
	"self assert: (self subdirectories noneSatisfy: [:dir |
		dir theName = svnDirectory theName and: [dir ~~ svnDirectory]])."
	"self subdirectories detect: [:dir | dir theName = svnDirectory theName]."
	| subdirectory |
	svnDirectory basePath: self path.
	subdirectory := self subdirectories
		detect: [:dir | dir theName = svnDirectory theName]
		ifNone: [self subdirectories add: svnDirectory. svnDirectory].
	
	subdirectory
		properties: svnDirectory properties;
		subdirectories: svnDirectory subdirectories;
		files: svnDirectory files.
			
	self flag: #TODO. "Ugly. How to inform subdirectories and files about new basepath?"
	svnDirectory subdirectories do: [:ea | svnDirectory addSubdirectory: ea].
	svnDirectory files do: [:ea | svnDirectory addFile: ea].
	
	^ subdirectory! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 3/3/2008 21:13'!
assureExistenceInParent
	"create a directory with the name 'theName' in 'self basePath' if it does not exists and add the directory to the working copy"

	| directory client |
	directory := FileDirectory on: self path.
	directory exists ifTrue: [^ self].
	
	(directory directoryExists: self basePath) ifFalse: [^ self].
	
	directory createDirectory: self path.
	client := SVNCApiClient new.
	client svnAdd: self path.! !

!SVNDirectory methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 15:13'!
checkAndSolveConflicts

	self subdirectories do: [:dir| dir checkForConflicts].
	self files do: [:file| file isConflicted ifTrue: [file solveConflict]].! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'test 3/5/2008 00:16'!
createFileNamed: filename 

	^ self
		createFileNamed: filename
		withContent: String new.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 3/5/2008 01:38'!
createFileNamed: filename withContent: content

	| newFile |
	newFile := SVNFile
		named: filename
		basePath: self path
		content: content.
	self addFile: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rt 3/14/2008 15:20'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	self flag: #TODO. "Test schreiben!!!!!!!!"
	(self subdirectories anySatisfy: [:each | each theName = aString])
		ifTrue: [^ (self subdirectories detect: [:each | each theName = aString])].
	newDirectory := self class
		named: aString
		basePath: self path.
	self addSubdirectory: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 3/4/2008 06:13'!
delete

	| fileDir dotSvnDir |
	fileDir := FileDirectory on: self basePath.
	
	self flag: #TODO.
	fileDir deleteFileNamed: '.DS_STORE'.
	dotSvnDir := SVNDirectory named: '.svn' basePath: self path.
	(FileDirectory on: dotSvnDir path) exists ifTrue:
		[dotSvnDir read.
		dotSvnDir recursivelyDo: [:svnDirectoryEntry |
			svnDirectoryEntry delete]].
	
	fileDir := FileDirectory on: self basePath.
	(fileDir directoryExists: self theName asString) ifFalse: [^ self].
	fileDir deleteDirectory: self theName.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:46'!
hash

	^ (super hash bitXor: self files hash) bitXor: self subdirectories hash! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rkrk 4/2/2008 12:01'!
initialize

	super initialize.
	self
		files: OrderedCollection new;
		subdirectories: OrderedCollection new;
		theName: String new! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
pathsOfAllElements

	| entries |
	entries := self files copy.
	entries addAll: self subdirectories.
	^ entries collect: [:each | each path].! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 4/2/2008 12:13'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 4/21/2008 00:54'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [
			Transcript show: 'Trying to load non-existing directory ' , self path; cr.
			^ self].

	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 4/28/2008 05:02'!
readDirectoriesInDir: dir

	| newSvnDirectory |
	self subdirectories removeAllSuchThat: [:ea | (dir directoryNames includes: ea theName) not].
	dir directoryNames
		select: [:each | each ~= '.svn']
		thenDo: [:each |
			"each = 'SVNTestClassCreatedInAcceptanceTest' ifTrue: [self halt]."
			newSvnDirectory := SVNDirectory
				named: each
				basePath: self path.
				"self halt."
			newSvnDirectory read.
			self addSubdirectory: newSvnDirectory].! !

!SVNDirectory methodsFor: 'reading' stamp: 'test 3/1/2008 02:49'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'cop 4/28/2008 11:47'!
readFilesInDir: directory

	self flag: #TODO. "Use addSvnFile:???"
	self files removeAllSuchThat: [:ea | (directory fileNames includes: ea theName) not].
	directory fileNames
		collect: [:each | SVNFile named: each basePath: self path]
		thenDo: [:newFile |
			newFile isConflictFile not
			ifTrue: [newFile read.
				self addFile: newFile].
			].! !

!SVNDirectory methodsFor: 'helper' stamp: 'rkrk 4/2/2008 15:13'!
recursivelyDo: aBlock

	| entries |
	self flag: #TODO. "Testen".
	entries := self files copy.
	entries addAll: self subdirectories.
	entries do: [:ea | ea recursivelyDo: aBlock].
	aBlock value: self.! !

!SVNDirectory methodsFor: 'helper' stamp: 'cop 4/14/2008 21:02'!
recursivelyDoForFiles: aBlock
	self subdirectories do: [:ea | ea recursivelyDoForFiles: aBlock].
	self files do: [:ea| aBlock value: ea.]! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
recursivelyGatherPathsOfAllElements

	| subElementsPaths |
	subElementsPaths := self subdirectories gather: [:each | each recursivelyGatherPathsOfAllElements].
	^ self pathsOfAllElements
		addAll: subElementsPaths;
		yourself.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:35'!
remove

	| myFileDirectory |
	myFileDirectory := FileDirectory on: self basePath.
	(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	super remove.
	"(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	myFileDirectory deleteRecursivelyPlatformIndependent.
	(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	Transcript show: 'Could not delete directory: ' , self path; cr."! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 03:40'!
removeSVNDirectory: svnDirectory

	self subdirectories
		remove: svnDirectory
		ifAbsent: [].
	svnDirectory remove.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:00'!
removeSVNFile: svnFile

	self files
		remove: svnFile
		ifAbsent: [].
	svnFile remove. "not needed in case of method... it removes itself... hmmm"! !

!SVNDirectory methodsFor: 'storing' stamp: 'cop 4/14/2008 13:46'!
store

	| entriesToStore |
	self basePath ifEmpty: [ Transcript show: 'No base path set for ', self asString;
							cr.
							^self ].
	(FileDirectory on: self path) assureExistence.
	super store.
	entriesToStore := self files copy.
	entriesToStore addAll: self subdirectories.
	entriesToStore do: [:each | each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:44'!
asciiValueSeparator

	^ $%! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 4/21/2008 13:08'!
illegalCharacters

	^ #($/ $\ $? $* $: $| $" $< $> $ $ $)! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:02'!
named: aString

	^ self
		named: aString
		basePath: String new.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 4/2/2008 17:57'!
named: aString basePath: pathName

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ self new
		encodeName: aString;
		basePath: pathName;
		yourself.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 3/31/2008 15:20'!
on: pathString
	
	FileDirectory
		splitName: pathString
		to: [:dirPath :localName |
			^ self named: localName basePath: dirPath].! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/9/2008 19:19'!
<= other

	^ self theName <= other theName! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName and:
		[self basePath = other basePath] and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/27/2008 02:25'!
addEntry

	| client |
	client := SVNCApiClient new.
	client svnAdd: self path! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:54'!
asciiValueSeparator

	^ self class asciiValueSeparator.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 15:13'!
checkAndSolveConflicts

	^self subclassResponsibility! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
checkoutFrom: url

	self svnClientDo: [:svnClient | 
		svnClient
			svnCheckoutHeadRevisionFrom: url asString
			to: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:03'!
commit

	self commitWithMessage: String new.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rt 4/23/2008 18:38'!
commitLogs
	| client |
	client := SVNCApiClient new.
	self commitLogs: (client svnGetCommitLogsFrom: self path).
	"commitLogs ifNil: [^OrderedCollection new]."
	^ commitLogs! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'mu 3/18/2008 17:40'!
commitLogs: anObject
	commitLogs := anObject! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:27'!
commitWithMessage: aString

	self svnClientDo: [:svnClient | 
		svnClient
			svnCommit: {self path}
			withMessage: aString.].! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rt 3/17/2008 13:34'!
delete! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 4/6/2008 02:39'!
encodeName: aString 

	"Parse the string and construct a filename from it."
	| parts char |
	self flag: #TODO.
	"self assert: aString isEmpty not."
	aString ifEmpty: [^ aString].
	(aString first = self asciiValueSeparator and: [aString size = 1]) ifTrue: [^ aString].
	
	aString isAllDigits ifTrue: [self theName: aString. ^ self].
	
	parts := aString subStrings: self asciiValueSeparator asString.
	self theName: (parts
		inject: String new
		into: [:result :each | each isAllDigits
			ifFalse: [result , each]
			ifTrue: [char := Character value: each asNumber.
				result , char asString]]).! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:55'!
fileNameRepresantationForIllegalCharacter: character

	| sep |
	sep := self asciiValueSeparator asString.
	^  sep , character asciiValue asString , sep.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 19:56'!
filename

	"print it: [self new theName: 'ab:ab'; filename]"
	^ self class illegalCharacters 
		inject: self theName copy
		into: [:convertedName :illegalCharacter |
			convertedName
				copyReplaceAll: illegalCharacter asString
				with: (self fileNameRepresantationForIllegalCharacter: illegalCharacter)].! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:58'!
hash

	^ ((self theName hash bitXor: self basePath hash) bitXor: self properties hash) bitXor: self species hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:14'!
initialize

	super initialize.
	self
		theName: String new;
		properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'cop 4/21/2008 17:35'!
myStatus
	
	^ (SVNStatusRequest target: self isRecursive: false)
		execute;
		yourself! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 18:03'!
path
	^ self basePath , FileDirectory slash , self filename.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'cop 4/14/2008 14:13'!
pathsOfAllElements
	^self path! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'mu 3/20/2008 14:10'!
read
	
	self	readProperties.
	self readCommitLogs.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'test 4/17/2008 19:49'!
readCommitLogs
	| client |
	client := SVNCApiClient new.
	self commitLogs: (client svnGetCommitLogsFrom: self path).! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rt 4/17/2008 20:32'!
readProperties

	self properties: ((SVNPropertiesRequest target: self path) execute; properties)! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rt 3/14/2008 15:09'!
remove

	self svnRemoveEntry! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 4/18/2008 11:02'!
revert
	self svnClientDo: [:svnClient |
		svnClient svnRevertTargets: {self path}].
	self read.! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'rkrk 4/7/2008 15:42'!
status
	
	^ (SVNStatusRequest target: self)
		execute;
		yourself! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'pe 4/14/2008 14:36'!
store
	self assert: (FileDirectory on: self basePath) exists.
	self
		addEntry;
		storeProperties.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'test 3/1/2008 04:14'!
storeProperties

	| client |
	client := SVNCApiClient new.
	self properties keysAndValuesDo: [:key :value |
		client svnAddProperty: key WithValue: value To: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:28'!
svnAdd

	self svnClientDo: [:svnClient |
		svnClient svnAdd: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rt 4/23/2008 18:42'!
svnBlame

	^ (SVNBlameLinesRequest target: self path)
		execute;
		blameLines! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 03:22'!
svnInfo

	^ (SVNInfoRequest target: self)
		execute;
		yourself.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rt 3/13/2008 17:30'!
svnRemoveEntry

	| client |
	client := SVNCApiClient new.
	client svnDeleteTargetsFromWorkingCopy: {self path}.
	self flag: #TODO. "svn status ??? If entry isn't under version control call: entry delete ?'"! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 18:54'!
theName: aString 

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	theName := aString asString.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rt 4/15/2008 16:40'!
update
	self svnClientDo: [:svnClient |
		svnClient svnUpdateTargetsToHeadRevision: {self path}].
	self read.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/27/2008 22:40'!
updateToRevision: svnRevision

	(SVNUpdateRequest
		target: self
		updateToRevision: svnRevision
		beRecursive: true) execute.
	self read.! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'test 3/5/2008 15:29'!
named: aString basePath: pathName content: content

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'svn functions' stamp: 'cop 4/3/2008 13:19'!
blame
	^self svnBlame.! !

!SVNFile methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 15:15'!
checkAndSolveConflicts
	
	self status isConflicted ifTrue: [self solveConflict]! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 3/4/2008 05:13'!
delete

	(FileDirectory on: self basePath) deleteFileNamed: self theName.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:50'!
hash

	self flag: #TODO.
	"^ (super hash bitXor: self content hash) bitXor: self properties hash."
	
	^ super hash bitXor: self content hash! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 4/27/2008 05:14'!
initialize

	super initialize.
	self	content: String new.! !

!SVNFile methodsFor: 'testing' stamp: 'cop 4/28/2008 11:56'!
isConflictFile
	^('*.mine*' match: self theName) or:['.r#' match: self theName]! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 4/2/2008 11:27'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 4/21/2008 00:53'!
read
	
	self flag: #TODO.
	(FileStream isAFileNamed: self path)
		ifFalse: [
			Transcript show: 'Trying to load non-existing file ' , self path; cr.
			^ self].

	self assert: ('*.mine*' match: self theName) not.
	self assert: ('.r#' match: self theName) not.
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'cop 4/14/2008 20:51'!
readContent
	FileStream 
		readOnlyFileNamed: self path
		do: [:stream | content := stream contents.]! !

!SVNFile methodsFor: 'helper' stamp: 'rkrk 3/4/2008 05:20'!
recursivelyDo: aBlock

	self flag: #TODO. "Testen".
	aBlock value: self.! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:35'!
remove

	| dir |
	dir := FileDirectory on: self basePath.
	dir exists ifFalse: [^ self].
	(dir fileExists: self filename) ifFalse: [^ self].
	super remove.
	"(dir fileExists: self filename) ifFalse: [^ self].
	dir deleteFileNamed: self filename.
	(dir fileExists: self filename) ifFalse: [^ self].
	Transcript show: 'Could not delete file ' , self path; cr."! !

!SVNFile methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 16:26'!
resolved
	
	self svnClientDo: [:svnClient|
		svnClient svnResolvedTarget: self path pathForSvn]! !

!SVNFile methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 13:10'!
solveConflict! !

!SVNFile methodsFor: 'storing' stamp: 'cop 4/22/2008 14:49'!
store
	"self assert: (self theName includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].
	super store.! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'dummy' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 3/14/2008 02:25'!
< other

	^ super < other! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 4/28/2008 12:48'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."! !

Object subclass: #SVNElement
	instanceVariableNames: 'theName parent svnDirectoryEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass superclassName classVariables instanceVariables classInstanceVariables comment category subclasses versionedMethods poolDictionaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 18:28'!
forExistingClass: aClass

	^ self new
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 00:35'!
name: className superclassName: superClassName instanceVariables: instVars classVariables: classVars classInstanceVariables: classInstVars poolDictionaries: poolDicts comment: comment category: classCategory

	^ self new
		theName: className asString;
		superclassName: superClassName;
		instanceVariables: instVars;
		classVariables: classVars;
		classInstanceVariables: classInstVars;
		poolDictionaries: poolDicts;
		comment:  comment;
		category: classCategory;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 4/15/2008 04:24'!
= other

	^ super = other "ifFalse: [^ false].
	(self superclassName = other superclassName and:
		[self instanceVariables = other instanceVariables] and:
		[self classVariables = other classVariables] and:
		[self classInstanceVariables = other classInstanceVariables] and:
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:
		[self poolDictionaries = other poolDictionaries] and:
		[self versionedMethods = other versionedMethods]"! !

!SVNClass methodsFor: 'adding' stamp: 'rkrk 4/23/2008 14:19'!
addCompiledMethod: aMethod

	"rename this in #addMethod:? and #addMethod: in #addSvnMethod:?
	Would be consisten to SVNProject>>addClass: und SVNProject>>addSvnClass:"
	self addMethod: (SVNMethod forExistingMethod: aMethod).! !

!SVNClass methodsFor: 'adding' stamp: 'rkrk 4/23/2008 14:18'!
addMethod: svnMethod

	| methodDirectory |
	methodDirectory := self directory
		getSubDirectoryNamed: (svnMethod isPartOfMetaclass
			ifTrue: ['class']
			ifFalse: ['instance']).
	
	methodDirectory addFile: svnMethod file.
	self versionedMethods add: svnMethod.
	self changed.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 4/1/2008 14:34'!
classDetailsDictionary

	^ Dictionary new
		at: self nameForSuperclassProperty 				put: self superclassName asString;
		at: self nameForCategoryProperty 				put: self category asString;
		at: self nameForPoolDictionariesProperty 		put: self poolDictionariesString;
		at: self nameForInstanceVariablesProperty 		put: self instanceVariablesString;
		at: self nameForClassVariablesProperty 			put: self classVariablesString;
		at: self nameForClassInstanceVariablesProperty 	put: self classInstanceVariablesString;
		at: self nameForCommentFile 					put: self comment;
		yourself.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:42'!
commit

	self
		commitWithMessage: 'empty commit message';
		changed.! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory

	^ self svnDirectoryEntry! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory: aSVNDirectory

	self svnDirectoryEntry: aSVNDirectory! !

!SVNClass methodsFor: 'initialize-release' stamp: 'pe 4/14/2008 15:08'!
establishSvnFilesAndDirectories
	
	self directory ifNil: [self directory: (SVNDirectory named: self theName)].	
	self directory
		createSubDirectoryNamed: 'instance';
		createSubDirectoryNamed: 'class'.
	
	self flag: #TODO. "Is this necessary... can this be expressed better? .. see #store"
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/14/2008 18:58'!
extractCategoryFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForCategoryProperty) content asSymbol! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractClassVarsFrom: aSVNDirectory
	
	^ ((aSVNDirectory getFileNamed: self nameForClassVariablesProperty) content substrings collect: [:each | each asSymbol]) asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:00'!
extractInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractMetaInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForClassInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:37'!
extractPoolDictionariesFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForPoolDictionariesProperty) content substrings asOrderedCollection! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:36'!
extractSuperclassFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForSuperclassProperty) content! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 4/20/2008 22:44'!
forExistingClass: aClass

	self
		theName: aClass name asString;
		superclassName: aClass superclass name asString;
		instanceVariables: aClass instVarNames;
		classVariables: aClass classVarNames;
		classInstanceVariables: aClass class instVarNames;
		poolDictionaries: aClass poolDictionaryNames;
		comment: aClass comment;
		category: aClass category.

	self establishSvnFilesAndDirectories.

	"Can't use #union or #addAll here because dicts would be merged in a strange way??"
	aClass class methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].	
	aClass methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].
	self changed.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 13:29'!
hash

	^ self theName hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 4/20/2008 22:44'!
initialize

	super initialize.
	self
		versionedMethods: Set new;
		subclasses: Set new.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/20/2008 22:58'!
isIncludedInEnvironment: svnEnvironment

	^ (svnEnvironment findSvnClassFor: self) notNil! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:25'!
isIncludedInProject: svnProject


	^ svnProject versionedClasses includes: self! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 4/20/2008 22:47'!
load
	
	self poolDictionaries do: [:each | Smalltalk at: each asSymbol ifAbsentPut: Dictionary new].
	
	(Smalltalk classNamed: self theName asSymbol)
		ifNotNil: [self reloadClass]
		ifNil: [self loadAsNewClass].
			
	self versionedMethods do: [:each | each load].
	self removeUnversionedMethods.
	self subclasses do: [:each | each load].
	self changed.! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 3/31/2008 23:37'!
loadAsNewClass

	| superclass |
	self assert: self theClass isNil.	
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	superclass
		subclass: self theName asSymbol
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self poolDictionariesString
		category: self category.
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.
	self theClass comment: self comment.
! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 4/1/2008 18:12'!
nameForCategoryProperty

	^ 'category'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:16'!
nameForClassInstanceVariablesProperty
	^ 'classInstanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForClassVariablesProperty
	^ 'classVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForInstanceVariablesProperty
	^ 'instanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 3/9/2008 16:45'!
nameForPoolDictionariesProperty
	^'poolDictionaries'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:05'!
nameForSuperclassProperty
	^'superclass'! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries

	^poolDictionaries! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries: anObject

	poolDictionaries := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rt 3/9/2008 16:46'!
poolDictionariesString

	^ self stringFromCollection: self poolDictionaries.! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rt 3/26/2008 23:42'!
reloadClass

	| class newVars |		
	class := Smalltalk classNamed: self theName asSymbol.
	self assert: class notNil.
	
	"superclass"
	class superclass: (Smalltalk classNamed: self superclassName).
	
	"instVars"
	newVars := self instanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class instVarNames.
	newVars do: [:newInstVar |
		class addInstVarName: newInstVar].
	
	"classVars"
	newVars := self classVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class classVarNames.
	newVars do: [:newClassVar |
		class addClassVarName: newClassVar].
	
	"pools"
	newVars := self poolDictionaries asOrderedCollection copy.
	newVars removeAllFoundIn: class poolDictionaryNames.
	newVars do: [:newPoolDictionary |
		class addSharedPool: (Smalltalk at: newPoolDictionary asSymbol)].
	
	"classInstVars"
	newVars := self classInstanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class class instVarNames.
	newVars do: [:newClassInstVar |
		class class addInstVarName: newClassInstVar].

	"category"
	class category: self category.
	
	"comment"
	class comment: self comment.! !

!SVNClass methodsFor: 'removing' stamp: 'rkrk 4/28/2008 02:50'!
removeSVNMethod: svnMethod

	| methodDirectory |
	svnMethod remove.
	self versionedMethods remove: svnMethod.
	self flag: #TODO. "..."
	methodDirectory := self directory getSubDirectoryNamed: (svnMethod isPartOfMetaclass
			ifTrue: ['class']
			ifFalse: ['instance']).
	methodDirectory removeSVNFile: svnMethod file.
	self changed.! !

!SVNClass methodsFor: 'removing' stamp: 'rt 3/25/2008 19:34'!
removeUnversionedMethods

	| class methodsToRemove metaClass |
	self flag: #TODO. "just for testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod"
	self flag: #TODO. "if we need this put it to reloadClass"
	
	class := (Smalltalk classNamed: self theName asSymbol).
	methodsToRemove := class methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:instanceMethod | instanceMethod isPartOfMetaclass not])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | class removeSelectorSilently: removeMeMethod asSymbol].
	
	metaClass := class class.
	methodsToRemove := metaClass methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:classMethod | classMethod isPartOfMetaclass])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | metaClass removeSelectorSilently: removeMeMethod asSymbol].! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'mu 4/23/2008 15:04'!
renameSVNClass: aString! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 01:06'!
restore

	super restore.
	self
		theName: self directory theName;
		restoreClassDetails;
		restoreMethods;
		comment: (self directory getFileNamed: self nameForCommentFile) content.! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 01:01'!
restoreClassDetails

	self
		superclassName: (self extractSuperclassFrom: self directory);
		instanceVariables: (self extractInstVarsFrom: self directory);
		classVariables: (self extractClassVarsFrom: self directory);
		classInstanceVariables: (self extractMetaInstVarsFrom: self directory);
		poolDictionaries: (self extractPoolDictionariesFrom: self directory);
		category: (self extractCategoryFrom: self directory).! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 4/28/2008 03:59'!
restoreMethods

	| allMethodFiles |
	allMethodFiles := self directory subdirectories gather: [:subDir | subDir files].
	 self versionedMethods
		select: [:ea | (allMethodFiles includes: ea file) not]
		thenDo: [:ea | self removeSVNMethod: ea].
	allMethodFiles do: [:file |
		self addMethod: (SVNMethod restoreFrom: file)].
	self changed.! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/22/2008 13:44'!
statusClassMethods
	^self statusMethodsFor: 'class'! !

!SVNClass methodsFor: 'svn state' stamp: 'rkrk 4/22/2008 17:24'!
statusComment

	^ (self directory getFileNamed: 'comment')
		ifNil: [#none]
		ifNotNilDo: [:commentFile | commentFile status statusKind].! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/22/2008 13:44'!
statusInstanceMethods
	^self statusMethodsFor: 'instance'! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/22/2008 14:31'!
statusMethodsFor: aString 
	| statusKind myStatus |
	statusKind := (svnDirectoryEntry subdirectories 
		detect: [ :ea | ea theName = aString ]
		ifNone: [ ^ #none ]) status statusKind.
	myStatus := svnDirectoryEntry myStatus statusKind.
	(self keyForStatus: statusKind) > (self keyForStatus: myStatus) ifTrue: [ ^ #modified ].
	^ statusKind! !

!SVNClass methodsFor: 'storing' stamp: 'cop 4/22/2008 14:54'!
store

	self versionedMethods do: [:each | each store].
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:16'!
subclasses

	^subclasses! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:14'!
subclasses: anObject

	subclasses := anObject asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 3/31/2008 23:36'!
theClass

	^ Smalltalk classNamed: self theName! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 01:13'!
versionedMethods
	
	^ versionedMethods! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/8/2008 22:08'!
versionedMethods: anObject

	versionedMethods := anObject asSet! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 00:18'!
restoreFrom: aSVNDirectoryEntry
	
	^ self new
		svnDirectoryEntry: aSVNDirectoryEntry;
		restore;
		yourself.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:40'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName
! !

!SVNElement methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 15:10'!
checkAndSolveConflicts

	self svnDirectoryEntry checkAndSolveConflicts! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/27/2008 22:47'!
commit

	self commitWithMessage: 'No commit message'.! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:40'!
commitWithMessage: aString

	self store.
	self svnDirectoryEntry commitWithMessage:aString.
	self changed.
	self flag: #TODO.! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:00'!
establishSvnFilesAndDirectories

	self subclassResponsibility.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/31/2008 23:35'!
hash

	^ self theName hash! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:44'!
initialize

	super initialize.
	self theName: String new.! !

!SVNElement methodsFor: 'testing' stamp: 'rkrk 4/14/2008 04:04'!
isIncludedInEnvironment: svnEnvironment

	^ false! !

!SVNElement methodsFor: 'testing' stamp: 'rkrk 4/14/2008 11:57'!
isIncludedInProject: svnProject


	^ false! !

!SVNElement methodsFor: 'svn state' stamp: 'cop 4/22/2008 14:31'!
keyForStatus: aSelector 
	^ SVNStatusRequest statusKindDictionary keyForIdentity: aSelector! !

!SVNElement methodsFor: 'removing' stamp: 'rkrk 4/20/2008 22:40'!
remove

	(self svnDirectoryEntry) ifNil: [^ self].
	self svnDirectoryEntry remove.
	self changed.! !

!SVNElement methodsFor: 'conflict solving' stamp: 'cop 4/28/2008 15:04'!
resolved

	self resolved! !

!SVNElement methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 00:56'!
restore

	"Hmm... is that good? If we do that than we have to be consistent
	regarding #store. So move serializing into filesystem	into SVNElements?"
	self svnDirectoryEntry read.
	! !

!SVNElement methodsFor: 'convenience' stamp: 'rkrk 4/21/2008 00:17'!
restoreAndLoad

	self
		restore;
		load;
		changed.! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:40'!
revert

	self svnDirectoryEntry revert.
	self restoreAndLoad.! !

!SVNElement methodsFor: 'svn state' stamp: 'cop 4/24/2008 13:46'!
status
	| statusKind myStatus |
	myStatus := svnDirectoryEntry myStatus statusKind.
	(myStatus = #added or: [myStatus = #deleted] or: [myStatus = #missing])
		ifTrue: [^myStatus].
	statusKind := svnDirectoryEntry status statusKind.
	(self keyForStatus: statusKind) > (self keyForStatus: myStatus) ifTrue: [ ^ #modified ].
	^ statusKind! !

!SVNElement methodsFor: 'storing' stamp: 'rkrk 4/21/2008 00:56'!
store! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry

	^ svnDirectoryEntry! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry: aSVNDirectoryEntry

	svnDirectoryEntry := aSVNDirectoryEntry! !

!SVNElement methodsFor: 'svn functions' stamp: 'pe 4/14/2008 11:41'!
svnInfo

	^ (SVNInfoRequest target: self svnDirectoryEntry) execute.! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 00:36'!
theName

	self assert: theName isString.
	^ theName asString! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 20:43'!
theName: anObject
	theName := anObject asString! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:16'!
update

	self svnDirectoryEntry update.
	self restoreAndLoad.	! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/27/2008 22:42'!
updateToRevision: svnRevision

	self svnDirectoryEntry updateToRevision: svnRevision.
	self restoreAndLoad.	! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'nameOfClass category source timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:50'!
forExistingMethod: aCompiledMethod 
	
	^ self new
		forExistingMethod: aCompiledMethod;
		establishSvnFilesAndDirectories;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:14'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodSelector = otherMethod methodSelector and: 
		[self nameOfClass = otherMethod nameOfClass]! !

!SVNMethod methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:11'!
blame

	^ self svnDirectoryEntry blame.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category
	^ category! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category: anObject
	category := anObject! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/21/2008 00:39'!
establishSvnFilesAndDirectories

	"create"
	self file: (SVNFile
		named: self theName
		basePath: '').
	"synch. Put synch in own method? Two way?"
	self flag: #TODO. "This is a store. So call it!!"
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
extractCategoryFrom: svnFile

	^ svnFile properties at: self nameForCategoryProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractClassFrom: svnFile

	^ svnFile properties at: self nameForClassProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 01:58'!
extractSourceCodeFrom: svnFile

	^ svnFile content! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractTimeStampFrom: svnFile

	^ svnFile properties at: self nameForTimeStampProperty! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file

	^ self svnDirectoryEntry! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file: aSVNFile

	self svnDirectoryEntry: aSVNFile! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/20/2008 23:01'!
forExistingMethod: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self
		methodSelector: methodReference methodSymbol;
		nameOfClass: methodReference actualClass name;
		category: methodReference category;
		source: methodReference source;
		timeStamp: methodReference timeStamp.! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:15'!
hash

	^ self methodSelector hash bitXor: self nameOfClass hash.! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:18'!
initialize
	
	super initialize.
	self
		theName: String new; "hmm SVNProject tests fail when theName is not set here... although it is done in super.."
		nameOfClass: String new;
		timeStamp: String new;
		methodSelector: String new;
		source: String new;
		category: String new;
		establishSvnFilesAndDirectories.! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:51'!
isIncludedInProject: svnProject


	^ svnProject allVersionedMethods includes: self! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/1/2008 04:14'!
isPartOfMetaclass

	self flag: #TODO.
	^ (Smalltalk hasClassNamed: self nameOfClass)
		ifTrue: [(Smalltalk classNamed: self nameOfClass) isMeta]
		ifFalse: [self nameOfClass endsWith: ' class'].! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'rkrk 4/20/2008 23:01'!
load
	
	| class relatedSystemEntry |
	"find the correct class"
	relatedSystemEntry := Smalltalk at: self nameOfClass substrings first asSymbol.
	
	class := self isPartOfMetaclass
		ifTrue: [relatedSystemEntry class]
		ifFalse: [relatedSystemEntry].
		
	class
		compile: self source
		classified: self category
		withStamp: self timeStamp
		notifying: nil.
		
	self changed.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector

	^ self theName! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector: aString

	self theName: aString! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
nameForCategoryProperty
	^ 'category'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForClassProperty
	^ 'class'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForTimeStampProperty
	^ 'timestamp'! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass
	^ nameOfClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass: anObject
	nameOfClass := anObject! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/24/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self nameOfClass;
		nextPutAll: '>>';
		nextPutAll: self methodSelector;
		nextPut: $).! !

!SVNMethod methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 00:37'!
restore

	super restore.
	self
		methodSelector: self file theName asString;
		category: (self extractCategoryFrom: self file);
		source: (self extractSourceCodeFrom: self file);
		nameOfClass: (self extractClassFrom: self file);
		timeStamp: (self extractTimeStampFrom: self file).! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source
	^ source! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source: anObject
	source := anObject! !

!SVNMethod methodsFor: 'svn state' stamp: 'mu 4/21/2008 12:57'!
status

	^ svnDirectoryEntry status statusKind! !

!SVNMethod methodsFor: 'storing' stamp: 'rkrk 4/1/2008 02:26'!
store
	
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'functionality' stamp: 'rkrk 4/20/2008 23:00'!
styledBlameText

	self flag: #TODO. "Does this belong here?"
	^ SVNBlameStyler createTextFromBlameLines: self blame.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp
	^ timeStamp! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp: anObject
	timeStamp := anObject! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods workingCopyDirectory repositoryURL repository projectDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 4/13/2008 19:33'!
checkoutProject: aName fromRepository: svnRepository toWorkingCopy: aSVNDirectory 

	| projectDir |
	projectDir := aSVNDirectory createSubDirectoryNamed: aName.
	svnRepository createProject: aName.
	self assert: (svnRepository projectExists: aName).
	
	^ self new
		svnRepository: svnRepository;
		directory: projectDir;
		theName: aName;
		checkout;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 4/13/2008 18:56'!
checkoutProject: aName fromURL: url inWorkingCopy: aSVNDirectory 
	
	| repository |
	repository := SVNRepository on: url.
	repository ifNil: [^ self error: 'Repository does not exists.'].
	^ self checkoutProject: aName fromRepository: repository toWorkingCopy: aSVNDirectory! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:44'!
named: aString 
	
	^ self new
		theName: aString;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNProject methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:50'!
= other

	super = other ifFalse: [^ false].
	^ self versionedClasses = other versionedClasses and:
		[self versionedMethods = other versionedMethods].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/27/2008 04:49'!
addCategory: categoryString

	(Smalltalk organization listAtCategoryNamed: categoryString)
		collect: [:classSymbol | Smalltalk at: classSymbol] 
		thenDo: [:class | self addClass: class].! !

!SVNProject methodsFor: 'adding' stamp: 'cop 4/24/2008 10:17'!
addClass: aClass

	self addSVNClass: (SVNClass forExistingClass: aClass).! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/27/2008 05:06'!
addMethod: aMethod 
	
	self flag: #TODO.
	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	self addSvnMethod: (SVNMethod forExistingMethod: aMethod).! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/27/2008 05:16'!
addSVNClass: svnClass

	self flag: #TODO. "Refactor. Code below is hard to read"
	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	
	self versionedClasses copy
		select: [:ea | ea theName asString = svnClass theName asString]
		thenDo: [:alreadyExistingClass | self versionedClasses remove: alreadyExistingClass].
	self projectDirectory addSubdirectory: svnClass directory.
	self versionedClasses add: svnClass.
	"Wuuuuuahhhh, this was never executed...."
	self versionedMethods do: [:method |
		(method nameOfClass = svnClass theName
		 or: [method nameOfClass = (svnClass theName, ' class')])
			ifTrue: [self removeSVNMethod: method]].
	self store.
	self changed.! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/27/2008 05:06'!
addSvnMethod: svnMethod 
	
	self projectDirectory addFile: svnMethod file.
	self versionedMethods add: svnMethod.
	self store.
	self changed.! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/27/2008 04:52'!
allElements

	^ (OrderedCollection with: self)
		addAll: self versionedMethods;
		addAll: self versionedClasses;
		yourself.! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/27/2008 05:20'!
allVersionedMethods
	
	^ self versionedClasses
		inject: self versionedMethods copy
		into: [:allMethods :class |
			allMethods
				addAll: class versionedMethods;
				yourself].! !

!SVNProject methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:20'!
checkout

	self projectDirectory checkoutFrom: self repositoryURL , '/' , self theName.
	self projectDirectory read.
	self restore.
	self changed.! !

!SVNProject methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:14'!
commit

	self commitWithMessage: 'empty commit message'.! !

!SVNProject methodsFor: 'removing' stamp: 'pe 4/17/2008 15:36'!
deleteClass: aClass
	
	self removeClass: aClass.
	(Smalltalk classNamed: aClass name asString) removeFromSystem.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'pe 4/17/2008 15:36'!
deleteMethod: aMethod

	self removeMethod: aMethod.
	(Smalltalk classNamed: aMethod sourceClass name) removeSelector: aMethod sourceSelector.
	^aMethod! !

!SVNProject methodsFor: 'derived accessing' stamp: 'cop 4/14/2008 11:18'!
directory

	self svnDirectoryEntry ifNil: [self svnDirectoryEntry: (SVNDirectory on: '')].
	^ self svnDirectoryEntry! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/1/2008 16:41'!
directory: svnDirectory

	self svnDirectoryEntry: svnDirectory! !

!SVNProject methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:01'!
establishSvnFilesAndDirectories

	self directory: (SVNDirectory named: self theName).! !

!SVNProject methodsFor: 'notifying' stamp: 'rkrk 4/15/2008 01:02'!
event: anEvent

	| method |
	self halt.
	(anEvent isRemoved and:
	[anEvent itemKind = #class])
		ifTrue: [(self versionedClasses includes: (SVNClass forExistingClass: anEvent itemClass))
				ifTrue: [self removeClass: anEvent itemClass]].

	(anEvent isRemoved and:
	[anEvent itemKind = #method])
		ifTrue: [method := self versionedMethods
							detect: [:each |
								(each methodSelector = anEvent itemSelector) and:
								[each nameOfClass = anEvent itemClass name]]
							ifNone: [nil].
				method ifNotNil: [self removeSVNMethod: method]]! !

!SVNProject methodsFor: 'finding' stamp: 'cop 4/18/2008 12:13'!
findClass: aString
	^self versionedClasses detect: [:class| class theName = aString] ifNone: [nil]! !

!SVNProject methodsFor: 'testing' stamp: 'rkrk 4/14/2008 11:57'!
includes: svnElement

	^ svnElement isIncludedInProject: self.! !

!SVNProject methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:08'!
initialize

	super initialize.
	self
		versionedClasses: Set new;
		versionedMethods: Set new;
		repositoryURL: nil.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'cop 4/14/2008 21:10'!
load
	SVNLoader
		loadSVNClasses: self versionedClasses copy
		andSVNMethods: self versionedMethods copy! !

!SVNProject methodsFor: 'notifying' stamp: 'rkrk 4/17/2008 09:01'!
notifyAboutSystemModifications: aBoolean

	| notifier |
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean ifTrue: [self halt].
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:.
			notifier
				notify: self
				ofSystemChangesOfItem: #method
				using: #event:].! !

!SVNProject methodsFor: 'printing' stamp: 'rkrk 3/3/2008 20:30'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rt 4/13/2008 18:35'!
projectDirectory

"	^ self workingCopyDirectory createSubDirectoryNamed: self theName."
	^ self directory! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/13/2008 13:27'!
removeClass: aClass

	| svnClass |
	svnClass := SVNClass forExistingClass: aClass.
	self removeSVNClass: svnClass.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 11:15'!
removeMethod: aMethod

	| svnMethod |
	svnMethod := SVNMethod forExistingMethod: aMethod.
	self removeSVNMethod: svnMethod.
	^aMethod! !

!SVNProject methodsFor: 'removing' stamp: 'rkrk 4/28/2008 03:16'!
removeSVNClass: aSVNClass

	self versionedClasses remove: aSVNClass.
	self projectDirectory removeSVNDirectory: aSVNClass directory.
	aSVNClass remove. " Remove from filesystem"
	self changed.! !

!SVNProject methodsFor: 'removing' stamp: 'cop 4/24/2008 11:41'!
removeSVNMethod: aSVNMethod

	| includedMethod |
	includedMethod := self versionedMethods
							detect: [:each |
								(each methodSelector = aSVNMethod methodSelector and:
								[each nameOfClass = aSVNMethod nameOfClass])]
							ifNone: [^ self].
	self projectDirectory files remove: includedMethod file.
	self versionedMethods remove: (includedMethod remove).
	self changed.
	^includedMethod! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:49'!
repositoryURL
	
	self svnRepository ifNil: [^''].
	^ self svnRepository url! !

!SVNProject methodsFor: 'accessing' stamp: 'cop 4/14/2008 11:33'!
repositoryURL: anUrl

	anUrl ifNil: [^ self].
	(SVNRepository repositoryExistsOn: anUrl) ifFalse: [^ self error: 'Repository does not exists.'].
	self svnRepository: (SVNRepository on: anUrl).
	self svnRepository createProject: self theName.! !

!SVNProject methodsFor: 'restoring' stamp: 'rkrk 4/28/2008 03:38'!
restore
	
	super restore.
	self theName: self directory theName.
	"If I have classes which are not included in the directory from which
	I restore now, I will remove those classes."
	self versionedClasses
		select: [:ea | (self directory subdirectories includes: ea directory) not]
		thenDo: [:ea | self removeSVNClass: ea].
	self directory subdirectories do: [:each |
		self addSVNClass: (SVNClass restoreFrom: each)].
	self flag: #TODO. "Load methods of project"! !

!SVNProject methodsFor: 'svn state' stamp: 'cop 4/23/2008 13:19'!
statusProjectMethods

	| statusKind myStatus highestStatus |
	self flag: #TODO. "Refactor!! find something better"
	myStatus := svnDirectoryEntry myStatus statusKind.
	(myStatus = #added or: [myStatus = #deleted] or: [myStatus = #missing])
		ifTrue: [^myStatus].
	statusKind := svnDirectoryEntry files collect: [:file| file status statusKind].
	SVNStatusRequest statusKindDictionary do: [:ea| (statusKind includes: ea)
		ifTrue: [highestStatus := ea]].
	(self keyForStatus: highestStatus) > (self keyForStatus: myStatus) ifTrue: [ ^ #modified ].
	^ highestStatus! !

!SVNProject methodsFor: 'storing' stamp: 'rkrk 4/15/2008 05:03'!
store

	self versionedMethods do: [:each | each store.].
	self versionedClasses do: [:each | each store].

	"Now write files and directories"
	self projectDirectory store.! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:47'!
svnRepository

	^ repository! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:46'!
svnRepository: aSVNRepository

	repository := aSVNRepository! !

!SVNProject methodsFor: 'accessing' stamp: 'cop 4/14/2008 11:14'!
theName: aString
	super theName: aString.
	self directory theName: aString.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'rkrk 2/25/2008 01:48'!
unload
	self flag: #TODO.! !

!SVNProject methodsFor: 'accessing' stamp: 'mu 3/31/2008 13:19'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 4/1/2008 15:57'!
versionedClasses: anObject
	versionedClasses := anObject! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 3/8/2008 17:55'!
versionedMethods
	
	^ versionedMethods! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 4/1/2008 15:58'!
versionedMethods: anObject
	versionedMethods := anObject! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:13'!
workingCopyDirectory

	^ self error: 'does not supported any longer'! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:13'!
workingCopyDirectory: anObject

	^ self error: 'does not supported any longer'! !

Object subclass: #SVNEnvironment
	instanceVariableNames: 'svnProjects currentProject'
	classVariableNames: 'CurrentSVNEnvironment'
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNEnvironment class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 01:57'!
forSvnProjects: collection

	^ self new
		svnProjects: collection;
		yourself.! !

!SVNEnvironment methodsFor: 'adding' stamp: 'rkrk 4/14/2008 21:38'!
addSvnProject: svnProject

	self svnProjects add: svnProject.! !

!SVNEnvironment methodsFor: 'derived accessing' stamp: 'rkrk 4/15/2008 02:01'!
allSvnClasses

	^ self svnProjects gather: [:ea | ea versionedClasses].! !

!SVNEnvironment methodsFor: 'derived accessing' stamp: 'rkrk 4/24/2008 12:02'!
allSvnMethods

	^ self svnProjects gather: [:ea | ea allVersionedMethods].! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:49'!
currentProject
	^ currentProject! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:49'!
currentProject: anObject
	currentProject := anObject! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:50'!
currentSvnProjectChanged: aSVNCurrentProjectChangedAnn

	self currentProject: aSVNCurrentProjectChangedAnn currentProject! !

!SVNEnvironment methodsFor: 'finding' stamp: 'cop 4/22/2008 14:17'!
findSvnClassFor: aClass

	^ self allSvnClasses
		detect: [:ea | (ea theName = aClass name) or: [ea theName, ' class' = aClass name]]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/14/2008 22:53'!
findSvnMethodForMethod: compiledMethod

	^ self findSvnMethodForMethodRef: compiledMethod methodReference.! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/24/2008 12:03'!
findSvnMethodForMethodRef: methodRef

	^ self allSvnMethods
		detect: [:ea |
			ea nameOfClass asString = methodRef actualClass asString and:
				[ea theName = methodRef methodSymbol asString] and:
				[ea isPartOfMetaclass = methodRef classIsMeta]]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/24/2008 13:00'!
findSvnMethodNamed: aStringOrSymbol

	^ self allSvnMethods
		detect: [:ea | ea theName = aStringOrSymbol asSymbol]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/25/2008 15:48'!
findSvnProjectFor: svnElement

	"Kludge. Use double dispatch"
	self flag: #TODO.
	svnElement ifNil: [^ nil].
	(svnElement isKindOf: SVNProject) ifTrue: [^ svnElement].
	^ (svnElement isKindOf: SVNMethod)
		ifTrue: [
			self svnProjects
				detect: [:ea | ea allVersionedMethods includes: svnElement]
				ifNone: [nil]]
		ifFalse: [
			self svnProjects
				detect: [:ea | ea versionedClasses includes: svnElement]
				ifNone: [nil]].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/21/2008 10:43'!
findSvnProjectNamed: aString

	^ self svnProjects
		detect: [:ea | ea theName = aString]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 02:03'!
findSvnProjectOrSvnClassForSvnMethod: method

	| result |
	result := self svnProjects
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].
	result ifNotNil: [^ result].
	^ self allSvnClasses
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'testing' stamp: 'rkrk 4/14/2008 22:14'!
includes: anObject

	^ anObject includedInSvnEnvironment: self.! !

!SVNEnvironment methodsFor: 'initialization' stamp: 'rkrk 4/14/2008 21:40'!
initialize

	super initialize.
	self svnProjects: Set new.! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:50'!
subscribeWithAnnouncer: anOBAnnouncer

	anOBAnnouncer
		observe: SVNCurrentProjectChanged
		send: #currentSvnProjectChanged:
		to: self.! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects
	^ svnProjects! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects: anObject
	svnProjects := anObject! !

SVNEnvironment subclass: #SVNRegistry
	instanceVariableNames: ''
	classVariableNames: 'Current CurrentSVNRegistry'
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNRegistry class methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 15:16'!
current

	CurrentSVNRegistry ifNil: [self initialize].
	^ CurrentSVNRegistry! !

!SVNRegistry class methodsFor: 'initialization' stamp: 'rkrk 4/25/2008 15:15'!
initialize

	"self initialize"
	CurrentSVNRegistry := self forSvnProjects: Set new.! !

!SVNRegistry class methodsFor: 'initialization' stamp: 'rkrk 4/26/2008 19:48'!
restart

	"self restart"
	| svnProjects |
	svnProjects := self current svnProjects.
	self initialize.
	self current svnProjects: svnProjects.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/26/2008 19:49'!
classChanged: anEvent

	| svnClass |
	svnClass := self findSvnClassFor: anEvent oldItem.
	svnClass ifNil: [^ self].
	svnClass forExistingClass: anEvent item.
	(self findSvnProjectFor: svnClass)
		ifNotNilDo: [:project | project store. project changed.].
	svnClass changed.
! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 15:49'!
classRemoved: anEvent

	| class container |
	self flag: #TODO. "under construction"
	class := self findSvnClassFor: anEvent item.
	class ifNil: [^ self].
	container := self findSvnProjectFor: class.
	container removeSVNClass: class.
	class remove.
	container changed.! !

!SVNRegistry methodsFor: 'svn environment' stamp: 'rkrk 4/24/2008 13:10'!
createSvnEnvironment

	^ SVNEnvironment forSvnProjects: self svnProjects! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 09:27'!
extractMethodFromEvent: anEvent

	self flag: #TODO. "..."
	(anEvent class canPerform: #oldItem)
		ifTrue: [^ anEvent oldItem].
	^ anEvent item! !

!SVNRegistry methodsFor: 'initialization' stamp: 'rkrk 4/25/2008 14:01'!
initialize
	
	super initialize.
	self notifyAboutSystemChanges: true.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 15:45'!
methodChanged: anEvent

	| method |
	method := self findSvnMethodForMethod: (self extractMethodFromEvent: anEvent).
	method ifNil: [^ self].
	method forExistingMethod: anEvent item.
	(self findSvnProjectFor: method)
		ifNotNilDo: [:project | project store. project changed.].
	method changed.
	(self findSvnProjectFor: method) changed.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 15:49'!
methodRemoved: anEvent

	| method container |
	method := self findSvnMethodForMethod: anEvent item.
	method ifNil: [^ self].
	container := self findSvnProjectOrSvnClassForSvnMethod: method.
	container removeSVNMethod: method.
	method remove.
	(self findSvnProjectFor: container) changed.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/26/2008 19:48'!
notifyAboutSystemChanges: aBoolean

	| notifier |
	"self restart"
	self flag: #TODO. "What about #category, #protocol?"
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				change: #Removed
				using: #classRemoved:.
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				change: #Modified
				using: #classChanged:.
			"Subscribe methods"
			#(#Modified #Recategorized #Reorganized #Renamed #Commented) do: [:ea |
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: ea
					using: #methodChanged:.].
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: #Removed
					using: #methodRemoved:.].! !

Object subclass: #SVNErrorCatcher
	instanceVariableNames: 'block successful'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNErrorCatcher class methodsFor: 'svn constants' stamp: 'rt 4/26/2008 16:02'!
errorDictionary

	^ Dictionary new
		at: 0		put: #onSuccess;
		at: 155000	put: #onWorkingCopyForDifferentURL;
		at: 150002	put: #onAlreadyUnderVersionControl;
		at: 150004	put: #onHasNoUrl;
		at: 155007	put: #onIsNotAWorkingCopy;
		at: 160013	put: #onFileNotFound;
		at: 160017	put: #onNotAFile;
		at: 170000	put: #onNonExistentInRevision;
		at: 170001	put: #onAuthenticationFailure;
		at: 200005	put: #onNotUnderVersionControl;
		at: 210005	put: #onRepositoryDoesNotExists;
		at: 730061	put: #onCanNotConnectToHost;
		yourself! !

!SVNErrorCatcher class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 15:42'!
on: aBlock

	^ self new
		onBlock: aBlock;
		yourself! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:42'!
block

	^ block! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rkrk 4/26/2008 03:11'!
execute

	| result |
	successful := false.
	"Transcript show: 'Calling SVN: ' , self block asString; cr."
	Cursor wait showWhile: [result := self block value].
	
	self perform: (self class errorDictionary
		at: result
		ifAbsent: ["#unsupportedErrorCode"
			Transcript show: 'Unsupported error code: ' , result asString; cr. ^ self]).! !

!SVNErrorCatcher methodsFor: 'initialize' stamp: 'rt 4/22/2008 16:10'!
initialize

	super initialize.
	successful := false.
	block := [0]! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:39'!
onAlreadyUnderVersionControl! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 18:44'!
onAuthenticationFailure

	| svnUser |
	svnUser :=(SVNAuthenticationRequestDialog
		withUsernameTemplate: ''
		andPasswordTemplate: '').
	svnUser ifNil: [^ self].
	
	(SVNAuthenticationRequest
		onUsername: svnUser user
		andPassword: svnUser password) execute.
		
	self execute.
	
	"reset to default"
	"(SVNAuthenticationRequest
		onUsername: ''
		andPassword: '') execute."! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:03'!
onBlock: aBlock

	block := aBlock! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/26/2008 16:02'!
onCanNotConnectToHost! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:41'!
onFileNotFound! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 18:29'!
onHasNoUrl
	"nothing"! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 18:27'!
onIsNotAWorkingCopy
	"nothing"! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:40'!
onNonExistentInRevision! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/24/2008 11:31'!
onNotAFile! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:38'!
onNotUnderVersionControl! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 16:53'!
onRepositoryDoesNotExists

	SVNMessageBox openWith: 'No repository found.'! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 15:48'!
onSuccess

	successful := true! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 16:51'!
onWorkingCopyForDifferentURL

	SVNMessageBox
		openWith: 'The working copy is already a working copy for a different URL.'! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:06'!
successful

	^ successful! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rkrk 4/24/2008 09:54'!
unsupportedErrorCode

	"send me an eMail"
	"SVNMessageBox openWith: 'Please contact the application support team.'"! !

Object subclass: #SVNLoader
	instanceVariableNames: 'requiredClasses classesToLoad unknownRequiredClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:27'!
loadSVNClasses: aSet
"superclasses"
	^self loadSVNClasses: aSet andSVNMethods: (Set new)! !

!SVNLoader class methodsFor: 'loading' stamp: 'rkrk 4/1/2008 12:12'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet

	self flag: #TODO. "implement unload..., reload (unload->load)"
	^ self new
		loadSVNClasses: aSVNClassSet
		andSVNMethods: aSVNMethodSet;
		yourself.! !

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:26'!
loadSVNMethods: aSet
"Classes"
	^self loadSVNClasses: (Set new) andSVNMethods: aSet! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/8/2008 16:44'!
addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet 

	| newDependencies |
	self classesToLoad addAll: (aSVNClassSet collect: [:each | each theName]).
	newDependencies := aSVNClassSet collect: [:each | each superclassName asString].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/10/2008 13:12'!
addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet 

	| newDependencies |
	newDependencies := aSVNMethodSet collect: [:each | each nameOfClass substrings first].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 12:01'!
classesToLoad
	^classesToLoad! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 23:05'!
findOriginInSystemFor: aSVNClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet

	| ownSuperclassName svnSuperClass |
	ownSuperclassName := aSVNClass superclassName.
	ownSuperclassName = aString ifTrue: [^nil].
	(aSet includes: ownSuperclassName) ifFalse: [^ownSuperclassName].
			
	svnSuperClass := (aSVNClassSet select: [:aClass | aClass theName = ownSuperclassName]) someElement.
	
	^self findOriginInSystemFor: svnSuperClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet.! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/7/2008 23:05'!
hasCycle: aSVNClassSet.
	"Answer if there is a cycle in the set of svnClasses.
	Needs that addToRequiredClassesAllDependenciesInSVNClasses: had running."

	aSVNClassSet do: [:eachClass |
			(self
				findOriginInSystemFor: eachClass
				superclassCanNotBe: eachClass theName
				superclassMustBeInSystemOr: aSVNClassSet
				consider: (self requiredClasses intersection: (self classesToLoad))) ifNil: [^true]].
	^false! !

!SVNLoader methodsFor: 'initialization' stamp: 'rt 3/7/2008 12:09'!
initialize
	super initialize.
	requiredClasses := Set new.
	classesToLoad := Set new.
	unknownRequiredClasses := Set new! !

!SVNLoader methodsFor: 'loading' stamp: 'rt 3/10/2008 13:14'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet 

	self addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	self addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet.
	
	self flag: #TODO. "abort, if some required classes are unknown or there are cycles"
	self unknownRequiredClasses ifNotEmpty: [^self].
	(self hasCycle: aSVNClassSet) ifTrue: [^self].
	
	self loadSVNClassesSorted: aSVNClassSet.
	aSVNMethodSet do: [:each | each load]! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/10/2008 13:14'!
loadSVNClassesSorted: aSVNClassSet

	| sortedClasses |
	sortedClasses := self sortSVNClasses: aSVNClassSet consider: (self requiredClasses intersection: self classesToLoad).
	
	sortedClasses do: [:each | each load]! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 00:37'!
requiredClasses
	^requiredClasses! !

!SVNLoader methodsFor: 'sorting' stamp: 'rt 3/7/2008 22:29'!
sortSVNClasses: aSVNClassSet consider: aSet

	| allSubclasses subclasses |
	aSet ifEmpty: [^aSVNClassSet].
	allSubclasses := Set new.
	aSVNClassSet do: [:each |
		(aSet includes: each theName)
			ifTrue: [subclasses := aSVNClassSet select: [:subClass |
												(subClass superclassName = each theName)].
					each subclasses addAll: subclasses.
					allSubclasses addAll: subclasses]].
	
	aSVNClassSet removeAll: allSubclasses.
	^aSVNClassSet! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/8/2008 16:49'!
unknownRequiredClasses
	"all required classes, which are not in classesToLoad and unknown in the system"
	| unknownClasses realyUnknownClasses class |
	unknownClasses := self requiredClasses copy.
	unknownClasses removeAllFoundIn: self classesToLoad.
	realyUnknownClasses := Set new.
	unknownClasses do: [:each | 
		class := Smalltalk classNamed: each.
		(class isNil or: [class isObsolete]) ifTrue: [realyUnknownClasses add: each]].
	^realyUnknownClasses
	! !

Object subclass: #SVNNode
	instanceVariableNames: 'svnElement svnEnvironment parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

SVNNode subclass: #SVNClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassNode methodsFor: 'functionality' stamp: 'rkrk 4/21/2008 02:06'!
getChildren

	^ {SVNInstanceSideOfClassNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.
	SVNClassSideOfClassNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.
	SVNCommentNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.}.! !

SVNNode subclass: #SVNClassSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:36'!
getChildren

	^ self sortChildren: (self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass]
		thenCollect: [:each | SVNMethodNode
				element: each
				parent: self
				svnEnvironment: self svnEnvironment]).! !

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:17'!
getLabel

	^ 'class'! !

!SVNClassSideOfClassNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 11:40'!
status
	^self svnElement statusClassMethods! !

SVNNode subclass: #SVNCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNCommentNode methodsFor: 'functionality' stamp: 'rkrk 4/6/2008 03:44'!
getLabel

	^ 'comment'! !

!SVNCommentNode methodsFor: 'as yet unclassified' stamp: 'mu 4/21/2008 11:40'!
status
	^self svnElement statusComment! !

SVNNode subclass: #SVNInstanceSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:37'!
getChildren
	^ self sortChildren: (self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass not]
		thenCollect: [:each |
			SVNMethodNode
				element: each
				parent: self
				svnEnvironment: self svnEnvironment.]).! !

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:52'!
getLabel
	^'instance'! !

!SVNInstanceSideOfClassNode methodsFor: 'svn functions' stamp: 'rkrk 4/25/2008 15:20'!
status

	^ self svnElement statusInstanceMethods! !

SVNNode subclass: #SVNMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 02:03'!
element: aSVNElement parent: aSVNNode svnEnvironment: svnEnvironment
	
	^ (self element: aSVNElement svnEnvironment: svnEnvironment)
		parent: aSVNNode;
		yourself.! !

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 02:03'!
element: aSVNElement svnEnvironment: svnEnvironment
	
	^self new
		svnElement: aSVNElement;
		svnEnvironment: svnEnvironment;
		yourself.! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:13'!
belongsToCurrentSvnProject

	"Kludge. Needed becaus of compatibility for OBSystemBrowser"
	^ true! !

!SVNNode methodsFor: 'derived accessing' stamp: 'rkrk 4/23/2008 09:32'!
currentSvnProject

	"Actually this method is not needed here yet. It has to be implemented from
	OBCodeNodes, But SVNNodes are only used in SVNProjects and there is no current
	Project there..."
	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment currentProject.! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:18'!
getChildren

	^ OrderedCollection new! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/12/2008 11:43'!
getLabel

	^ self svnElement theName! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:35'!
hasSvnElementOfKind: aClass

	^ self svnElement isKindOf: aClass! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent

	^ parent! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent: aSVNNode

	parent := aSVNNode! !

!SVNNode methodsFor: 'message handling' stamp: 'rkrk 4/6/2008 03:41'!
perform: selector orSendTo: otherTarget

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:36'!
sortChildren: aCol
	^aCol asSortedCollection: [:a :b| a svnElement theName < b svnElement theName ]! !

!SVNNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 11:38'!
status
	^self svnElement status! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement

	^ svnElement! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement: aSVNElement

	svnElement := aSVNElement! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 02:04'!
svnEnvironment
	^ svnEnvironment! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 02:04'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

SVNNode subclass: #SVNNodeMock
	instanceVariableNames: 'kindOfClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNNodeMock class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 09:56'!
shouldBeKindOfClass: aClass

	^ self new
		shouldBeKindOfClass: aClass;
		yourself.! !

!SVNNodeMock methodsFor: 'initialization' stamp: 'rkrk 4/23/2008 09:58'!
initialize

	super initialize.
	self kindOfClasses: Set new.! !

!SVNNodeMock methodsFor: 'testing' stamp: 'rkrk 4/23/2008 09:51'!
isKindOf: class

	(self kindOfClasses includes: class) ifTrue: [^ true].
	^ super isKindOf: class.! !

!SVNNodeMock methodsFor: 'accessing' stamp: 'rkrk 4/23/2008 09:52'!
kindOfClasses
	^ kindOfClasses! !

!SVNNodeMock methodsFor: 'accessing' stamp: 'rkrk 4/23/2008 09:52'!
kindOfClasses: anObject
	kindOfClasses := anObject! !

!SVNNodeMock methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 09:58'!
shouldBeKindOfClass: aClass

	| class |
	class := aClass.
	[class = ProtoObject] whileFalse: [
		self kindOfClasses add: class.
		class := class superclass].! !

SVNNode subclass: #SVNProjectMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectMethodNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:37'!
getChildren

	^ self sortChildren: (self svnElement versionedMethods
		collect: [:each | SVNMethodNode
			element: each
			parent: self
			svnEnvironment: self svnEnvironment]).! !

!SVNProjectMethodNode methodsFor: 'functionality' stamp: 'rkrk 4/15/2008 06:52'!
getLabel

	^ 'methods'! !

!SVNProjectMethodNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 12:04'!
status
	^self svnElement statusProjectMethods! !

SVNNode subclass: #SVNProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:45'!
getChildren

	| children |
	children := self svnElement versionedClasses
		collect: [:each | SVNClassNode
						element: each
						parent: self
						svnEnvironment: self svnEnvironment].
	children := self sortChildren: children.
	self svnElement versionedMethods ifNotEmpty: [
		children add: (SVNProjectMethodNode
						element: self svnElement
						parent: self
						svnEnvironment: self svnEnvironment)].
	^ children! !

Object subclass: #SVNRepository
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRepository class methodsFor: 'instance creation' stamp: 'rt 4/9/2008 00:28'!
on: anURL

	(self repositoryExistsOn: anURL) ifFalse: [^nil].
	^self new
		setUrl: anURL;
		yourself! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:02'!
primitiveSvnExistsRepositoryOnUrl: anUrl
	<primitive: 'svnExistsRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 12:41'!
primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl
	<primitive: 'svnRequireAuthenticationAtRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:01'!
repositoryExistsOn: anUrl

	^ self primitiveSvnExistsRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 12:58'!
requireAuthenticationAtRepositoryOnUrl: anUrl

	^ self primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/23/2008 19:38'!
createProject: aName

	(self projectExists: aName)
		ifFalse: [(SVNErrorCatcher on: [self
					primitiveCreateProject: aName
					onUrl: self url pathForSvn]) execute].
	^ aName! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:24'!
primitiveCreateProject: aName onUrl: anUrl

	<primitive: 'svnCreateProjectOnRepository' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/23/2008 15:40'!
primitiveProject: aName onRepository: anUrl exists: aBoolInAnArray

	<primitive: 'svnProjectOnExists' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository methodsFor: 'printing' stamp: 'rt 4/21/2008 13:06'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	aStream nextPutAll: '''', self url , ''''.
	aStream nextPut: $).! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/23/2008 15:41'!
projectExists: aName

	| arrayOfBool |
	arrayOfBool := {nil}.
	(SVNErrorCatcher on: [self
		primitiveProject: aName
		onRepository: self url pathForSvn
		exists: arrayOfBool]) execute.
	^ arrayOfBool at: 1! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:12'!
repositoryExists

	^ self class repositoryExistsOn: self url! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:13'!
requiresAuthentication

	^ self class requireAuthenticationAtRepositoryOnUrl: self url! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 4/8/2008 12:41'!
setUrl: anUrl
	url := anUrl! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 3/30/2008 23:45'!
url
	^url! !

Object subclass: #SVNRequest
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNRequest subclass: #SVNBlameLinesRequest
	instanceVariableNames: 'blameLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNBlameLinesRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 17:53'!
basicSvnGetBlameLinesFrom: aTarget storeLinesIn: lineArray
	<primitive: 'svnGetBlameLinesFromStoreLinesIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNBlameLinesRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 17:47'!
basicSvnGetCountOfBlameLinesFrom: aTarget StoreCountIn: arrayForNumber
	<primitive: 'svnGetCountOfBlameLinesFromStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 17:44'!
blameLines

	^ blameLines! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 17:44'!
blameLines: anObject

	blameLines := anObject! !

!SVNBlameLinesRequest methodsFor: 'execution' stamp: 'rt 4/23/2008 18:22'!
execute

	| arrayForNumber number linesArray errorCatcher |
	errorCatcher := SVNErrorCatcher new.
	
	"get count of lines"
	arrayForNumber := {nil}.
	errorCatcher
		onBlock: [self
			basicSvnGetCountOfBlameLinesFrom: self target pathForSvn
			StoreCountIn: arrayForNumber];
		execute.
	errorCatcher successful
		ifTrue: [number := arrayForNumber at: 1]
		ifFalse: [number := 0].
	
	"get lines"
	number = 0 ifTrue: [^ self processResult: Array new].
	linesArray := self forPrimitiveGetArrayOfSize: number.
	errorCatcher
		onBlock: [self
			basicSvnGetBlameLinesFrom: self target pathForSvn
			storeLinesIn: linesArray];
		execute.
	errorCatcher successful
		ifTrue: [self processResult: (linesArray collect: [:ea | ea copyUpTo: (Character value: 0)]) asArray]
		ifFalse: [self processResult: Array new].! !

!SVNBlameLinesRequest methodsFor: 'execution' stamp: 'rt 4/23/2008 17:44'!
processResult: result

	self blameLines: result! !

SVNRequest subclass: #SVNCommitLogsRequest
	instanceVariableNames: 'commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNCommitLogsRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 19:51'!
basicSvnGetCommitLogs: count
	from: targetStringForSvnPrimitive
	to: revisionNumberOop
	storeInArray: resultArray
	
	<primitive: 'svnGetCommitLogsFromToStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNCommitLogsRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 19:51'!
basicSvnGetCountOfCommitLogsFrom: aTarget
	to: headRevisionNumber
	storeCountIn: arrayForCount
	
	<primitive: 'svnGetCountOfCommitLogsFromToStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNCommitLogsRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 20:06'!
commitLogs

	^ commitLogs! !

!SVNCommitLogsRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 20:06'!
commitLogs: anObject

	commitLogs := anObject! !

!SVNCommitLogsRequest methodsFor: 'execution' stamp: 'rt 4/27/2008 07:09'!
execute

	| count arrayForCount errorCatcher logsArray |
	errorCatcher := SVNErrorCatcher new.
	
	"get count of logs"
	arrayForCount := {nil}.
	errorCatcher
		onBlock: [self
			basicSvnGetCountOfCommitLogsFrom: self target pathForSvn
			to: self revisionNumber
			storeCountIn: arrayForCount];
		execute.
	count := arrayForCount first.

	"get the logs"
	logsArray := self forPrimitiveGetArrayOfSize: 4 * count.
	errorCatcher
		onBlock: [self
			basicSvnGetCommitLogs: count
			from: self target pathForSvn
			to: self revisionNumber
			storeInArray: logsArray];
		execute.
	errorCatcher successful
		ifTrue: [self processResult: (self getLogsFromArray: logsArray)]
		ifFalse: [self processResult: (self getLogsFromArray: Array new)].! !

!SVNCommitLogsRequest methodsFor: 'converting' stamp: 'rt 4/23/2008 20:20'!
getLogsFromArray: anArray

	| logs |
	logs := OrderedCollection new.
	anArray ifEmpty: [^ logs].
	
	1 to: (anArray size) by: 4 do: [:index | 
		logs add: (SVNCommitLog 
			createCommitLogWithRevision: (anArray at: index) asInteger
			author: ( (anArray at: index+1) copyUpTo: (Character value: 0) )
			date: ( (anArray at: index+2) copyUpTo: (Character value: 0) ) 
			comment: ( (anArray at: index+3) copyUpTo: (Character value: 0) ))].  
	^ logs! !

!SVNCommitLogsRequest methodsFor: 'execution' stamp: 'rt 4/23/2008 20:11'!
processResult: anObject

	self commitLogs: anObject! !

!SVNCommitLogsRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 20:01'!
revisionNumber

	self flag: #TODO.
	^ (SVNCApiClient new) svnGetHeadRevision: self target! !

SVNRequest subclass: #SVNInfoRequest
	instanceVariableNames: 'targetRevision author revision lastChangedRevision date repositoryRootUrl repositoryUUID schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 04:33'!
arrayForPrimitive

	"Pass this array down and fill in the elements the result of svn info"
	^ {
		self stringForRepositoryRootUrl.
		self elementForRevision.			"Current revision"
		self stringForRepositoryUUID.
		self elementForRevision.			"Last changed revision"
		self stringForDate.
		self stringForAuthor.
		self stringForSchedule
	}! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:42'!
elementForRevision

	^ SVNRevision unspecified! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForAuthor

	^ String new: 125! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForDate

	"apr_ctime returns a string of size 25"
	^ String new: 25! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForRepositoryRootUrl

	^ String new: 255! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:20'!
stringForRepositoryUUID

	^ String new: 36! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForSchedule

	^ String new: 8! !

!SVNInfoRequest class methodsFor: 'instance creation' stamp: 'mu 3/31/2008 15:14'!
target: svnDirectoryEntry

	^ self new
		target: svnDirectoryEntry;
		yourself.! !

!SVNInfoRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/26/2008 02:31'!
target: svnDirectoryEntry forRevision: svnRevision

	^ self new
		target: svnDirectoryEntry;
		targetRevision: svnRevision;
		yourself.! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 3/23/2008 02:51'!
arrayForPrimitive

	"Some objects are mapped to more than one object for their
	representation in the primitive. E.g. a SVNRevision is mapped
	to: <KindString>. NumberOrNil"
	^ (self class arrayForPrimitive
		inject: OrderedCollection new
		into: [:preparedCol :each |
			preparedCol addAll: each forSvnPrimitive.
			preparedCol]) asArray.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author
	^ author! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author: anObject
	author := anObject! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 3/24/2008 11:24'!
basicSvnGetInfoFrom: targetPath revisionKind: revKind revisionNumber: revNumber storeInArray: array

	<primitive: 'svnInfoForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNInfoRequest methodsFor: 'service' stamp: 'rkrk 3/23/2008 03:35'!
convertToDateFromCTimeString: aString

	self flag: #TODO. "Implement the thing"
	^ DateAndTime current! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date
	^ date! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date: anObject
	date := anObject! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'rkrk 4/26/2008 02:49'!
execute

	| arrayForPrimitive |
	
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 9.
	
	(SVNErrorCatcher on: [self
		basicSvnGetInfoFrom: self target path pathForSvn
		revisionKind: self targetRevision kind
		revisionNumber: self targetRevision number
		storeInArray: arrayForPrimitive]) execute.

	"check for success ?"
	
	self processResult: arrayForPrimitive.! !

!SVNInfoRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/26/2008 03:23'!
initialize

	super initialize.
	self targetRevision: SVNRevision unspecified.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision
	^ lastChangedRevision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision: anObject
	lastChangedRevision := anObject! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
null

	^ Character value: 0! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
prepareStringForPrimitive: string

	"self assert: (string includes: self null) not."
	string at: string size put: self null.
	^ string convertToSystemString.! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
prepareStringForSqueak: string

	^ string asDefaultDecodedString copyUpTo: (Character value: 0).	! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 16:19'!
processResult: resultArray

	| preparedArray |
	self flag: #TODO. "Implicit mapping. Where should the indices be stored?"
	preparedArray := resultArray collect: [:each | each isString
		ifTrue: [self prepareStringForSqueak: each]
		ifFalse: [each]].
	self repositoryRootUrl: (preparedArray at: 1).
	self revision: (SVNRevision
		fromKind: (preparedArray at: 2)
		number: (preparedArray at: 3)).
	self repositoryUUID: (preparedArray at: 4).
	self lastChangedRevision: (SVNRevision
		fromKind: (preparedArray at: 5)
		number: (preparedArray at: 6)).
	self date: (self convertToDateFromCTimeString: (preparedArray at: 7)).
	self author: (preparedArray at: 8).
	self schedule: (preparedArray at: 9).! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl
	^ repositoryRootUrl! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl: anObject
	repositoryRootUrl := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID
	^ repositoryUUID! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID: anObject
	repositoryUUID := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision
	^ revision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision: anObject
	revision := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule
	^ schedule! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule: anObject
	schedule := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 4/26/2008 02:31'!
targetRevision
	^ targetRevision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 4/26/2008 02:31'!
targetRevision: anObject
	targetRevision := anObject! !

SVNRequest subclass: #SVNPropertiesRequest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNPropertiesRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 19:04'!
basicSvnGetCountOfPropertiesOf: pathForPrimitives storeCountIn: arrayForCount
	<primitive: 'svnGetCountOfPropertiesOnStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNPropertiesRequest methodsFor: 'primitives' stamp: 'rt 4/17/2008 17:28'!
basicSvnGetPropertiesOf: pathOop StoreInArray: resultArray
	<primitive: 'svnGetPropertiesOfStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNPropertiesRequest methodsFor: 'converting' stamp: 'rt 4/17/2008 18:19'!
dictionaryFromArray: anArray

	| resultDict realArray |
	resultDict := Dictionary new.
	realArray := (anArray collect: [:ea | ea copyUpTo: (Character value: 0)]) asArray.
	
	realArray ifNil: [^ resultDict].
	realArray pairsDo: [:key :value |
		resultDict at: key put: value].
	^ resultDict.! !

!SVNPropertiesRequest methodsFor: 'execution' stamp: 'rt 4/23/2008 19:13'!
execute

	| count resultArray arrayForCount errorCatcher |
	errorCatcher := SVNErrorCatcher new.
	
	arrayForCount := {nil}.
	errorCatcher
		onBlock: [self
			basicSvnGetCountOfPropertiesOf: self target pathForSvn
			storeCountIn: arrayForCount];
		execute.
	count := arrayForCount at: 1.	
	count = 0 ifTrue: [^ self processResult: Dictionary new; yourself].
	
	resultArray := (self forPrimitiveGetArrayOfSize: 2*count).
	errorCatcher
		onBlock: [self
			basicSvnGetPropertiesOf: self target pathForSvn
			StoreInArray: resultArray];
		execute.
	errorCatcher successful
		ifTrue: [self processResult: (self dictionaryFromArray: resultArray)]
		ifFalse: [self processResult: Dictionary new].! !

!SVNPropertiesRequest methodsFor: 'execution' stamp: 'rt 4/17/2008 17:45'!
processResult: resultDict

	self properties: resultDict! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rt 4/17/2008 17:30'!
properties

	^ properties
! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rt 4/17/2008 17:30'!
properties: anObject

	properties := anObject
! !

!SVNRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/3/2008 16:43'!
target: svnDirectoryElement

	^ self new
		target: svnDirectoryElement;
		yourself.! !

!SVNRequest methodsFor: 'execution' stamp: 'cop 4/10/2008 08:14'!
execute
	^self subclassResponsibility! !

!SVNRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 17:41'!
forPrimitiveGetArrayOfSize: aNumber

	^ ( (1 to: aNumber) collect: [:ea | String ofSize: 1024])  asArray! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target
	^ target! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target: anObject
	target := anObject! !

SVNRequest subclass: #SVNStatusRequest
	instanceVariableNames: 'isRecursive statusKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNStatusRequest class methodsFor: 'svn constants' stamp: 'mu 4/21/2008 11:18'!
statusKindDictionary

"enum svn_wc_status_kind:"

	^ Dictionary new
		at: 0 	put: #unversioned;
		at: 1 	put: #none;			"does not exist"
		at: 2 	put: #unversioned;	"is not a versioned thing in this wc"
		at: 3 	put: #normal;		"exists, but uninteresting"
		at: 4 	put: #added;			"is scheduled for addition"
		at: 5 	put: #missing;		"under v.c., but is missing"
		at: 6 	put: #deleted;		"scheduled for deletion"
		at: 7 	put: #replaced;		"was deleted and then re-added"
		at: 8 	put: #modified;		"text or props have been modified"
		at: 9 	put: #merged;		"local mods received repos mods"
		at: 10 	put: #conflicted;	"local mods received conflicting repos mods"
		at: 11 	put: #ignored;		"is unversioned but configured to be ignored"
		at: 12 	put: #obstructed;	"an unversioned resource is in the way of the versioned resource"
		at: 13 	put: #external;		"an unversioned path populated by an svn:externals property"
		at: 14 	put: #incomplete;	"a directory doesn't contain a complete entries list"
		yourself.! !

!SVNStatusRequest class methodsFor: 'instance creation' stamp: 'cop 4/21/2008 17:33'!
target: svnDirectoryElement isRecursive: aBool

	^ self new
		target: svnDirectoryElement;
		isRecursive: aBool;
		yourself.! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'rkrk 4/12/2008 14:04'!
arrayForPrimitive

	"Put only an enum value (int) into the array.
	It is created in the primitive, so pass nil."
	^ {nil}.! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rt 4/23/2008 19:42'!
execute

	| arrayForPrimitive |
	
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 1.
	
	(SVNErrorCatcher on: [self
		primSvnStatus: self target path pathForSvn
		revisionKind: nil revisionNumber: nil
		storeInArray: arrayForPrimitive
		recursive: self isRecursive]) execute.
	
	"check for result ?"
	
	self processResult: arrayForPrimitive.! !

!SVNStatusRequest methodsFor: 'initialization' stamp: 'cop 4/21/2008 17:31'!
initialize
	super initialize.
	self isRecursive: true.! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'rkrk 4/7/2008 15:27'!
isConflicted

	^ self statusKind = #conflicted! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'cop 4/28/2008 13:03'!
isNormal

	^ self statusKind = #normal! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'cop 4/21/2008 17:29'!
isRecursive
	^isRecursive! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'cop 4/21/2008 17:29'!
isRecursive: aBool
	isRecursive := aBool! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'mu 4/21/2008 10:31'!
primSvnStatus: targetString revisionKind: revKind revisionNumber: revNum storeInArray: arr recursive: bool

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArrayRecursive' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 17:15'!
processResult: resultArray

	self statusKind: (self class statusKindDictionary at: (resultArray at: 1)).! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind
	^ statusKind! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind: anObject
	statusKind := anObject! !

SVNRequest subclass: #SVNUpdateRequest
	instanceVariableNames: 'revisionToUpdate beRecursive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNUpdateRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/27/2008 13:42'!
target: svnElement updateToRevision: revisionToUpdate beRecursive: boolean

	^ self new
		target: svnElement;
		revisionToUpdate: revisionToUpdate;
		beRecursive: boolean;
		yourself.! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:42'!
beRecursive
	^ beRecursive! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:42'!
beRecursive: anObject
	beRecursive := anObject! !

!SVNUpdateRequest methodsFor: 'execution' stamp: 'cop 4/28/2008 13:06'!
execute

	(SVNErrorCatcher on: [
		self
			primSvnUpdateTargets: {self target path pathForSvn}
			toRevisionkind: self revisionToUpdate kind
			revisionNumber: self revisionToUpdate number
			beRecursive: self beRecursive]) execute.
	self target checkForConflicts.! !

!SVNUpdateRequest methodsFor: 'primitive' stamp: 'rkrk 4/27/2008 15:56'!
primSvnUpdateTargets: collectionOfPathesToTargets toRevisionkind: revKind revisionNumber: revisionNumber beRecursive: bool
 
	<primitive: 'svnUpdateTargetsToRevisionKindRevisionNumberBeRecursive' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:39'!
revisionToUpdate
	^ revisionToUpdate! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:39'!
revisionToUpdate: anObject
	revisionToUpdate := anObject! !

Object subclass: #SVNRevision
	instanceVariableNames: 'number kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:39'!
base
	".svn/entries current revision"

	^ self
		fromKindSymbol: #base
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:05'!
fromKind: enumKindNumber number: number

	"Not for public use"
	^ self basicNew
		initialize;
		kind: enumKindNumber;
		number: number;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:06'!
fromKindSymbol: symbol number: number

	"Not for public use"
	^ self
		fromKind: (self revisionKindDictionary at: symbol)
		number: number.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/25/2008 04:13'!
halloWelt

	self teilnehmerListe do: [: teilnehmer |
		Transcript
			show: 'Hallo ';
			show: teilnehmer;
			show: ' - Willkommen zum Etoys Workshop';
			cr.]! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
head
	".svn/entries current revision"

	^ self
		fromKindSymbol: #head
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/23/2008 01:02'!
new

	self error: 'No new!! Use specific revisions!!'! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
number: aNumber

	^ self
		fromKindSymbol: #number
		number: aNumber.! !

!SVNRevision class methodsFor: 'svn constants' stamp: 'rkrk 3/24/2008 11:48'!
revisionKindDictionary

	"enum svn_opt_revision_kind
		0 svn_opt_revision_unspecified - No revision information given.
		1 svn_opt_revision_number- revision given as number
		2 svn_opt_revision_date- revision given as date
		3 svn_opt_revision_committed- rev of most recent change
		4 svn_opt_revision_previous- (rev of most recent change) - 1
		5 svn_opt_revision_base- .svn/entries current revision
		6 svn_opt_revision_working - current, plus local mods
		7 svn_opt_revision_head- repository youngest"
	^ Dictionary new
		add: #unspecified 	-> 0;
		add: #number 		-> 1;
		add: #date 			-> 2;
		add: #committed 	-> 3;
		add: #previous 		-> 4;
		add: #base 			-> 5;
		add: #working 		-> 6;
		add: #head 			-> 7;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
unspecified
	
	^ self
		fromKindSymbol: #unspecified
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:41'!
working
	"current, plus local mods"

	^ self
		fromKindSymbol: #working
		number: nil.! !

!SVNRevision methodsFor: 'comparing' stamp: 'rkrk 3/24/2008 11:52'!
= other

	super = other.
	^ self number
		ifNil: [self kind = other kind]
		ifNotNil: [self number = other number].! !

!SVNRevision methodsFor: 'converting' stamp: 'rkrk 3/24/2008 11:51'!
forSvnPrimitive

	self flag: #TODO.
	^ {self kind. self number} asOrderedCollection.! !

!SVNRevision methodsFor: 'testing' stamp: 'rkrk 3/24/2008 11:52'!
hash

	^ self number
		ifNil: [self kind hash]
		ifNotNil: [self number hash].! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind
	^ kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind: anObject
	kind := anObject! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:45'!
kindSymbol
	^ self class revisionKindDictionary keyAtValue: self kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'test 3/23/2008 02:43'!
number

	^ number! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 00:59'!
number: anObject
	number := anObject! !

!SVNRevision methodsFor: 'printing' stamp: 'rkrk 3/25/2008 23:55'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self kindSymbol asString;
		nextPutAll: ' - ';
		nextPutAll: self number asString;
		nextPut: $).! !

Object subclass: #SVNTestDirectory
	instanceVariableNames: 'directory isDirty number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectory subclass: #SVNAwareTestDirectory
	instanceVariableNames: 'workingCopyDirectory workingCopyDirectory2 repositoryDirectory'
	classVariableNames: 'UseTestEnvPlg'
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/14/2008 00:08'!
testEnvPlgInUse

	UseTestEnvPlg ifNil: [^ false].
	^ UseTestEnvPlg! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useOSProcess: bool

	UseTestEnvPlg := bool not! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useTestEnvPlg: bool

	UseTestEnvPlg := bool! !

!SVNAwareTestDirectory methodsFor: 'consistency' stamp: 'rkrk 4/3/2008 03:09'!
checkConsistency
	
	| workingCopyIsDirty workingCopy2IsDirty |
	workingCopyIsDirty := (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 1]) not.
	"SVNAwareTestDirectories which were created before the addition of
	the second working copy have no workingCopyDirectory2. Declare them
	as dirty. this can be removed after everyone has fresh test directories"
	workingCopy2IsDirty := self workingCopyDirectory2 isNil.
	self directory: self directory.
	"Really test if wc2 is dirty"
	workingCopy2IsDirty ifFalse:
		[workingCopy2IsDirty := self workingCopyDirectory2 exists].
	
	self isDirty: (workingCopyIsDirty or: [workingCopy2IsDirty]).! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 03:09'!
create

	super create.
	self
		createRepository;
		createWorkingCopy.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/27/2008 00:55'!
createRepository
	
	self assert: (FileDirectory on: self repositoryPath) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCreateRepositoryOn: self repositoryPath]
		ifFalse: [OSProcess waitForCommand: 'svnadmin create "' , self repositoryPath ,'"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:35'!
createSecondWorkingCopy

	self isDirty: true.
	self createWorkingCopyInPath: self workingCopyDirectory2 pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:26'!
createWorkingCopy

	self createWorkingCopyInPath: self workingCopyDirectory pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/27/2008 00:55'!
createWorkingCopyInPath: path

	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCheckoutHeadRevisionFrom: self repositoryURLPath to: path]
		ifFalse: [OSProcess waitForCommand:
		'svn co ' , self repositoryURLPath , ' "' , path , '"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
directory: aFileDirectory
	super directory: aFileDirectory.
	
	self
		workingCopyDirectory: (aFileDirectory directoryNamed: self nameForWorkingCopy);
		workingCopyDirectory2: (aFileDirectory directoryNamed: self nameForWorkingCopy2);
		repositoryDirectory: (aFileDirectory directoryNamed: self nameForRepository)! !

!SVNAwareTestDirectory methodsFor: 'OSProcess' stamp: 'rt 4/27/2008 00:49'!
executeViaOSProcessSynchronously: command

	OSProcess waitForCommand: command! !

!SVNAwareTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	^ true! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForRepository

	^ 'repository'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForWorkingCopy

	^ 'workingCopy'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 4/3/2008 01:24'!
nameForWorkingCopy2

	^ 'workingCopy2'! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:02'!
pathForTests

	^ self workingCopyPath! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory

	^ repositoryDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory: aFileDirectory

	repositoryDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:31'!
repositoryPath

	^ self repositoryDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:49'!
repositoryURLPath

	^ self repositoryDirectory asUrl asString! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:11'!
workingCopyDirectory

	^ workingCopyDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2
	^ workingCopyDirectory2! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2: anObject
	workingCopyDirectory2 := anObject! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:08'!
workingCopyDirectory: aFileDirectory

	workingCopyDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:03'!
workingCopyPath

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:46'!
workingCopyPath2

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory2 pathName! !

SVNAwareTestDirectory subclass: #SVNRestrictedTestDirectory
	instanceVariableNames: 'accessible username password'
	classVariableNames: 'Daemon'
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNRestrictedTestDirectory class methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 05:10'!
startDaemonOnRoot: aPath

	(Daemon isNil or: [Daemon isRunning not])
		ifTrue: [Daemon := OSProcess command: 'svnserve -r "' , aPath , '" -d'].
	[Daemon isRunning] whileFalse: [(Delay forMilliseconds: 100) wait]! !

!SVNRestrictedTestDirectory methodsFor: 'testing' stamp: 'rt 4/26/2008 20:47'!
accessRestricted

	^ true! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 06:06'!
accessible

	"^ accessible"
	^ Daemon notNil and: [Daemon isRunning]! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/26/2008 17:01'!
accessible: anObject

	accessible := anObject! !

!SVNRestrictedTestDirectory methodsFor: 'consistency' stamp: 'rt 4/27/2008 05:55'!
checkConsistency

	| workingCopyIsDirty workingCopy2IsDirty usernameChanged passwordChanged hasRevisions revsDir |
	workingCopyIsDirty := (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 0]) not.
	
	workingCopy2IsDirty := self workingCopyDirectory2 notNil.
	workingCopy2IsDirty :=workingCopy2IsDirty ifTrue: [(self workingCopyDirectory2 exists" and:
					[self workingCopyDirectory2 entries size ~= 0]")].
			
	usernameChanged := self usernameForRepository ~= self defaultUsername.
	passwordChanged := self passwordForRepository ~= self defaultPassword.
	
	revsDir := (self repositoryDirectory directoryNamed: 'db') directoryNamed: 'revs'.
	hasRevisions := revsDir exists and: [revsDir entries size > 1].
	
	self isDirty: (workingCopyIsDirty or:
		[workingCopy2IsDirty] or:
		[usernameChanged] or:
		[passwordChanged] or:
		[hasRevisions]).! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/25/2008 10:56'!
checkoutSecondWorkingCopy

	self isDirty: true.
	self checkoutWorkingCopyInPath: self workingCopyDirectory2 pathName.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/25/2008 10:55'!
checkoutWorkingCopy

	self isDirty: true.
	self checkoutWorkingCopyInPath: self workingCopyDirectory pathName.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 00:54'!
checkoutWorkingCopyInPath: path

	self flag: #TODO.
	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists.
	
	"TestEnvPlg doesn't support any authentication"
	OSProcess waitForCommand:
		'svn co ' , self repositoryURLPath , ' "' , path , '"',
		' --username ' , self usernameForRepository , 
		' --password ' , self passwordForRepository.
	! !

!SVNRestrictedTestDirectory methodsFor: 'clearing' stamp: 'rt 4/26/2008 21:31'!
clear

	self makeRepositoryNonAccessible.
	super clear.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:00'!
configureRepository

	self writeConfigurationFile.
	self writePasswordFile.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:11'!
contentOfConfFile

	^ '### Visit http://subversion.tigris.org/ for more information.' , Character cr asString ,
	Character cr asString ,
	'[general]' , Character cr asString ,
	'anon-access = none' , Character cr asString ,
	'auth-access = write' , Character cr asString ,
	'password-db = passwd'.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:21'!
contentOfPasswdFile

	^ '[users]' , Character cr asString ,
	self usernameForRepository , ' = ' , self passwordForRepository! !

!SVNRestrictedTestDirectory methodsFor: 'creating' stamp: 'rt 4/26/2008 18:59'!
createRepository

	super createRepository.
	self configureRepository.! !

!SVNRestrictedTestDirectory methodsFor: 'creating' stamp: 'rt 4/25/2008 10:39'!
createWorkingCopyInPath: path

	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists not.
	
	(FileDirectory on: path) assureExistence.
	
	self assert: (FileDirectory on: path) exists.! !

!SVNRestrictedTestDirectory methodsFor: 'default' stamp: 'rt 4/27/2008 05:25'!
defaultPassword

	^ 'password'! !

!SVNRestrictedTestDirectory methodsFor: 'default' stamp: 'rt 4/27/2008 05:25'!
defaultUsername

	^ 'username'! !

!SVNRestrictedTestDirectory methodsFor: 'initialization' stamp: 'rt 4/26/2008 19:46'!
initialize

	super initialize.
	accessible := false! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 06:05'!
makeRepositoryAccessible

	self accessible ifTrue: [^ self].
	"self accessible: true."
	"[self runSvnServe] fork."
	self class startDaemonOnRoot: self serverRoot! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 00:53'!
makeRepositoryNonAccessible

	self accessible ifFalse: [^ self].
	self accessible: false.
	
	"final call to stop last instances of svnserve"
	OSProcess waitForCommand: 'svn info svn://localhost/stop'.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 05:26'!
passwordForRepository

	password
		ifNil: [^ self defaultPassword]
		ifNotNil: [^ password]! !

!SVNRestrictedTestDirectory methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 06:31'!
repositoryURLPath

	| dir topDirName |
	self isDirty: true.
	self makeRepositoryAccessible.
	(Delay forMilliseconds: 50) wait.
	dir := self directory.
	topDirName := ( FileDirectory on: (dir pathName
		copyFrom: 1
		to: (dir pathName size - dir localName size - 1)) ) localName.
	^ 'svn://localhost/' , topDirName , '/' , dir localName , '/' , self nameForRepository! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 05:11'!
runSvnServe
"that will not work"
"	[self accessible] whileTrue: [self
		executeViaOSProcessSynchronously: 'svnserve -r ' , self serverRoot , ' -X']"
	[self accessible] whileTrue: [OSProcess waitForCommand: 'svnserve -r ' , self serverRoot , ' -X']! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/27/2008 06:33'!
serverRoot

	| dir topDir |
	dir := self directory.
	topDir := FileDirectory on: (dir pathName
		copyFrom: 1
		to: (dir pathName size - dir localName size - 1)).
	^ topDir pathName
		copyFrom: 1
		to: ( topDir pathName size - topDir localName size - 1 )! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/26/2008 19:36'!
setPassword: aString

	password := aString.
	(self repositoryDirectory directoryExists: 'conf') ifTrue: [self writePasswordFile]! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/26/2008 19:36'!
setUsername: aString

	username := aString.
	(self repositoryDirectory directoryExists: 'conf') ifTrue: [self writePasswordFile]! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 05:25'!
usernameForRepository

	username
		ifNil: [^ self defaultUsername]
		ifNotNil: [^ username]! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:19'!
writeConfigurationFile

	| confDir |
	confDir := self repositoryDirectory directoryNamed: 'conf'.
	confDir deleteFileNamed: 'svnserve.conf'.
	
	(CrLfFileStream fileNamed: confDir pathName , FileDirectory slash , 'svnserve.conf')
		nextPutAll: self contentOfConfFile;
		close.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:19'!
writePasswordFile

	| confDir |
	confDir := self repositoryDirectory directoryNamed: 'conf'.
	confDir deleteFileNamed: 'passwd'.
	
	(CrLfFileStream fileNamed: confDir pathName , FileDirectory slash , 'passwd')
		nextPutAll: self contentOfPasswdFile;
		close.! !

!SVNTestDirectory class methodsFor: 'instance creation' stamp: 'rkrk 3/14/2008 20:39'!
theName: aName basePath: basePath

	^ self new
		directory: (FileDirectory on: basePath , FileDirectory slash , aName);
		yourself.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rt 4/26/2008 20:48'!
accessRestricted

	^ false! !

!SVNTestDirectory methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:17'!
checkConsistency
	
	self isDirty: (self directory exists and: [self directory entries size = 0]) not.
! !

!SVNTestDirectory methodsFor: 'clearing' stamp: 'rkrk 3/16/2008 01:24'!
clear

	self directory deleteRecursivelyPlatformIndependent! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:21'!
create

	self directory exists ifTrue: [self reCreate. ^ self].
	self directory assureExistence.
	self isDirty: false.! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory
	^ directory! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory: anObject
	directory := anObject! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'test 3/16/2008 06:25'!
initialize

	super initialize.
	self isDirty: true.
	number := 1000 atRandom.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 21:58'!
isDirty

	^ isDirty! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:00'!
isDirty: anObject
	isDirty := anObject! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	"I cannot create repositories and stuff"
	^ false! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 21:59'!
pathForTests

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self directory pathName! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:26'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self isDirty ifTrue: [''] ifFalse: ['not ']);
		nextPutAll: 'dirty';
		nextPutAll: ' ' , number asString;
		nextPut: $).! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:25'!
reCreate

	self
		clear;
		create! !

Object subclass: #SVNTestDirectoryManager
	instanceVariableNames: 'currentDirectory basicTestDirectories svnAwareTestDirectories basePath svnRestrictedTestDirectories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

!SVNTestDirectoryManager class methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:10'!
checkConsistency

	self getInstance checkConsistency.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:09'!
createObservingMorph

	"SVNTestDirectoryManager createObservingMorph"
	observingMorph := SVNObservingMorph new.
	observingMorph
		openInWorld;
		start.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 03:05'!
getInstance

	"[SVNTestDirectoryManager getInstance]
	[SVNTestDirectoryManager instance: nil]"
	^ self instance
		ifNil: [instance := self basicNew initialize]
		ifNotNil: [self instance]! !

!SVNTestDirectoryManager class methodsFor: 'class initialization' stamp: 'rkrk 3/16/2008 17:10'!
initialize

	"self initialize"
	super initialize.
	World 
		when: #aboutToEnterWorld
		send: #checkConsistency to: self.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:57'!
instance

	^ instance! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:58'!
instance: instanceOfSelf

	instance := instanceOfSelf! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:10'!
killObservingMorph

	"SVNTestDirectoryManager killObservingMorph"
	observingMorph
		stop;
		delete.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 01:45'!
new

	self error: 'Singleton. Call getInstance'.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 07:02'!
reCreate

	"SVNTestDirectoryManager reCreate"
	[self getInstance reCreateTestDirectories. self beep] fork.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:19'!
uninstall

	self getInstance clear.
	self instance: nil.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/12/2008 21:49'!
basePath
	basePath
		ifNil: [^ self basePath: FileDirectory default fullName , FileDirectory slash , 'svnTests'].
	^ basePath! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 00:25'!
basePath: anObject
	basePath := anObject! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/18/2008 23:55'!
basicReCreateDirectories: directories howMany: number
"Recreate all or only the given number of directories.
Ignore if number > directories size"

	| dirtyDirs |
	dirtyDirs := directories select: [:ea | ea isDirty].
	dirtyDirs size > number ifTrue: [dirtyDirs := dirtyDirs first: number].
	dirtyDirs
		do: [:each | each reCreate]
		displayingProgress: 'Recreating dirty test directories'.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
basicTestDirectories
	^ basicTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'test 3/16/2008 06:03'!
basicTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	"self assert: (anObject isKindOf: Array) not."
	basicTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:28'!
checkConsistency

	self testDirectories
		do: [:ea | ea checkConsistency]
		displayingProgress: 'SVNTestDirectoryManager conistency check'.! !

!SVNTestDirectoryManager methodsFor: 'removing' stamp: 'rkrk 3/16/2008 01:27'!
clear

	self testDirectories do: [:ea | ea clear].
	(FileDirectory on: self basePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:29'!
create: number fromClass: SVNDirectoryClass named: partOfName considerExisting: directories
"Create only as many new directories as needed. Reuse old ones"

	| newDirectories |
	^ directories size >= number
		ifTrue: [self reuse: number of: directories]
		ifFalse: [
			newDirectories := (directories size to: number - 1) collect: [:i |
				SVNDirectoryClass
					theName: partOfName , i asString
					basePath: self basePath].
				directories addAll: newDirectories asOrderedCollection.
				directories].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:39'!
createBasicTestDirectories: number

	self basicTestDirectories: (self
		create: number
		fromClass: SVNTestDirectory
		named: 'SVNTestDirectory_'
		considerExisting: self basicTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/19/2008 00:00'!
createBasicTestDirs: numberForBasic svnAwareTestDirs: numberForSvnAware
"This method should be called by a user for setting up the state
og the manager"

	self assert: self basePath notNil.
	self
		createBasicTestDirectories: numberForBasic;
		createSvnAwareTestDirectories: numberForSvnAware.
	self reCreateTestDirectories.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:38'!
createSvnAwareTestDirectories: number

	self svnAwareTestDirectories: (self
		create: number
		fromClass: SVNAwareTestDirectory
		named: 'SVNAwareTestDirectory_'
		considerExisting: self svnAwareTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rt 4/27/2008 03:12'!
createSvnRestrictedTestDirectories: number

	self svnRestrictedTestDirectories: (self
		create: number
		fromClass: SVNRestrictedTestDirectory
		named: 'SVNRestrictedTestDirectory_'
		considerExisting: self svnRestrictedTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory
	^ currentDirectory! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory: anObject
	currentDirectory := anObject! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rt 4/26/2008 20:49'!
findCleanSvnAwareTestDirectory

	self assert: self svnAwareTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and:
		[directory isDirty not] and:
		[directory accessRestricted not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rt 4/27/2008 18:29'!
findCleanSvnRestrictedTestDirectory

	self svnRestrictedTestDirectories ifEmpty: [self createSvnRestrictedTestDirectories: 20].
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and:
		[directory isDirty not] and:
		[directory accessRestricted]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:06'!
findCleanTestDirectory

	self assert: self basicTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware not and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 03:04'!
findTestDirectoryWhichSatisfies: conditionBlock

	^ self testDirectories
		detect: conditionBlock
		ifNone: [self reCreatePercent: 10.
			self testDirectories detect: conditionBlock].! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:03'!
getPassword

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory passwordForRepository.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:03'!
getUsername

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory usernameForRepository.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rt 4/27/2008 01:52'!
initialize

	super initialize.
	self
		basicTestDirectories: OrderedCollection new;
		svnAwareTestDirectories: OrderedCollection new;
		svnRestrictedTestDirectories: OrderedCollection new.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanBasicTestDirectories

	^ self basicTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanSvnAwareTestDirectories

	^ self svnAwareTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:52'!
numberOfCleanSvnRestrictedTestDirectories

	^ self svnRestrictedTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 00:36'!
pathForTests

	self
		assert: self currentDirectory notNil
		description: 'The calling test has not registered for directory support'.
	^ self currentDirectory pathForTests! !

!SVNTestDirectoryManager methodsFor: 'helper' stamp: 'rkrk 3/16/2008 05:18'!
percent: percent of: total

	| result |
	result := (total * (percent / 100)) asInteger.
	result = 0 ifTrue: [^ 1]. "should at least be one"
	^ result! !

!SVNTestDirectoryManager methodsFor: 'printing' stamp: 'rt 4/27/2008 01:58'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: 'svn restricted ';
		nextPutAll: self svnRestrictedTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnRestrictedTestDirectories asString;
		nextPutAll: ' svn aware: ';
		nextPutAll: self svnAwareTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnAwareTestDirectories asString;
		nextPutAll: ' basic: ';
		nextPutAll: self basicTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanBasicTestDirectories asString;
		nextPut: $).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rt 4/27/2008 01:50'!
reCreatePercent: percent

	self
		basicReCreateDirectories: self basicTestDirectories
	 	howMany: (self	percent: percent of: self basicTestDirectories size).
	self
		basicReCreateDirectories: self svnAwareTestDirectories
	 	howMany: (self	percent: percent of: self svnAwareTestDirectories size).
	self
		basicReCreateDirectories: self svnRestrictedTestDirectories
	 	howMany: (self	percent: percent of: self svnRestrictedTestDirectories size).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:41'!
reCreateTestDirectories

	self reCreatePercent: 100.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForSvnAwareTestDirectory
	
	self currentDirectory: self findCleanSvnAwareTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 4/3/2008 01:48'!
registerForSvnAwareTestDirectoryWithTwoWorkingCopies

	self registerForSvnAwareTestDirectory.
	self currentDirectory createSecondWorkingCopy.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rt 4/27/2008 01:47'!
registerForSvnRestrictedTestDirectory
	
	self currentDirectory: self findCleanSvnRestrictedTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rt 4/27/2008 01:47'!
registerForSvnRestrictedTestDirectoryWithTwoWorkingCopies

	self registerForSvnRestrictedTestDirectory.
	self currentDirectory createSecondWorkingCopy.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForTestDirectory
	
	self currentDirectory: self findCleanTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
repositoryURLPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:15'!
reuse: number of: directories

	| directoriesNotNeeded |
	directoriesNotNeeded := (directories last: directories size - number).
	directoriesNotNeeded do: [:ea | ea clear].
	^ (directories first: number) asOrderedCollection! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:04'!
setPassword: aString

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory setPassword: aString.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:04'!
setUsername: aString

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory setUsername: aString.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:31'!
stopAccessToRepository

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	self currentDirectory accessRestricted ifTrue: [self currentDirectory makeRepositoryNonAccessible]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
svnAwareTestDirectories
	^ svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 06:00'!
svnAwareTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnAwareTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 02:06'!
svnRestrictedTestDirectories

	svnRestrictedTestDirectories ifNil: [self svnRestrictedTestDirectories: OrderedCollection new].
	^ svnRestrictedTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:44'!
svnRestrictedTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnRestrictedTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:45'!
testDirectories

	^ self basicTestDirectories
		union: (self svnAwareTestDirectories
		union: self svnRestrictedTestDirectories)! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 02:38'!
unregister

	self flag: #TODO. "self currentDirectory: nil"
	self currentDirectory: self findCleanTestDirectory.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
workingCopyPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory workingCopyPath.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:45'!
workingCopyPath2

	self assert: (self currentDirectory notNil
		and: [self currentDirectory isSvnAware]
		and: [self currentDirectory workingCopyDirectory2 exists]).
	^ self currentDirectory workingCopyPath2.! !

Object subclass: #SVNTool
	instanceVariableNames: 'builder window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNTool subclass: #SVNCommitBrowser
	instanceVariableNames: 'svnElement comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/6/2008 02:21'!
openWith: svnElement

	^ self new
		svnElement: svnElement;
		open;
		yourself.
! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:22'!
buildCommentField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #comment;
		setText: #setComment:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self commitButtonLabel;
		action: #commit;
		color: #grayColor;
		frame: (0.4 @ 0.9 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitSelectionTree

	^ (self builder pluggableTreeSpec new)
		frame: (0 @ 0.3 corner: 1 @ 0.9);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:25'!
buildWidgets

	^ {self buildCommentField.
	self buildCommitSelectionTree.
	self buildCommitButton}! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment

	^ comment ifNil: ['Enter a comment'].! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment: aString

	comment := aString.! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'mu 4/28/2008 16:05'!
commit
	
	| revisionNumber newRevisionNumber |
	self readAllInputs.
	revisionNumber := self getRevisionNumber.
	self svnElement commitWithMessage: self comment.
	newRevisionNumber := self getRevisionNumber.
	(newRevisionNumber > revisionNumber) 
		ifTrue: [SVNCommitMessage openWith: self comment.]
		ifFalse: [SVNMessageBox openWith: self noCommitString].
	self close.! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/5/2008 23:19'!
commitButtonLabel

	^ 'Commit'! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
extent

	^ 400 @ 300! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'mu 4/28/2008 15:57'!
getRevisionNumber

	| request |
	request := SVNInfoRequest 
				target: self svnElement svnDirectoryEntry
				forRevision: (SVNRevision head).
	request execute.
	^ request revision number! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
label

	^ 'SqueakSVN Commit Browser'! !

!SVNCommitBrowser methodsFor: 'as yet unclassified' stamp: 'mu 4/28/2008 16:08'!
noCommitString
	
	^ 'SVN have not commit the selected element(s). Probably there where no changes to the previous version'! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:07'!
setComment: aText

	self comment: aText asString.
	^ true.! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement
	^ svnElement! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement: anObject
	svnElement := anObject! !

SVNTool subclass: #SVNCommitMessage
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitMessage class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/6/2008 02:22'!
openWith: aString

	^ self new
		comment: aString;
		open;
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildLogMessageField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #logMessage;
		frame: (0 @ 0 corner: 1 @ 0.85);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildOKButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: #okButtonLabel;
		action: #close;
		color: #grayColor;
		frame: (0.4 @ 0.85 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:41'!
buildWidgets

	^ {self buildLogMessageField.
	self buildOKButton}.! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment
	^ comment! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment: aString
	comment := aString! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
extent

	^ 300@200! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
label

	^ 'Commit successful'! !

!SVNCommitMessage methodsFor: 'log message creation' stamp: 'rkrk 4/6/2008 01:46'!
logMessage

	| logMessage |
	logMessage := 
		('Comment:' asText) allBold,
		String tab,
		self comment,
		String cr,
		String cr,
		('Timestamp:' asText) allBold,
		String tab,
		"nicht schn, da nicht die Zeit von der Version sondern aktuelle Zeit"
		TimeStamp current asString.
	^ logMessage! !

!SVNCommitMessage methodsFor: 'default' stamp: 'mu 3/13/2008 14:32'!
okButtonLabel
	^ 'Ok'! !

SVNTool subclass: #SVNCreateRepositoryTool
	instanceVariableNames: 'repositoryName repositoryUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:32'!
initialize

	"self initialize"
	self registerInOpenMenu.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 16:35'!
open

	^ self new
		open;
		yourself.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:31'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNCreateRepositoryTool'. {self. #open}}.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:36'!
buildGenerateRepositoryButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self generateRepositoryButtonLabel;
		action: #generate;
		color: #grayColor;
		frame: (0.2 @ 0.8 corner: 0.8 @ 1);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/21/2008 01:41'!
buildRepositoryNameField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryName;
		setText: #setRepositoryName:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 20:23'!
buildRepositoryPathField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryUrl;
		frame: (0 @ 0.3 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:29'!
buildWidgets

	^ {self buildRepositoryNameField.
	self buildRepositoryPathField.
	self buildGenerateRepositoryButton}! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:42'!
defaultRepositoryNameInfo

	^ 'Please type in a name for the repository.'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:36'!
extent

	^ 400 @ 200! !

!SVNCreateRepositoryTool methodsFor: 'generating' stamp: 'rt 4/27/2008 00:52'!
generate

	| repositoryDir |
	self repositoryName = self defaultRepositoryNameInfo ifTrue: [
		UIManager default inform: 'Please specify a local repository name'. ^ self].
	repositoryDir := (FileDirectory default directoryNamed: self repositoryName).
	OSProcess waitForCommand: 'svnadmin create "' , repositoryDir pathName , '"'.
	self assert: repositoryDir exists.
	self repositoryUrl: repositoryDir asUrl asString.
	self changed: #repositoryUrl.! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
generateRepositoryButtonLabel

	^ 'Generate Repository'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
label

	^ 'SqueakSVN Create Repository Tool'! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:42'!
repositoryName
	^ repositoryName ifNil: [self defaultRepositoryNameInfo]! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:35'!
repositoryName: anObject
	repositoryName := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl
	^ repositoryUrl! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl: anObject
	repositoryUrl := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:10'!
setRepositoryName: aText

	(aText asString includes: Character space) ifTrue: [^ false].
	self repositoryName: aText asString.
	^ true.! !

SVNTool subclass: #SVNMessageBox
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNMessageBox class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 16:37'!
openWith: aString

	^ self new
		comment: aString;
		open;
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:47'!
buildMessageField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #comment;
		frame: (0 @ 0 corner: 1 @ 0.65);
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:47'!
buildOKButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: #okButtonLabel;
		action: #close;
		color: #grayColor;
		frame: (0.4 @ 0.65 corner: 0.6 @ 1);
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:44'!
buildWidgets

	^ {self buildMessageField.
	self buildOKButton}.! !

!SVNMessageBox methodsFor: 'accessing' stamp: 'rt 4/22/2008 16:37'!
comment
	^ comment! !

!SVNMessageBox methodsFor: 'accessing' stamp: 'rt 4/22/2008 16:37'!
comment: aString
	comment := aString! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:50'!
extent

	^ 270@100! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:42'!
label

	^ 'SVN Notification'! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:37'!
okButtonLabel
	^ 'Ok'! !

SVNTool subclass: #SVNModalTool
	instanceVariableNames: 'done response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNModalTool subclass: #SVNCreateProjectDialog
	instanceVariableNames: 'svnProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateProjectDialog class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/7/2008 04:22'!
call

	^ self new
		svnProject: (SVNProject named: '');
		open;
		call.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'mu 4/7/2008 13:42'!
buildCreateProjectButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: self projectButtonLabel;
		action: #finished;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.8 corner: 0.7 @ 1);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildProjectNameField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectName;
		setText: #setProjectName:;
		frame: (0 @ 0 corner: 1 @ 0.266);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildUrlField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectUrl;
		setText: #setProjectUrl:;
		frame: (0 @ 0.266 corner: 1 @ 0.533);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:59'!
buildWidgets

	^ {self buildProjectNameField.
	self buildUrlField.
	self buildWorkingCopyPathField.
	self buildCreateProjectButton}.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:24'!
buildWorkingCopyPathField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectWorkingCopyPath;
		setText: #setProjectWorkingCopyPath:;
		frame: (0 @ 0.533 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'testing' stamp: 'cop 4/24/2008 17:03'!
canAccept
	^ self projectName ~= self projectButtonLabel and:
		[self projectUrl ~= self defaultURL] and:
		[self projectWorkingCopyPath ~= self defaultWCPath] and:
		[self projectWorkingCopyPath ~= (FileUrl absoluteFromText: self projectUrl) path first].! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
cancelButtonLabel

	^ 'Cancel'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultProjectName

	^ 'Insert the project name here.'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultURL

	^ 'Insert the repository URL here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultWCPath

	^ 'Insert the working copy path here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
extent

	^ 300 @ 180! !

!SVNCreateProjectDialog methodsFor: 'accepting' stamp: 'rkrk 4/21/2008 12:37'!
finished

	self readAllInputs.
	self canAccept ifFalse: [^ self].
	self answer: self svnProject.
	self closeIfOpen.! !

!SVNCreateProjectDialog methodsFor: 'converting' stamp: 'rkrk 4/6/2008 02:42'!
getFullPathFor: aString

	aString asURI isAbsolute ifTrue: [^ aString].
	^ FileDirectory fullPathForURI: aString! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
label

	^ 'Create a SVNProject'.! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 02:02'!
projectButtonLabel

	^ 'Create project'! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/6/2008 02:55'!
projectName

	^ self svnProject theName
		ifEmpty: [self defaultProjectName]
		ifNotEmptyDo: [:name | name].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/14/2008 12:12'!
projectUrl

	^ self svnProject repositoryURL
		ifNil: [self defaultURL]
		ifNotNilDo: [:url |
			url
				ifEmpty: [self defaultURL]
				ifNotEmpty: [url asString]].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/14/2008 12:14'!
projectWorkingCopyPath

	^ self svnProject directory basePath
		ifNil: [self defaultWCPath]
		ifNotNilDo: [:dir | 
			dir
				ifEmpty: [self defaultWCPath]
				ifNotEmpty: [dir asString]].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'cop 4/18/2008 13:02'!
setProjectName: stringOrText
	self svnProject theName: stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 01:31'!
setProjectUrl: stringOrText
	
	self svnProject repositoryURL: stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 4/13/2008 20:25'!
setProjectWorkingCopyPath: stringOrText

	| path |
	path := self getFullPathFor: stringOrText asString.
	self svnProject directory basePath: path.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject
	^ svnProject! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject: anObject
	svnProject := anObject! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
answer: object

	response := object.
	self endModalState.! !

!SVNModalTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 21:18'!
buildMainWindow
	
	^ super buildMainWindow
		closeAction: #endModalState;
		yourself.! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 22:20'!
call
	
	"Pattern taken from FillInTheBlankMorph"
	"Answers nil if canceled"
	| world |
	world := World.
	done := false.
	[done] whileFalse: [world doOneCycle].
	self closeIfOpen.
	world doOneCycle.
	^ response! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:24'!
closeIfOpen

	"Dirty hack. If the close (X) button is clicked then #close is called two times.
	The second time the widget is already closed, so the delete call results in an error."
	[self close] on: MessageNotUnderstood do: [].! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
endModalState

	done := true.! !

SVNModalTool subclass: #SVNRequestDialog
	instanceVariableNames: 'label text canAccepBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNRequestDialog subclass: #SVNAuthenticationRequestDialog
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNAuthenticationRequestDialog class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 17:48'!
ask: questionString template: templateString canAcceptBlock: aBlock

	^ superclass ask: questionString template: templateString canAcceptBlock: aBlock! !

!SVNAuthenticationRequestDialog class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 18:02'!
withUsernameTemplate: usernameString andPasswordTemplate: passwordString

	^ self new
		username: usernameString;
		password: passwordString;
		canAccepBlock: [:ea | true];
		open;
		call.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildPasswordField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #password;
		setText: #password:;
		frame: (0.26 @ 0.3 corner: 1 @ 0.6);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:20'!
buildPasswordFieldDescriptionField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #passwordDescriptionText;
		frame: (0 @ 0.3 corner: 0.25 @ 0.6);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildUsernameField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #username;
		setText: #username:;
		frame: (0.26 @ 0 corner: 1 @ 0.25);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildUsernameFieldDescriptionField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #usernameDescriptionText;
		frame: (0 @ 0 corner: 0.25 @ 0.25);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:19'!
buildWidgets
	
	^ {self buildUsernameFieldDescriptionField.
	self buildPasswordFieldDescriptionField.
	self buildUsernameField.
	self buildPasswordField.
	self buildOKButton}.! !

!SVNAuthenticationRequestDialog methodsFor: 'confirming' stamp: 'rt 4/22/2008 17:50'!
confirm

	self readAllInputs.
	self canAccept ifFalse: [^ self].
	self answer: (SVNUser
		user: self username asString
		password: self password asString).
	self closeIfOpen.! !

!SVNAuthenticationRequestDialog methodsFor: 'default' stamp: 'rt 4/22/2008 17:41'!
extent

	^ 300@100! !

!SVNAuthenticationRequestDialog methodsFor: 'default' stamp: 'rt 4/22/2008 17:39'!
label

	^ 'SVN Authentication Request'! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:13'!
password

	^ password! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:47'!
password: aStringOrText

	password := aStringOrText.
	^ self canAccept! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 18:18'!
passwordDescriptionText

	^ 'Password:' asText allBold! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:12'!
username

	^ username! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:47'!
username: aStringOrText

	username := aStringOrText.
	^ self canAccept! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 18:18'!
usernameDescriptionText

	^ 'Username:' asText allBold! !

!SVNRequestDialog class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/7/2008 03:55'!
ask: questionString template: templateString canAcceptBlock: aBlock

	^ self new
		canAccepBlock: aBlock;
		label: questionString;
		text: templateString;
		open;
		call.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildOKButton
	
	^ self builder pluggableButtonSpec new
		model: self;
		label: self okButtonLabel;
		action: #confirm;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.6 corner: 0.7 @ 1);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildTextField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #text;
		setText: #text:;
		frame: (0 @ 0 corner: 1 @ 0.6);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 22:04'!
buildWidgets
	
	^ {self buildTextField.
	self buildOKButton}.! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock
	^ canAccepBlock! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock: anObject
	canAccepBlock := anObject! !

!SVNRequestDialog methodsFor: 'testing' stamp: 'rkrk 4/6/2008 22:10'!
canAccept

	^ self canAccepBlock value: self text.! !

!SVNRequestDialog methodsFor: 'confirming' stamp: 'rkrk 4/21/2008 12:38'!
confirm

	self readAllInputs.
	self canAccept ifFalse: [^ self].
	self answer: self text asString.
	self closeIfOpen.! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/7/2008 03:50'!
extent

	^ 220@100! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:10'!
label

	^ label! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
label: aString

	label := aString! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 22:11'!
okButtonLabel

	^ 'Confirm'! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
text
	^ text! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:54'!
text: anObject

	text := anObject.
	^ self canAccept! !

SVNTool subclass: #SVNProjectBrowser
	instanceVariableNames: 'svnEnvironment projectNodes selectedNode selectedCommitLogString commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/25/2008 14:45'!
open

	self flag: #TODO.
	^ self openWithSvnEnvironment: SVNRegistry current createSvnEnvironment.! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'cop 4/24/2008 12:55'!
openWithSvnEnvironment: svnEnvironment

	^ self new
		svnEnvironment: svnEnvironment;
		beDependentFromProjects;
		open;
		yourself.! !

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNProjectBrowser'. {self. #open}}.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/22/2008 14:56'!
beDependentFromClassesOfProject: aSVNProject

	aSVNProject versionedClasses do: [:each |
			each addDependent: self.
			self beDependentFromMethodsOfClass: each ].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/22/2008 14:56'!
beDependentFromMethodsOfClass: aSVNClass

	aSVNClass versionedMethods do: [:each |
			each addDependent: self].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/22/2008 14:10'!
beDependentFromProjects

	self svnEnvironment svnProjects do: [:project |
		project allElements do: [:each |
			each addDependent: self ].
		self beDependentFromClassesOfProject: project].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/20/2008 15:08'!
beIndependentFromSvnProjects

	self svnEnvironment svnProjects do: [:project |
		project allElements do: [:each |
			each removeDependent: self]].! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/7/2008 02:00'!
buildButtonsFromCommands
"This methods creates commands from #commandClasses. For each command a button
is created and inserted at the bottom of the browser"
	| buttonHeight commands numberOfButtons buttonWidth buttonX buttonSpec |
	self flag: #TODO. "Refactor"
	buttonHeight := 0.9.
	commands := self commands select: [:ea | ea wantsButton].
	numberOfButtons := commands size.
	buttonWidth := 1 / numberOfButtons.
	buttonX := 0.
	^ commands collect: [:ea |
		buttonSpec := self builder pluggableButtonSpec new
			model: ea;
			label: ea label;
			action: #execute;
			frame: (buttonX@buttonHeight corner: (buttonX + buttonWidth)@1);
			yourself.
		buttonX := buttonX + buttonWidth.
		buttonSpec].
	! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 03:18'!
buildLogMessageText

	^ self builder pluggableTextSpec new
		model: self;
		getText: #displayLogMessage;
		frame: (0.5 @  0.5 corner: 1 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:21'!
buildRevisionList

	^ self builder pluggableListSpec new
		model: self;
		list: #listRevisionsForSelectedElement;
		getSelected: #selectedCommitLogString;
		setSelected: #setSelectedCommitLogString:;
		getIndex: #revisionListIndex;
		setIndex: #revisionListIndex:;
		frame: (0.5 @ 0 corner: 1 @ 0.5);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'cop 4/24/2008 12:59'!
buildSvnElementTree

	^ self builder pluggableTreeSpec new
		model: self;
		roots: #updateProjectNodes;
		hasChildren: #nodeHasChildren:;
		getChildren: #getChildrenOfNode:;
		label: #labelOfNode:;
		menu: #menuOn:;
		getSelectedPath: #getPathToSelectedNode;
		icon: #getIcon:;
		setSelected: #setSelectedNode:;
		frame: (0 @ 0 corner: 0.5 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 21:48'!
buildWidgets

	| result |
	result := {self buildSvnElementTree.
	self buildRevisionList.
	self buildLogMessageText} asOrderedCollection.
	result addAll: self buildButtonsFromCommands.
	^ result! !

!SVNProjectBrowser methodsFor: 'as yet unclassified' stamp: 'rkrk 4/20/2008 15:07'!
close

	super close.
	self beIndependentFromSvnProjects.! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 4/28/2008 00:34'!
commandClasses

	^ { 
		SVNBrowseClassCommand.
		SVNBrowseMethodCommand.
		SVNCreateProjectCommand.
		SVNCommitCommand.
		SVNUpdateCommand.
		SVNUpdateToRevisionCommand.
		SVNRevertCommand.
		SVNSetURLCommand.
		SVNCheckoutCommand.
		SVNDeleteProjectCommand.
		SVNDeleteClassCommand.
		SVNDeleteMethodCommand.
		SVNChooseAndAddClassCommand.
		SVNChooseAndAddMethodCommand
	 }! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 4/12/2008 11:32'!
commands
	
	^ self commandClasses collect: [:ea |
		ea
			on: self selectedNode
			for: self].! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:17'!
commitLogs

	commitLogs ifNil: [^ OrderedCollection new].
	^ commitLogs
! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'mu 3/26/2008 12:42'!
commitLogs: aCollection
	commitLogs := aCollection.
! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'pe 4/14/2008 15:29'!
determineCurrentCommitLog

	"The revisionList only saves strings not full objects.
	This is a workaround..."
	^ self commitLogs
		detect: [:ea | ea revisionAuthorDateString = self selectedCommitLogString asString]
		ifNone: [nil].! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'pe 4/14/2008 15:30'!
displayLogMessage

	| logMessageHeader logMessage |
	logMessageHeader := self displayLogMessageHeader.
	logMessage := self getCommentFor: self determineCurrentCommitLog.
	^ logMessageHeader , logMessage! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'rkrk 4/7/2008 02:23'!
displayLogMessageHeader

	^ 'Log-Message:' asText allBold,
		String cr.
! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 03:13'!
extent

	^ 600 @ 500! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:39'!
getChildrenOfNode: aNode

	^ aNode getChildren! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'mu 3/26/2008 12:53'!
getCommentFor: aCommitLog

	aCommitLog ifNil: [^ 'Select a versioned class or method'].
	^ aCommitLog comment.! !

!SVNProjectBrowser methodsFor: 'as yet unclassified' stamp: 'mu 4/21/2008 11:59'!
getIcon: node
	^ OBMorphicIcons iconNamed: node status! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
getPathToSelectedNode

	| aCollection aNode |
	aNode := self selectedNode.
	aCollection := OrderedCollection new.
	[aNode notNil] whileTrue: [
		aCollection addLast: aNode.
		aNode := aNode parent].
	^ aCollection! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 03:13'!
label

	^ 'SqueakSVN Project Browser'! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
labelOfNode: aNode 

	^ aNode getLabel! !

!SVNProjectBrowser methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 02:02'!
listOfProjectNodes: svnProjects

	self projectNodes: (svnProjects collect: [:each |
		SVNProjectNode
			element: each
			svnEnvironment: self svnEnvironment]).
! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'rkrk 4/25/2008 13:01'!
listRevisionsForSelectedElement

	| svnElement |
	self selectedNode ifNil: [^ #('No SVNElement selected')].
	svnElement := self selectedNode svnElement svnDirectoryEntry.
	svnElement ifNil: [^ #('Select a versioned Class or a vesioned method')]. 
	self commitLogs: svnElement commitLogs.
	self commitLogs ifEmpty: [^ #('No Commit-Logs available')].
	^ self commitLogs collect: [ :each | 
		(self selectedNode svnElement svnInfo revision number = each revision)
			ifTrue:[each revisionAuthorDateString asText allBold]
			ifFalse:[each revisionAuthorDateString]].! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'rkrk 4/12/2008 11:19'!
menuOn: aMenu 
	
	self commands do: [:ea | ea addItemToMenu: aMenu].
	^ aMenu! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
nodeHasChildren: aNode

	^ (self getChildrenOfNode: aNode) notEmpty! !

!SVNProjectBrowser methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:41'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 4/24/2008 12:59'!
projectNodes
	^ projectNodes! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:48'!
projectNodes: anObject
	projectNodes := anObject asOrderedCollection! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:20'!
selectedCommitLogString

	^ selectedCommitLogString! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:21'!
selectedCommitLogString: aString

	selectedCommitLogString := aString.! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'mu 3/18/2008 17:51'!
selectedNode
	^ selectedNode! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 02:27'!
selectedNode: aNode 

	selectedNode := aNode! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'pe 4/14/2008 15:34'!
setSelectedCommitLogString: obj

	"callback for revision list"
	self selectedCommitLogString: obj.
	self updateLogMessageWindow.! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/21/2008 01:59'!
setSelectedNode: aNode 

	"callback for elmentTree"
	self
		selectedNode: aNode;
		updateRevisionList;
		setSelectedCommitLogString: ''.! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/20/2008 15:05'!
svnEnvironment
	^ svnEnvironment! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/20/2008 15:05'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/7/2008 04:03'!
update: anObject

	self updateTree! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/7/2008 03:19'!
updateLogMessageWindow

	self changed: #displayLogMessage.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/25/2008 12:59'!
updateProjectNodes

	self projectNodes
		ifNil: [self listOfProjectNodes: self svnEnvironment svnProjects]
		ifNotNil: [self updateProjectNodesList].
	^ self projectNodes! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/25/2008 12:59'!
updateProjectNodesList

	| copyedSet |
	copyedSet := self svnEnvironment svnProjects copy.
	self projectNodes copy do: [:node |
		(copyedSet includes: node svnElement)
			ifTrue: [copyedSet remove: node svnElement]
			ifFalse: [self projectNodes remove: node]].
	copyedSet do: [:each |
		self projectNodes add: (SVNProjectNode
			element: each
			svnEnvironment: self svnEnvironment)].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'pe 4/14/2008 15:32'!
updateRevisionList

	"call the revision list's '#list: selector"
	self changed: #listRevisionsForSelectedElement.
	self updateLogMessageWindow.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/24/2008 13:15'!
updateTree

	self changed: #updateProjectNodes.
	self changed: #getPathToSelectedNode.! !

!SVNTool methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 11:58'!
allTextMorphs

	"hack for accepting text contents of windows"
	^ self window allMorphs select: [:ea | ea isKindOf: PluggableTextMorph].! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
blueColor
	^ Color blue lighter lighter  ! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 20:41'!
buildMainWindow

	^ self builder pluggableWindowSpec new
		model: self;
		extent: self extent;
		label: self label;
		children: self buildWidgets;
		yourself.! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:34'!
buildWidgets

	^ #()! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 20:41'!
buildWith: aBuilder
"This method is expected by the ToolBuilder. It creates the main widget specification.
Subclasses of SVNTool should create their sub widgets in the #buildWidgets"

	self builder: aBuilder.
	self	window: (self builder build: (self buildMainWindow)).
	^ self window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:20'!
builder

	^ builder ifNil: [builder := ToolBuilder default].! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:36'!
builder: anObject
	builder := anObject! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/6/2008 00:59'!
close

	self builder close: self window.! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:59'!
extent

	^ 300 @ 300! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
grayColor
	^ Color gray  ! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
greenColor

	^ Color green! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:19'!
label

	^ 'I have no label'! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/6/2008 02:20'!
open

	self builder open: self.! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/21/2008 12:38'!
readAllInputs

	self allTextMorphs do: [:ea | ea accept].! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
redColor

	^ Color red! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window
	^ window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window: anObject
	window := anObject! !

Object subclass: #SVNUser
	instanceVariableNames: 'user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNUser class methodsFor: 'instance creating' stamp: 'rt 3/30/2008 20:55'!
user: aString password: aSecString

	^self new
		user: aString password: aSecString! !

!SVNUser methodsFor: 'comparing' stamp: 'rt 3/30/2008 20:58'!
= obj
	^self species = obj species
		and: [self user = obj user]
		and: [self password = obj password]! !

!SVNUser methodsFor: 'comparing' stamp: 'rt 4/21/2008 11:22'!
hash

	^ self user hash bitXor: self password hash! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
password
	^ password! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
password: aSecString
	password := aSecString.! !

!SVNUser methodsFor: 'printing' stamp: 'rt 4/8/2008 14:54'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	aStream nextPutAll: '''', self user , ''', ''' , self password , ''''.
	aStream nextPut: $).! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
user
	^ user! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString
	user := aString.! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString password: aSecString
	self user: aString.
	self password: aSecString.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 15:37'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'test 3/20/2008 04:00'!
callStringTest02

	<primitive: 'stringTest02' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 22:38'!
onlyATest

	<primitive: 'onlyATest' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 14:56'!
primSvnStatus: target revisionKind: revKind revisionNumber: revNum storeInArray: arr

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rt 4/15/2008 19:43'!
primWriteOutText: aString

	<primitive: 'writeToOutputFileText' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

Object subclass: #TestEnvAcs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!TestEnvAcs commentStamp: 'rt 4/14/2008 00:18' prior: 0!
A TestEnvAcs is an accessor to the TestEnvPlg. You can use the TestEnvPlg to create and checkout a subversion repository.!

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 00:36'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 15:41'!
svnCreateRepositoryOn: path

	<primitive: 'svnAdminCreateRepositoryOn' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
added
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'mu 3/31/2008 15:28'!
conflicted

	"do it: [self new conflicted asMorph openInHand]"
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3789677025 4294967295 4292993505 4294967295 3789684735 4292993535 4294967295 4292993535 4293001215 4294967295 4294959615 3791650815 3789677025 4294959585 3791650815 3789677025 3789677025 3791650815 3789677025 3789677025 3791650815 3789677055 4294959585 4293001215 4294967295 4294959615 4292993535 4294967295 4292993535 4294959585 3789677025 3789684735 4294967295 3789677025 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
doesNotUnderstand: selector

	^ self unknown! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:00'!
errorIcon

	"do it: [self new errorIcon asMorph openInHand]"
	^((ColorForm
	extent: 11@18
	depth: 8
	fromArray: #( 6974136 1785358954 1785358848 6994104 3099113656 3099093504 6994104 3099113656 3099113472 1785379000 3099113656 3099093504 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1790490808 3093981802 1785358848 1785379000 1785358954 1785358848)
	offset: 697@527)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
modified
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3941264106 4294967295 4294961898 3942645738 3941269503 4293585642 4294967295 3941264127 4293585642 4294967295 3941264127 3941264106 4294967295 3941264106 3941264106 4294967295 3941264106 3941264106 3942645738 3941264106 3941264106 3941264106 3941264106 4293585642 3942645738 3941264127 4293585642 4294967295 3941264127 4294961898 3942645738 3941269503 4294967295 3941264106 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 19:21'!
normal
	^ (ColorForm 
		extent: 12 @ 12
		depth: 8
		fromArray: #(
				4294967295
				2038004089
				4294967295
				4286151033
				2038004089
				2038038527
				4286151033
				2038004089
				2038004223
				4286151033
				2038004089
				2046786047
				2038004089
				2038004223
				4286151033
				2038004089
				2038038527
				2038004089
				2046820217
				4294967161
				2038004089
				2046820351
				4294932857
				2038004089
				4286185471
				4286151033
				2038004223
				4286151167
				2038004089
				2038004223
				4294932857
				2038004089
				2038038527
				4294967295
				2038004089
				4294967295
			)
		offset: 0 @ 0) colorsFromArray: #(
			#()
			#(0.0 0.0 0.0 )
			#(1.0 1.0 1.0 )
			#(0.5 0.5 0.5 )
			#(1.0 0.0 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 1.0 )
			#(0.0 1.0 1.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 1.0 )
			#(0.125 0.125 0.125 )
			#(0.25 0.25 0.25 )
			#(0.375 0.375 0.375 )
			#(0.625 0.625 0.625 )
			#(0.75 0.75 0.75 )
			#(0.875 0.875 0.875 )
			#(0.031 0.031 0.031 )
			#(0.063 0.063 0.063 )
			#(0.094 0.094 0.094 )
			#(0.156 0.156 0.156 )
			#(0.188 0.188 0.188 )
			#(0.219 0.219 0.219 )
			#(0.282 0.282 0.282 )
			#(0.313 0.313 0.313 )
			#(0.344 0.344 0.344 )
			#(0.407 0.407 0.407 )
			#(0.438 0.438 0.438 )
			#(0.469 0.469 0.469 )
			#(0.531 0.531 0.531 )
			#(0.562 0.562 0.562 )
			#(0.593 0.593 0.593 )
			#(0.656 0.656 0.656 )
			#(0.687 0.687 0.687 )
			#(0.718 0.718 0.718 )
			#(0.781 0.781 0.781 )
			#(0.812 0.812 0.812 )
			#(0.844 0.844 0.844 )
			#(0.906 0.906 0.906 )
			#(0.937 0.937 0.937 )
			#(0.969 0.969 0.969 )
			#(0.0 0.0 0.0 )
			#(0.0 0.199 0.0 )
			#(0.0 0.4 0.0 )
			#(0.0 0.599 0.0 )
			#(0.0 0.8 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 0.199 )
			#(0.0 0.199 0.199 )
			#(0.0 0.4 0.199 )
			#(0.0 0.599 0.199 )
			#(0.0 0.8 0.199 )
			#(0.0 1.0 0.199 )
			#(0.0 0.0 0.4 )
			#(0.0 0.199 0.4 )
			#(0.0 0.4 0.4 )
			#(0.0 0.599 0.4 )
			#(0.0 0.8 0.4 )
			#(0.0 1.0 0.4 )
			#(0.0 0.0 0.599 )
			#(0.0 0.199 0.599 )
			#(0.0 0.4 0.599 )
			#(0.0 0.599 0.599 )
			#(0.0 0.8 0.599 )
			#(0.0 1.0 0.599 )
			#(0.0 0.0 0.8 )
			#(0.0 0.199 0.8 )
			#(0.0 0.4 0.8 )
			#(0.0 0.599 0.8 )
			#(0.0 0.8 0.8 )
			#(0.0 1.0 0.8 )
			#(0.0 0.0 1.0 )
			#(0.0 0.199 1.0 )
			#(0.0 0.4 1.0 )
			#(0.0 0.599 1.0 )
			#(0.0 0.8 1.0 )
			#(0.0 1.0 1.0 )
			#(0.199 0.0 0.0 )
			#(0.199 0.199 0.0 )
			#(0.199 0.4 0.0 )
			#(0.199 0.599 0.0 )
			#(0.199 0.8 0.0 )
			#(0.199 1.0 0.0 )
			#(0.199 0.0 0.199 )
			#(0.199 0.199 0.199 )
			#(0.199 0.4 0.199 )
			#(0.199 0.599 0.199 )
			#(0.199 0.8 0.199 )
			#(0.199 1.0 0.199 )
			#(0.199 0.0 0.4 )
			#(0.199 0.199 0.4 )
			#(0.199 0.4 0.4 )
			#(0.199 0.599 0.4 )
			#(0.199 0.8 0.4 )
			#(0.199 1.0 0.4 )
			#(0.199 0.0 0.599 )
			#(0.199 0.199 0.599 )
			#(0.199 0.4 0.599 )
			#(0.199 0.599 0.599 )
			#(0.199 0.8 0.599 )
			#(0.199 1.0 0.599 )
			#(0.199 0.0 0.8 )
			#(0.199 0.199 0.8 )
			#(0.199 0.4 0.8 )
			#(0.199 0.599 0.8 )
			#(0.199 0.8 0.8 )
			#(0.199 1.0 0.8 )
			#(0.199 0.0 1.0 )
			#(0.199 0.199 1.0 )
			#(0.199 0.4 1.0 )
			#(0.199 0.599 1.0 )
			#(0.199 0.8 1.0 )
			#(0.199 1.0 1.0 )
			#(0.4 0.0 0.0 )
			#(0.4 0.199 0.0 )
			#(0.4 0.4 0.0 )
			#(0.4 0.599 0.0 )
			#(0.4 0.8 0.0 )
			#(0.4 1.0 0.0 )
			#(0.4 0.0 0.199 )
			#(0.4 0.199 0.199 )
			#(0.4 0.4 0.199 )
			#(0.4 0.599 0.199 )
			#(0.4 0.8 0.199 )
			#(0.4 1.0 0.199 )
			#(0.4 0.0 0.4 )
			#(0.4 0.199 0.4 )
			#(0.4 0.4 0.4 )
			#(0.4 0.599 0.4 )
			#(0.4 0.8 0.4 )
			#(0.4 1.0 0.4 )
			#(0.4 0.0 0.599 )
			#(0.4 0.199 0.599 )
			#(0.4 0.4 0.599 )
			#(0.4 0.599 0.599 )
			#(0.4 0.8 0.599 )
			#(0.4 1.0 0.599 )
			#(0.4 0.0 0.8 )
			#(0.4 0.199 0.8 )
			#(0.4 0.4 0.8 )
			#(0.4 0.599 0.8 )
			#(0.4 0.8 0.8 )
			#(0.4 1.0 0.8 )
			#(0.4 0.0 1.0 )
			#(0.4 0.199 1.0 )
			#(0.4 0.4 1.0 )
			#(0.4 0.599 1.0 )
			#(0.4 0.8 1.0 )
			#(0.4 1.0 1.0 )
			#(0.599 0.0 0.0 )
			#(0.599 0.199 0.0 )
			#(0.599 0.4 0.0 )
			#(0.599 0.599 0.0 )
			#(0.599 0.8 0.0 )
			#(0.599 1.0 0.0 )
			#(0.599 0.0 0.199 )
			#(0.599 0.199 0.199 )
			#(0.599 0.4 0.199 )
			#(0.599 0.599 0.199 )
			#(0.599 0.8 0.199 )
			#(0.599 1.0 0.199 )
			#(0.599 0.0 0.4 )
			#(0.599 0.199 0.4 )
			#(0.599 0.4 0.4 )
			#(0.599 0.599 0.4 )
			#(0.599 0.8 0.4 )
			#(0.599 1.0 0.4 )
			#(0.599 0.0 0.599 )
			#(0.599 0.199 0.599 )
			#(0.599 0.4 0.599 )
			#(0.599 0.599 0.599 )
			#(0.599 0.8 0.599 )
			#(0.599 1.0 0.599 )
			#(0.599 0.0 0.8 )
			#(0.599 0.199 0.8 )
			#(0.599 0.4 0.8 )
			#(0.599 0.599 0.8 )
			#(0.599 0.8 0.8 )
			#(0.599 1.0 0.8 )
			#(0.599 0.0 1.0 )
			#(0.599 0.199 1.0 )
			#(0.599 0.4 1.0 )
			#(0.599 0.599 1.0 )
			#(0.599 0.8 1.0 )
			#(0.599 1.0 1.0 )
			#(0.8 0.0 0.0 )
			#(0.8 0.199 0.0 )
			#(0.8 0.4 0.0 )
			#(0.8 0.599 0.0 )
			#(0.8 0.8 0.0 )
			#(0.8 1.0 0.0 )
			#(0.8 0.0 0.199 )
			#(0.8 0.199 0.199 )
			#(0.8 0.4 0.199 )
			#(0.8 0.599 0.199 )
			#(0.8 0.8 0.199 )
			#(0.8 1.0 0.199 )
			#(0.8 0.0 0.4 )
			#(0.8 0.199 0.4 )
			#(0.8 0.4 0.4 )
			#(0.8 0.599 0.4 )
			#(0.8 0.8 0.4 )
			#(0.8 1.0 0.4 )
			#(0.8 0.0 0.599 )
			#(0.8 0.199 0.599 )
			#(0.8 0.4 0.599 )
			#(0.8 0.599 0.599 )
			#(0.8 0.8 0.599 )
			#(0.8 1.0 0.599 )
			#(0.8 0.0 0.8 )
			#(0.8 0.199 0.8 )
			#(0.8 0.4 0.8 )
			#(0.8 0.599 0.8 )
			#(0.8 0.8 0.8 )
			#(0.8 1.0 0.8 )
			#(0.8 0.0 1.0 )
			#(0.8 0.199 1.0 )
			#(0.8 0.4 1.0 )
			#(0.8 0.599 1.0 )
			#(0.8 0.8 1.0 )
			#(0.8 1.0 1.0 )
			#(1.0 0.0 0.0 )
			#(1.0 0.199 0.0 )
			#(1.0 0.4 0.0 )
			#(1.0 0.599 0.0 )
			#(1.0 0.8 0.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 0.199 )
			#(1.0 0.199 0.199 )
			#(1.0 0.4 0.199 )
			#(1.0 0.599 0.199 )
			#(1.0 0.8 0.199 )
			#(1.0 1.0 0.199 )
			#(1.0 0.0 0.4 )
			#(1.0 0.199 0.4 )
			#(1.0 0.4 0.4 )
			#(1.0 0.599 0.4 )
			#(1.0 0.8 0.4 )
			#(1.0 1.0 0.4 )
			#(1.0 0.0 0.599 )
			#(1.0 0.199 0.599 )
			#(1.0 0.4 0.599 )
			#(1.0 0.599 0.599 )
			#(1.0 0.8 0.599 )
			#(1.0 1.0 0.599 )
			#(1.0 0.0 0.8 )
			#(1.0 0.199 0.8 )
			#(1.0 0.4 0.8 )
			#(1.0 0.599 0.8 )
			#(1.0 0.8 0.8 )
			#(1.0 1.0 0.8 )
			#(1.0 0.0 1.0 )
			#(1.0 0.199 1.0 )
			#(1.0 0.4 1.0 )
			#(1.0 0.599 1.0 )
			#(1.0 0.8 1.0 )
			#(1.0 1.0 1.0 )
		)! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
unknown

	^  self unversioned! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:41'!
unversioned

	^  (Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0)
	offset: 819@706)! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/23/2008 22:48'!
belongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNClass forExistingClass: self theClass).! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:20'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnClassFor: self theClass.! !

OBFilter subclass: #OBSVNStatusIconClassFilter
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:57'!
currentProject
	^currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/9/2008 16:14'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'cop 4/21/2008 16:45'!
icon: aSymbol forNode: aNode 

	self currentProject ifNil: [^ #blank].
	^ (self svnElementFrom: aNode)
		ifNil: [#blank]
		
		ifNotNilDo: [:svnElement | svnElement status].! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 11:11'!
selectedProjectChanged: anAnn
	self currentProject: anAnn currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 16:30'!
subscribeAt: aBrowser
	aBrowser announcer
		observe: SVNCurrentProjectChanged
		send: #selectedProjectChanged:
		to: self! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'rkrk 4/12/2008 22:05'!
svnElementFrom: aNode

	^ self currentProject versionedClasses
		detect: [:ea | ea theName = aNode name]
		ifNone: [nil].! !

OBSVNStatusIconClassFilter subclass: #OBSVNStatusIconMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconMethodFilter methodsFor: 'filtering' stamp: 'cop 4/28/2008 14:57'!
svnElementFrom: aNode

	self doOnlyOnce: [self halt.].
	^ self currentProject allVersionedMethods
		detect: [:ea | ea = aNode svnElement ]
		ifNone: [nil].! !

OBFilter subclass: #SVNOBEnvironmentFilter
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNOBEnvironmentFilter class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 03:52'!
with: svnEnvironment

	^ self new
		svnEnvironment: svnEnvironment;
		yourself.! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 11:03'!
displayString: aString forParent: pNode child: cNode

	self metaNode allChildrenForNode: pNode.
	^ aString asText! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/21/2008 10:56'!
initialize

	super initialize.
	self svnEnvironment: (SVNEnvironment forSvnProjects: Set new).! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment
	^ svnEnvironment! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 02:28'!
wantsButton

	^ true! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 12:02'!
belongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNMethod forExistingMethod: self reference compiledMethod).! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/23/2008 23:41'!
classBelongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNClass forExistingClass: self theClass).! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:51'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnMethodForMethodRef: self reference.! !

OBCmdBrowse subclass: #OBSVNCmdBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!OBSVNCmdBrowse methodsFor: 'as yet unclassified' stamp: 'per 4/24/2008 15:51'!
execute
	(target isKindOf: OBClassCategoryNode) ifTrue:[OBSVNSystemBrowser 
		openOnEnvironment: target container 
		category: target name 
		onSVNEnvironment: requestor browser svnEnvironment].

	(target isKindOf: OBClassNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		onSVNEnvironment: requestor browser svnEnvironment].
	
	(target isKindOf: OBMethodCategoryNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		category: target name
		onSVNEnvironment: requestor browser svnEnvironment].
	
	(target isKindOf: OBMethodNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		selector: target selector
		onSVNEnvironment: requestor browser svnEnvironment].! !

OBSystemBrowser subclass: #OBSVNSystemBrowser
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/9/2008 13:47'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel
	^ (OBSVNMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'per 4/24/2008 13:38'!
cmdBrowse
	^OBCmdBrowse! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 3/6/2008 13:26'!
definitionPanel
	^ OBSVNDefinitionPanel new! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:33'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!OBSVNSystemBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/14/2008 02:30'!
metaNode: metaNode root: rootNode selection: selectedNode panels: panels

	^ (super metaNode: metaNode root: rootNode selection: selectedNode panels: panels)
		registerSVNFilters;
		yourself.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:42'!
onClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBMethodCategoryNode on: aSymbol inClass: aClass).
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:39'!
onClass: aClass onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: aClass asNode.
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:43'!
onClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBMethodNode on: aSelector inClass: aClass).
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:35'!
onEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBClassCategoryNode 
					on: aSymbol 
					inEnvironment: anEnvironment).
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:42'!
openOnClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:40'!
openOnClass: aClass onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:44'!
openOnClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:18'!
openOnEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment
	^ (self onEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/8/2008 19:39'!
panels
	^ super panels asOrderedCollection
		addFirst: SVNOBProjectSelectionPanel new;
		yourself! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:34'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNSystemBrowser'. {self. #open}}.! !

!OBSVNSystemBrowser methodsFor: 'command' stamp: 'per 4/24/2008 13:47'!
cmdBrowse
	^OBSVNCmdBrowse! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'cop 3/6/2008 12:09'!
cmdMultiView
	^ OBSVNCmdMultiView! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'rkrk 4/28/2008 00:34'!
cmdSvn
	^ { 
		SVNCommitCommand.
		SVNUpdateCommand.
		SVNUpdateToRevisionCommand.
		SVNRevertCommand.
		SVNDeleteClassCommand.
		SVNDeleteMethodCommand.
	 } asOrderedCollection
		addAll: SVNAddToCurrentProjectCommand allSubclasses;
		yourself.! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 21:52'!
definitionPanel
	^ self class definitionPanel! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 4/25/2008 15:43'!
newNode: ann

	| class aNode |
	aNode := ann node.
	svnEnvironment currentProject ifNil: [^ self].
	(aNode isKindOf: OBMethodNode)
		ifTrue: [
			class := svnEnvironment findSvnClassFor: aNode theClass.
			(class isNil or: [(svnEnvironment currentProject includes: class) not])
				ifTrue: [svnEnvironment currentProject addMethod: aNode reference compiledMethod]
				ifFalse: [class addMethod: (SVNMethod forExistingMethod: aNode reference compiledMethod)].
			svnEnvironment currentProject
				addClass: aNode theClass;
				store;
				changed.
				self announce: (OBNodeChanged node: aNode).
			^ self].
	(aNode isKindOf: OBClassNode) ifFalse: [^ self].
	class := svnEnvironment findSvnClassFor: aNode theClass.
	class ifNotNil: [^ self].
	svnEnvironment currentProject
		addClass: aNode theClass;
		store;
		changed.
	self announce: (OBNodeChanged node: aNode).! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/11/2008 19:41'!
registerSVNFilters

	self subscribeEdgesRecursivly: self navigationPanel root metaNode edges! !

!OBSVNSystemBrowser methodsFor: 'initializing' stamp: 'rkrk 4/25/2008 15:13'!
setMetaNode: aMetaNode node: aNode

	| filter |
	svnEnvironment := SVNRegistry current createSvnEnvironment.
	"svnEnvironment notifyAboutSystemChanges: true."
	svnEnvironment subscribeWithAnnouncer: self announcer.
	filter := SVNOBEnvironmentFilter with: svnEnvironment.
	aMetaNode svnWithAllChildrenDo: [ :each |
		each addFilter: filter].
	super setMetaNode: aMetaNode node: aNode! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 4/15/2008 06:28'!
subscribe

	super subscribe.
	(self announcer)
		observe: OBNodeCreated
		send: #newNode:
		to: self! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/21/2008 10:39'!
subscribeEdges: aCol
	aCol do: [:each | (each class canPerform: #subscribeAt:)
		ifTrue: [each subscribeAt: self]]! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/17/2008 10:57'!
subscribeEdgesRecursivly: aCol

	aCol do: [:each |
		self subscribeEdgesRecursivly: each metaNode edges.
		self subscribeEdges: each metaNode svnFilters].! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:38'!
svnEnvironment
	self flag: #TODO. "Use accessor sonsistently"
	^ svnEnvironment! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:37'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

PluggableMultiColumnListMorph subclass: #OBSVNBlameMorphWithTable
	instanceVariableNames: 'blame getTextSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:07'!
blame
	^blame! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:07'!
blame: aBool
	blame := aBool! !

!OBSVNBlameMorphWithTable methodsFor: 'functionality' stamp: 'cop 4/3/2008 14:10'!
checkForBlame
	(model getDefinition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^false]
				ifTrue: [^model definition blame ]! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/7/2008 10:59'!
getTextSelector
	^getTextSelector! !

!OBSVNBlameMorphWithTable methodsFor: 'functionality' stamp: 'cop 4/7/2008 10:55'!
tableChangedHandling
	self checkForBlame  ifTrue: [ self listChanged.
								  self show. ]! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/7/2008 10:59'!
textSelector: aSymbol
	getTextSelector := aSymbol! !

!OBSVNBlameMorphWithTable methodsFor: 'updating' stamp: 'cop 4/7/2008 11:06'!
update: aSymbol
	aSymbol == getTextSelector 
	ifTrue: 
		[^self hide].
	aSymbol == getListSelector 
	ifTrue: 
		[^self tableChangedHandling].
	super update: aSymbol.! !

!WindowsProcess methodsFor: '*SqueakSVN' stamp: 'rt 4/27/2008 01:16'!
waitForCommand: aCommandString
	"copied for UnixProcess"
	
	| proc d |
	self flag: #TODO. "sometimes the image stops"
	d := Delay forMilliseconds: 50.
	proc := self command: aCommandString.
	proc ifNil: [self class noAccessorAvailable].
	[proc isComplete] whileFalse: [d wait].
	^ proc
! !

OBTextPanel subclass: #SVNOBProjectSelectionPanel
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:45'!
accept: aText notifying: anObject 

	self currentProject: (self browser svnEnvironment findSvnProjectNamed: aText asString).! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:49'!
announceCurrrentProjectChanged

	self
		announce: (SVNCurrentProjectChanged forProject: self currentProject);
		announce: OBRefreshRequired new.! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'per 4/24/2008 16:28'!
browseCurrentProject: aSVNProject

	| node |
	aSVNProject ifNotNil:
	[browser := SVNProjectBrowser open.
	node := browser projectNodes detect: [:ea | ea svnElement = aSVNProject]
	ifNone:[].
	browser setSelectedNode: node.
	browser updateTree.]
	! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 17:27'!
buildOn: aBuilder 
	^ aBuilder textfield: self with: []! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'cop 4/8/2008 18:02'!
currentProject
	^currentProject! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:50'!
currentProject: aSVNProject

	currentProject := aSVNProject.
	self changed: #text.
	self announceCurrrentProjectChanged! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'per 4/24/2008 16:08'!
menu: aMenu shifted: aBoolean selection: aTextSelection

	aMenu 
		add: self noProjectText
		selector: #currentProject:
		argument: nil.
	self browser svnEnvironment svnProjects isEmpty
		ifFalse: [aMenu addLine].
	self browser svnEnvironment svnProjects do: [:each |
		aMenu
		add: each theName
		selector: #currentProject:
		argument: each].
	aMenu 
		addLine;
		add: 'Browse current project'
		selector: #browseCurrentProject:
		argument: currentProject.	
	
	^aMenu
	! !

!SVNOBProjectSelectionPanel methodsFor: 'text' stamp: 'cop 4/10/2008 12:00'!
noProjectText
	^'No SVNProject selected'! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/8/2008 17:42'!
selection
	^ 1 to: 0! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/10/2008 11:58'!
text
	^(currentProject ifNil: [^self noProjectText]) theName! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 19:44'!
vResizing
	^ #shrinkWrap! !

OBCommand subclass: #OBSVNCmdAddElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 4/10/2008 16:54'!
cluster
	^ #SVN! !

!OBSVNCmdAddElement methodsFor: 'execution' stamp: 'mu 4/3/2008 16:43'!
execute
	
	| projectName project |
	projectName := OBTextRequest
				prompt: 'Please type in the name of an existing SVNProject' 
				template: ''.
				
	"self halt."
	project := SVNProject allInstances
		detect: [:each | each theName = projectName]
		ifNone: [^ self].

	self flag: #TODO. "quick hack for now"
	(target isKindOf: OBClassNode) ifTrue: [project addClass: target theClass].
	(target isKindOf: OBClassCategoryNode) ifTrue: [project addCategory: target name asString].! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:10'!
group
	^ #SVN! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:19'!
icon
	^ #smallOkIcon! !

!OBSVNCmdAddElement methodsFor: 'testing' stamp: 'rkrk 4/12/2008 12:03'!
isActive

	^ ((target isKindOf: OBMethodNode) 
			or: [target isKindOf: OBClassNode] 
			or: [target isKindOf: OBClassCategoryNode])
		and: [requestor isSelected: target]! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:13'!
label
	^ 'add to SVNProject...'! !

!FileDirectory methodsFor: '*SqueakSVN' stamp: 'rkrk 4/21/2008 14:55'!
deleteRecursivelyPlatformIndependent

	| p |
	"You will need the recursiveDelete.bat in a path which OSProcess can reach."
	self exists ifFalse: [^ self].
	SmalltalkImage current platformName =  'Win32'
		ifTrue: [p := ExternalOSProcess command:
			'recursiveDelete.bat "' , self pathName , '"'.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 5) wait]].
	self exists ifTrue: [self recursiveDelete].! !

OBDefinitionPanel subclass: #OBSVNDefinitionPanel
	instanceVariableNames: 'codeTabPanel morph contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNDefinitionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 17:16'!
buildOn: aBuilder
	morph ifNil: [morph := aBuilder panelArea: self with: []].
	^morph! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:08'!
changeToTable
	( (contentMorph isKindOf: OBPluggableTextMorph) or: [contentMorph isKindOf: OBPluggableTextMorphWithShout])
		ifTrue: [ self removeDependent: contentMorph.
				 ^self exchangeContentWith: self createTableMorph. ]! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:32'!
changeToText
	( contentMorph isKindOf: PluggableMultiColumnListMorph )
		ifTrue: [ | tempMorph |
				 tempMorph := self createTextMorph.
				 self exchangeContentWith: tempMorph.
				 self addDependent: tempMorph.
				 tempMorph refreshWorld ]! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'rkrk 4/10/2008 14:51'!
createContentMorph

	^ self createTextMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'rkrk 4/10/2008 14:51'!
createTableMorph

	| tableMorph |
	tableMorph := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: nil
				changeSelected: nil.
	tableMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^tableMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 4/7/2008 15:35'!
createTextMorph
	| textMorph |
	textMorph := self textMorphClass 
				on: self
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:. 
	textMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^textMorph! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 4/7/2008 17:22'!
definition
	^definition! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 11:29'!
definitionChanged: ann
	definition := ann definition.
	self handleDefinition.
	self changed: #text! !

!OBSVNDefinitionPanel methodsFor: 'as yet unclassified' stamp: 'cop 4/8/2008 12:18'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBSVNDefinitionPanel methodsFor: 'model access' stamp: 'cop 4/8/2008 11:43'!
getListSize
	^0! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:10'!
handleDefinition
	(self definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^ self changeToText ]
				ifTrue: [^ self changeToTable ]! !

!OBSVNDefinitionPanel methodsFor: 'testing' stamp: 'rkrk 4/10/2008 14:51'!
hasReferencePanel

    ^ browser class hasReferencePanel! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/8/2008 11:22'!
list
	(self definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^Array new ]
				ifTrue: [^self definition blameArray ]! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
selectionChanged: ann
	self changeToText.
	super selectionChanged: ann.! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 4/8/2008 12:10'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
subscribe
	self announcer 
		observe: OBDefinitionChanged 
		send: #definitionChanged:
		to: self.
	self announcer 
		observe: OBSelectionChanged 
		send: #selectionChanged:
		to: self! !

!OBSVNDefinitionPanel methodsFor: 'configuration' stamp: 'cop 4/8/2008 12:09'!
textMorphClass
	| shoutInstalled |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	^shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].! !
SVNRegistry initialize!
SVNTestDirectoryManager initialize!
SVNCreateRepositoryTool initialize!
SVNProjectBrowser initialize!
OBSVNSystemBrowser initialize!
